<?php
/*
* Copyright (C) 1999-2000 EKILAT LLC (http://ekilat.com - the first reactor)
* 
* php(REACTOR) is open source; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License <http://www.opensource.org/licenses/gpl-license.html>
* for a complete version of the license.
*
** 				./conf/bbs.conf.php
* configuration for the bbs system.   
*/

// tell everyone we're already loaded
define("REACTOR_CONF_BBS", 1);

//what directory are the icons for the forums stored in
$icondir = $reactorcore."/img/";//relative to document root, include trailing /

//what HTML tags will you allow your users to use.
//note: I do not recommend allowing <br> or <p> as newlines are converted to 
//<br> tags in the comments.
$allowedtags = "<b>,<i>,<font>,<img>";

// THE MAXIMUM NUMBER OF RECORDS YOU WANT TO DISPLAY ON ANY PAGE VIEW
//this is already specified in global.inc.php but you can change it here
#$showmax = 14;  // this could be hacke into a user pref

//TURN ON EMAIL REPLIES? - MAKE SURE YOUR BBSMAIL CRONJOB IS SET FIRST
$allowemailreplies = false; //false or true

//ALLOW SEARCHES?  THIS PUTS A MEAN LOAD ON THE DATABASE
$allowsearches = true; //false or true

//how many days until a subforum is not shown (inactive forums disappear)
$daystodie = 31;

//set the default display mode - this could be hacked to a user pref
if(!isset($mode)) $mode = "flat"; //flat, threaded, or ranked

//set the default threshold - no posts with a rank less tha or equal to
// threshhold will be shown
// could be hacked into a user pref
$threshold = -2;

//SET YOUR LANGUAGE VALUES.
$bbslang = array(
"last_post" => array( "english" => "last&nbsp;post", "default" => "ltimo&nbsp;mensaje"),
"today_active_topics" => array( "english" => "today's active topics", "default" => "temas activos de hoy"),
"total" => array( "english" => "total", "default" => "total"),
"new" => array( "english" => "new", "default" => "nuevo"),
"prev_forums" => array( "english" => "prev forums", "default" => "foros anteriores"),
"more_forums" => array( "english" => "more forums", "default" => "ms foros"),
"last_visit" => array( "english" => "last visit", "default" => "ltima visita"),
"signup" => array( "english" => "signup", "default" => "apuntarse"),
"lost_password" => array( "english" => "lost password", "default" => "contrasea perdida"),
"comments" => array( "english" => "comments", "default" => "comentarios"),
"prev_clubs" => array( "english" => "prev clubs", "default" => "clubs anteriores"),
"more_clubs" => array( "english" => "more clubs", "default" => "ms clubs"),
"flat_view" => array( "english" => "flat view", "default" => "vista plana"),
"threaded_view" => array( "english" => "threaded view", "default" => "vista con hilos"),
"ranked_view" => array( "english" => "ranked view", "default" => "vista por puntuaciones"),
"request_forum" => array( "english" => "request a new forum", "default" => "pedir un nuevo foro"),
"post_topic" => array( "english" => "post new topic", "default" => "poner un tema nuevo"),
"topics" => array( "english" => "topics",  "default" => "temas"),
"prev_topics" => array( "english" => "previous topics", "default" => "temas anteriores"), 
"other_forums" => array( "english" => "other forums", "default" => "otros foros"), 
"next_topics" => array( "english" => "next topics", "default" => "temas siguientes"), 
"rank" => array( "english" => "rank", "default" => "puntos"), 
"reply_to_post" => array( "english" => "reply to this post", "default" => "responder a este mensaje"), 
"about" => array( "english" => "about", "default" => "acerca de"), 
"rank_up" => array( "english" => "rank up", "default" => "aadir puntos"), 
"rank_down" => array( "english" => "rank down", "default" => "quitar puntos"), 
"edit_delete" => array( "english" => "edit / delete", "default" => "editar / borrar"), 
"closed" => array( "english" => "closed", "default" => "cerrado"), 
"previous_comments" => array( "english" => "previous comments", "default" => "comentario anterior"), 
"start" => array( "english" => "start", "default" => "principio"), 
"other_topics" => array( "english" => "other topics", "default" => "otros temas"), 
"end" => array( "english" => "end", "default" => "fin"), 
"next_comments" => array( "english" => "next comments", "default" => "siguientes comentarios2"),
"reply" => array( "english" => "reply", "default" => "contestar"),
"previous" => array( "english" => "previous", "default" => "anterior"),
"next" => array( "english" => "next", "default" => "siguiente"),
"regarding_topic" => array( "english" => "Regarding your topic at", "default" => "De acuerdo con el mensaje en"),
"double_vote" => array( "english" => "sorry, your IP address has been blocked temporarily.  please try again in a moment.", "default" => "Lo sentimos, su IP esta bloqueada temporalmente. Pruebe pasados unos instantes"),
"close_win" => array( "english" => "close", "default" => "cerrar"), 
"thank_opinion" => array( "english" => "thank you for your opinion", "default" => "gracias por el comentario"), 
"recent_activity" => array( "english" => "recent activity in", "default" => "avtividad reciente en"), 
"search_for" => array( "english" => "search for", "default" => "busqueda de"), 
"search_in" => array( "english" => "in", "default" => "en"), 
"search_all_forums" => array( "english" => "all forums", "default" => "todos los foros"), 
"search" => array( "english" => "search", "default" => "buscar"), 
"search_disabled" => array( "english" => "the search function for our forums has been disabled", "default" => "la funcin de bsqueda en los foros ha sido desactivada") 
);

?>
