<?php
/*
* Copyright (C) 1999-2000 EKILAT LLC (http://ekilat.com - the first reactor)
* 
* php(REACTOR) is open source; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License <http://www.opensource.org/licenses/gpl-license.html>
* for a complete version of the license.
*
** ./inc/cards.inc.php
*/

// tell everyone we're already loaded
define("REACTOR_CONF_CARDS", 1);

//directory where cards are stored
$imgdir = "/img/";
$iframedir = "/iframe/";
$scriptdir = "/script/";
$mididir = "/midi/";

//set the amount of thumbnails you want to display per category
$tablecols = 3;
$tablerows = 2;
//3*2 = 6 :)

//default height and width of cards - this can be customized when each card is created
$cardheight = 265;
$cardwidth = 412;

//midi files
//these should be stored in the /cards/midi/ directory - use descriptive names
#$midis = array("song1.midi", "song2.midi", "song3.midi", "song4.midi");
$midis = false;//to turn off midis

//spacer image (1x1 transparent gif)
$spacer = "/img/spacer.gif";

//SET language values
$cardlang = array(
"select_category" => array( "english" => "select a category", "default" => "seleciona una categoria"),
"select_card" => array( "english" => "choose a $catname card", "default" => "elige una tarjeta de $catname"),
"prev_cat" => array( "english" => "prev categories", "default" => "categorias anteriores),
"prev_cat_cards" => array( "english" => "prev $catname cards", "default" => "tarjetas anteriores de $catname"), 
"other_cat" => array( "english" => "other categories", "default" => "otras categoras"),
"next_cat" => array( "english" => "next categories", "default" => "categoras siguientes"),
"next_cat_cards" => array( "english" => "next $catname cards", "default" => "prximas tarjetas de $catname"),
"new_cards" => array( "english" => "new cards", "default" => "tarjetas nuevas"),
"pop_cards" => array( "english" => "most popular cards", "default" => "tarjetas ms populares"),
"enter_message" => array( "english" => "enter message", "default" => "mensaje:")
);

//SET language values
$createlang = array(
"err_message_length" => array(  "english" => "sorry, your message was longer that 165 characters (trimmed)", "default" => "ops, tu mensaje tiene ms de 165 caracteres (mximo)),
"err_rec_email" => array(  "english" => "sorry, you didn't fill in your friends address", "default" => "no has especificado las direcciones de tus amigos"),
"err_bad_recmail" => array(  "english" => "sorry, $recmail is not a valid email address", "default" => "lo sentimos, $recmail no es una direccin electrnica vlida"),
"err_send_email" => array(  "english" => "sorry, you haven't entered your email address", "default" => "ops, no has introducido tu direccin de correo electrnico"),
"err_bad_sendmail" => array(  "english" => "sorry, $sendmail is not a valid email address", "default" => "lo sentimos, $sendmail no es una direccin vlida"),
"to" => array( "english" => "To", "default" => "a"), 
"from" => array( "english" => "From", "default" => "De"), 
"success" => array( "english" => "it worked", "default" => "ha funcionado"), 
"card_sent" => array( "english" => "your card has been sent", "default" => "la tarjeta ha sido enviada"), 
"card_to_be_sent" => array( "english" => "your card will be sent<br>on", "default" => "tu tarjeta ser enviada<br>en"), 
"thanks_card_url" => array( 
 "english" => "thank you for using $reactorname cards.  you can see this card at" 
, "default" => "gracias por usar las tarjetas de $reactorname, puedes ver la tarjeta en"), 
"send_another" => array( "english" => "send another $reactorname card", "default" => "enviar otra tarjeta de $reactorname"), 
"or" => array( "english" => "or", "default" => "o"), 
"send_again" => array( "english" => "send this card to another friend", "default" => "enviar esta tarjeta a otro amigo"), 
"rec_name" => array( "english" => "friend's name (recipient)", "default" => "nombre del amigo (destinatario)"), 
"send_name" => array( "english" => "my name (sender)", "default" => "mi nombre (remitente)"), 
"rec_email" => array( "english" => "friend's email", "default" => "email del amigo"), 
"send_email" => array( "english" => "my email", "default" => "mi email"), 
"choose_font" => array( "english" => "choose font", "default" => "elige tipo de letra"), 
"choose_color" => array( "english" => "choose a text color", "default" => "elige color del texto"), 
"navy_blue" => array( "english" => "navy blue", "default" => "azul marino"), 
"black" => array( "english" => "black", "default" => "negro"), 
"blue" => array( "english" => "blue", "default" => "azul"), 
"red" => array( "english" => "red", "default" => "rojo"), 
"green" => array( "english" => "green", "default" => "verde"), 
"yellow" => array( "english" => "yellow", "default" => "amarillo"), 
"dark_red" => array( "english" => "dark red", "default" => "rojo oscuro"), 
"grey" => array( "english" => "grey", "default" => "gris"), 
"choose_midi" => array(  "english" => "choose music", "default" => "elige msica"), 
"no_midi" => array(  "english" => "no music", "default" => "sin msica"), 
"notify_me" => array( "english" => "notify me when my friend has read this card", "default" => "avisame cuando mi amigo lea la tarjeta"), 
"preview" => array( "english" => "check my card", "default" => "comprobar mi tarjeta"), 
"again" => array( "english" => "again", "default" => "de nuevo"), 
"now" => array( "english" => "now", "default" => "ahora"), 
"send" => array( "english" => "send this card", "default" => "enviar esta tarjeta"), 
"click_once" => array( "english" => "click once", "default" => "pulsar una vez") 
);


//SET language values
$pickuplang = array(
"to" => array( "english" => "To", "default" => "A"), 
"from" => array( "english" => "From", "default" => "De"), 
"thanks" => array( "english" => "thank you for using $reactorname cards", "default" => "gracias por usar las tarjetas de $reactorname"), 
"see_url" => array( "english" => "you can see this card for approximately 90 days at", "default" => "puedes ver esta tarjeta durante mas o menos unos 90 das en"), 
"choose" => array( "english" => "choose an $reactorname card", "default" => "elige una tarjeta de $reactorname"), 
"or" => array( "english" => "or", "default" => "o"), 
"reply" => array( "english" => "reply to this card", "default" => "contestar al destinatario de esta tarjeta"), 
"favorites" => array( "english" => "save this card in my favorites", "default" => "guardar tarjeta como una de mis favoritas")
);

?>
