<?php
/*
* Copyright (C) 1999-2000 EKILAT LLC (http://ekilat.com - the first reactor)
* 
* php(REACTOR) is open source; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License <http://www.opensource.org/licenses/gpl-license.html>
* for a complete version of the license.
*
**			./conf/users.conf.php
* this file contains all the variables for validating users, showing login
* status, etc.
* SPECIAL: THIRD PARTY WEBMAIL
* we have incorporated a facility for retreiving session information from third
* party webmail services. Basically,
* you can incorporate any third party webmail service which:
* - stores session information in cookies
* - is customizable enough for you to put an <img> tag (which points to your main
*   webserver) into their webmail interface.
* - running a webmail service is not a trivial operation.  people get _VERY_
*   upset when they cannot reach their mail.  that's why we leave this to the
*   third party.
* the webmail login here is defaulted to our service at http://webmail.ekilat.com 
* you'll have to make the necessary changes if you want to use it.
* BEWARE THE PROXY SERVER!
*
* to customize this to incorporate existing users databases, just update the
* respective functions.
*/

// tell everyone we're already loaded
define("REACTOR_CONF_USERS", 1);

//THIS IS THE PRIVATE KEY FOR YOUR LOGIN COOKIES.  CHANGE IT!
//this will expire once a day
//IT DOESN'T MATTER MUCH IF YOUR CHANGE THIS FREQUENTLY
$bbs_private_key = "youbetterchangethis".date($datestringshort, time() + $timeadj);

//THIS IS THE PRIVATE KEY FOR THE USER DB PASSWORDS.  CHANGE IT!!
//ONCE YOU SET THIS, YOU CAN NEVER CHANGE IT AGAIN!!!!
//WRITE IT DOWN IN SEVENTEEN DIFFERENT PLACES ON FIVE DIFFERENT CONTINENTS!!!
$userdb_private_key = "changethisoncethenneveragain";

//THIS IS THE URL TO THE INBOX OF THE THIRD PARTY WEBMAIL
$webmail_inbox = "http://webmail.ekilat.com/email.fcgi?folder=INBOX&passed=go_index";

//the action attribute of the webmail login form
$webmail_action = "http://webmail.ekilat.com/email.fcgi";

//the url to the login page of the third party webmail
$webmail_login = "http://webmail.ekilat.com/email.fcgi?type=english";

//the url to the logout page of the third party webmail
$webmail_logout = "http://webmail.ekilat.com/email.fcgi?folder=INBOX&passed=logout";

//the users table name
$userstable = "users";

//how many posts are needed to be a power user
//should correspond with a level in quickuserstatus()
$powerthreshold = 75;

//SET the language values for the users functions
$userlang = array(
"err_invalid_email" => array( "english" => "sorry, ($email) is not a valid email address", "default" => "lo sentimos, ($email) no es una direccin de correo electrnico vlida"),
"err_password_not_match" => array( "english" => "sorry, the passwords you entered did not match", "default" => "ops, las contraseas que ha especificado no coinciden"),
"err_password_bad_format" => array( "english" => "sorry, your password has to be between 4 and 20 letters or numbers", "default" => "lo sentimos, pero la contrasea debe tener una longitud de entre 4 y 20 letras o nmeros"),
"err_username_bad_format" => array( "english" => "sorry, your username must start with a letter or number, and be between 2 and 20 letters, numbers, dots ( . ), or underscores ( _ )", , "default" => "lo sentimos, pero su nombre de usuario debe empezar con una letra o nmero y tener de 2 a 20 letras, nmeros, puntos (.) o guiones bajos (_)"),
"err_db_problem" => array( "english" => "sorry, we had a problem connecting to our database.  please contact an administrator", "default" => "lo sentimos, pero se ha producido un error al conectar con la base de datos, por favor, contacte urgentemente con nuestro administrador"),
"err_username_taken" => array(  "english" => "sorry, $username has already been taken.  try another one", "default" => "lo sentimos, pero $username ya ha sido tomado, elije otro nombre diferente"),
"err_username_empty" => array(  "english" => "sorry, you haven't entered your nick", "default" => "ops, no has especificado un nick"),
"err_password_empty" => array(  "english" => "sorry, you haven't entered your password", "default" => "ops, no has especificado la contrasea"),
"not_power_user" => array( "english" => "you are not a ".quickuserstatus($powerthreshold, 0)." yet", "default" => "an no tienes status de ".quickuserstatus($powerthreshold, 0)),
"logout" => array( "english" => "logout", "default" => "salida"), 
"not_signed_up" => array( "english" => "don't have one?", "default" => "an no tienes?"),  
"signup" => array( "english" => "signup", "default" => "registrarse"), 
"forgot_password" => array( "english" => "lost password", "default" => "contrasea perdida"), 
"check_email" => array( "english" => "check email", "default" => "mirar email"), 
"comments" => array( "english" => "comments", "default" => "comentarios"), 
"member_since" => array( "english" => "member since", "default" => "miembro desde"), 
"last_post" => array( "english" => "last post", "default" => "ltima publicacin"), 
"change" => array( "english" => "change", "default" => "cambiar") 
);


//SET language values
$proflang = array( 
"click_once" => array( "english" => "click once", "default" => "pulsar una vez"), 
"cancel" => array( "english" => "cancel", "default" => "anular"), 
"err_username_empty" => array(  "english" => "sorry, you haven't entered your nick", "default" => "ops, no has especificado el nick"), 
"err_password_empty" => array(  "english" => "sorry, you haven't entered your password", "default" => "ops, no has especificado la contrasea"), 
"err_invalid_email" => array(  "english" => "sorry, ($email) is not a valid email address", "default" => "lo sentimos, pero ($email) no es una direccin electrnica vlida"),  
"err_long_profile" => array( "english" => "your profile is longer than 255 characters.  (trimmed)", "default" => "tu descripcin es mayor de 255 caracteres (mximo)"), 
"err_unknown_user" => array(  "english" => "sorry, (<i>$username</i>) is not in our database", "default" => "lo sentimos, pero (<i>$username</i>) no est en nuestra base de datos"), 
"err_bad_user_or_pass" => array(  "english" => "sorry, your nick or password is incorrect", "default" => "lo sentimos, o el nick o la contrasea con incorrectos"), 
"edit_profile" => array( "english" => "edit profile", "default" => "edtar descripcin"), 
"success" => array( "english" => "Thanks $username", "default" => "Gracias $username"), 
"profile_updated" => array( "english" => "we have updated your email and profile.", "default" => "hemos actualizado tu email y descripcin"), 
"forgot_password" => array( "english" => "lost password", "default" => "contrasea perdida"), 
"email" => array( "english" => "my email", "default" => "mi email"), 
"profile" => array( "english" => "about me", "default" => "sobre mi"), 
"allowed_tags" => array( "english" => "allowed tags", "default" => "etiquetas permitidas"), 
"profile_help" => array( "english" => "enter a few facts about yourself", "default" => "pon algunas cosas sobre ti"), 
"save" => array( "english" => "save", "default" => "grabar") 
); 


//SET language values 
$forgotlang = array( 
"lost_password" => array( "english" => "forgot password", "default" => "contrasea perdida"), 
"err_no_username" => array(  "english" => "sorry, you didn't fill in your nick", "default" => "ops, no especificastes el nick"), 
"for" => array( "english" => "for", "default" => "para"), 
"forgot_message" => array( "english" => "Thank you for your continued support", "default" => "Gracias por tu inters"), 
"err_unlisted_username" => array(  "english" => "sorry, (<i>$username</i>) is not listed in our database", "default" => "lo sentimos, (<i>username</i>) no est en nuestra base de datos"), 
"click_once" => array( "english" => "click once", "default" => "pulsar una vez"), 
"cancel" => array( "english" => "cancel", "default" => "anular"), 
"case_sensitive" => array( "english" => "remember passwords are case sensitive", "default" => "recuerda que las contraseas discriminan entre maysculas y minsculas"), 
"enter_nick_below" => array(  "english" => "to get your password, enter your nick below", "default" => "para recuperar la contrasea, pon tu nick abajo"),  
"password_to_email" => array( "english" => "your password will be sent to your email address", "default" => "la contrasea ser enviada a tu direccin de correo electrnico"), 
"get_password" => array( "english" => "get password", "default" => "obtener contrasea"), 
"success" => array( "english" => "it worked!", "default" => "perfecto"), 
"password_sent" => array( "english" => "your password has been sent to", "default" => "tu contrasea ha sido enviada a"), 
"close" => array( "english" => "close", "default" => "cerrar") 
); 


//SET language values 
$logoutlang = array( 
"has_logged_out" => array( "english" => "has logged out", "default" => "ha salido del sistema"), 
"home" => array( "english" => "home", "default" => "pgina principal") 
); 


//SET language values
$signlang = array( 
"click_once" => array( "english" => "click once", "default" => "pulsar una vez"), 
"cancel" => array( "english" => "cancel", "default" => "anular"), 
"err_no_agree" => array( "english" => "sorry, you have to agree with $reactorname's terms of use", "default" => "lo sentimos, pero debe aceptar los trminos de $reactorname"), 
"err_long_profile" => array( "english" => "your profile is longer than 255 characters.  (trimmed)", "default" => "tu descripcin es mayor de 255 caracteres (mximo)"), 
"welcome" => array( "english" => "welcome", "default" => "bienvenido"), 
"welcome_message" => array( "english" => "<h2>welcome</h2>we have successfully added $username into our system.  you are now logged in and can partake in the advanced funtionality of our site.<br>\n", "default" => "<h2>bienvenido</h2> hemos aadido $username a la base de datos, ahora mismo estas dentro y puedes tomar parte en las funciones avanzadas del sistema"), 
"continue" => array( "english" => "continue &gt;&gt;", "default" => "continuar &gt;&gt;"), 
"signup" => array( "english" => "signup", "default" => "inscripcin"), 
"back_message" => array( "english" => "back and try again", "default" => "vuelve e intntalo de nuevo"), 
"badpass_message" => array( "english" => "we did not recognize your username and password combination. you must register to post to our system. you can click above to try again, or confirm your password if you <a href=$reactorcore/forgot.php tabindex=200>forgot</a> it.  if you are a new user, use the form below to signup.", , "default" => "no hemos reconocido la combinacin de nombre de usuario y contrasea, debes registrarte para poder publicar, puedes intentarlo de nuevo pulsando abajo o comunicar que las has <a href=$reactorcore/forgot.php tabindex=200>olvidado</a>. Si eres un nuevo usuario debers inscribirte en el formulario de abajo" ), 
"choose" => array( "english" => "choose a", "default" => "elige un"), 
"again" => array( "english" => "again", "default" => "de nuevo"), 
"email" => array( "english" => "my email", "default" => "mi email"), 
"profile" => array( "english" => "about me", "default" => "sobre mi"), 
"allowed_tags" => array( "english" => "allowed tags", "default" => "etiquetas permitidas"), 
"profile_help" => array( "english" => "enter a few facts about yourself", "default" => "pon algunas cosas de ti"), 
"username_help" => array( "english" => "2-20 characters", "default" => "2-20 caracteres"), 
"password_help" => array( "english" => "4-20 characters", "default" => "4-20 caracteres"), 
"agree" => array( "english" => "I agree with $reactorname's <a href=$reactorcore/termsofuse.html>terms of use</a>.", "default" => "Estoy conforme con los <a href=$reactorcore/termsofuse.html>trminos de uso</a> de $reactorcore") 
);

?>
