<?php
/*
* Copyright (C) 1999-2000 EKILAT LLC (http://ekilat.com - the first reactor)
* 
* php(REACTOR) is open source; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License <http://www.opensource.org/licenses/gpl-license.html>
* for a complete version of the license.
*
** 				./conf/bbs.conf.php
* configuration for the bbs system.   
*/

// tell everyone we're already loaded
define("REACTOR_CONF_BBS", 1);

//what directory are the icons for the forums stored in
$icondir = $reactorcore."/img/";//relative to document root, include trailing /

//what HTML tags will you allow your users to use.
//note: I do not recommend allowing <br> or <p> as newlines are converted to 
//<br> tags in the comments.
$allowedtags = "<b>,<i>,<font>,<img>";

// THE MAXIMUM NUMBER OF RECORDS YOU WANT TO DISPLAY ON ANY PAGE VIEW
//this is already specified in global.inc.php but you can change it here
#$showmax = 14;  // this could be hacke into a user pref

//TURN ON EMAIL REPLIES? - MAKE SURE YOUR BBSMAIL CRONJOB IS SET FIRST
$allowemailreplies = false; //false or true

//ALLOW SEARCHES?  THIS PUTS A MEAN LOAD ON THE DATABASE
$allowsearches = true; //false or true

//how many days until a subforum is not shown (inactive forums disappear)
$daystodie = 31;

//set the default display mode - this could be hacked to a user pref
if(!isset($mode)) $mode = "flat"; //flat, threaded, or ranked

//set the default threshold - no posts with a rank less tha or equal to
// threshhold will be shown
// could be hacked into a user pref
$threshold = -2;

//SET YOUR LANGUAGE VALUES
$bbslang = array(
"last_post" => array("default" => "terakhir", "english" => "last&nbsp;post"),
"today_active_topics" => array("default" => "aktivitas hari ini", "english" => "today's active topics"),
"total" => array("default" => "jumlah", "english" => "total"),
"new" => array("default" => "baru", "english" => "new"),
"prev_forums" => array("default" => "forum sebelumnya", "english" => "prev forums"),
"more_forums" => array("default" => "forum berikutnya", "english" => "more forums"),
"last_visit" => array("default" => "kunjungan terakhir", "english" => "last visit"),
"signup" => array("default" => "daftar", "english" => "signup"),
"lost_password" => array("default" => "lupa password", "english" => "lost password"),
"comments" => array("default" => "komentar", "english" => "comments"),
"prev_clubs" => array("default" => "klub sebelumnya", "english" => "prev clubs"),
"more_clubs" => array("default" => "klub berikutnya", "english" => "more clubs"),
"flat_view" => array("default" => "urutan biasa", "english" => "flat view"),
"threaded_view" => array("default" => "urutan lapis", "english" => "threaded view"),
"ranked_view" => array("default" => "urutan nilai", "english" => "ranked view"),
"request_forum" => array("default" => "pasang klub baru", "english" => "request a new forum"),
"post_topic" => array("default" => "pasang $boardname baru", "english" => "post new topic"),
"topics" => array("default" => "topik", "english" => "topics"),
"prev_topics" => array("default" => "$boardname berikutnya", "english" => "previous topics"),
"other_forums" => array("default" => "$boardname lain", "english" => "other forums"),
"next_topics" => array("default" => "$boardname sebelumnya", "english" => "next topics"),
"rank" => array("default" => "nilai", "english" => "rank"),
"reply_to_post" => array("default" => "komentar yang ini", "english" => "reply to this post"),
"about" => array("default" => "tentang", "english" => "about"),
"rank_up" => array("default" => "meningkatkan nilai", "english" => "rank up"),
"rank_down" => array("default" => "menurunkan nilai", "english" => "thumbs down"),
"edit_delete" => array("default" => "edit / delete", "english" => "edit / delete"),
"closed" => array("default" => "ditutup", "english" => "closed"),
"previous_comments" => array("default" => "komentar sebelumnya", "english" => "previous comments"),
"start" => array("default" => "awal", "english" => "start"),
"other_topics" => array("default" => "topik lain", "english" => "other topics"),
"end" => array("default" => "akhir", "english" => "end"),
"next_comments" => array("default" => "komentar berikutnya", "english" => "next comments"),
"reply" => array("default" => "komentar", "english" => "reply"),
"previous" => array("default" => "sebelumnya", "english" => "previous"),
"next" => array("default" => "berikutnya", "english" => "next"),
"regarding_topic" => array("default" => "Mengenai topik anda di", "english" => "Regarding your topic at"),
"double_vote" => array("default" => "maaf, IP anda diblokir untuk sementara, mohon dicoba beberapa saat lagi.", "english" => "sorry, your IP address has been blocked temporarily.  please try again in a moment."),
"close_win" => array("default" => "tutup", "english" => "close"),
"thank_opinion" => array("default" => "terima kasih atas pendapat anda", "english" => "thank you for your opinion"),
"recent_activity" => array("default" => "aktivitas terakhir di", "english" => "recent activity in"),
"search_for" => array("default" => "cari untuk", "english" => "search for"),
"search_in" => array("default" => "di", "english" => "in"),
"search_all_forums" => array("default" => "semua $boardname", "english" => "all forums"),
"search" => array("default" => "cari", "english" => "search"),
"search_disabled" => array("default" => "mesin cari ditidakaktifkan untuk sementara", "english" => "the search function for our forums has been disabled")
);


?>
