<?php
/*
* Copyright (C) 1999-2000 EKILAT LLC (http://ekilat.com - the first reactor)
* 
* php(REACTOR) is open source; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License <http://www.opensource.org/licenses/gpl-license.html>
* for a complete version of the license.
*
** ./inc/cards.inc.php
*/

// tell everyone we're already loaded
define("REACTOR_CONF_CARDS", 1);

//directory where cards are stored
$imgdir = "/img/";
$iframedir = "/iframe/";
$scriptdir = "/script/";
$mididir = "/midi/";

//set the amount of thumbnails you want to display per category
$tablecols = 3;
$tablerows = 3;
//3*2 = 6 :)

//default height and width of cards - this can be customized when each card is created
$cardheight = 265;
$cardwidth = 412;

//midi files
//these should be stored in the /cards/midi/ directory - use descriptive names
#$midis = array("song1.midi", "song2.midi", "song3.midi", "song4.midi");
$midis = false;//to turn off midis

//spacer image (1x1 transparent gif)
$spacer = "/img/spacer.gif";

//SET language values
$cardlang = array(
"select_category" => array("default" => "pilih kategori", "english" => "select a category"),
"select_card" => array("default" => "pilih kartu $catname", "english" => "choose a $catname card"),
"prev_cat" => array("default" => "kategori sebelumnya", "english" => "prev categories"),
"prev_cat_cards" => array("default" => "kartu $catname sebelumya", "english" => "prev $catname cards"),
"other_cat" => array("default" => "kategori lain", "english" => "other categories"),
"next_cat" => array("default" => "kategori berikutnya", "english" => "next categories"),
"next_cat_cards" => array("default" => "kartu $catname berikutnya", "english" => "next $catname cards"),
"new_cards" => array("default" => "kartu terbaru", "english" => "new cards"),
"pop_cards" => array("default" => "kartu popular", "english" => "most popular cards"),
"enter_message" => array("default" => "ketik pesan", "english" => "enter message")
);

//SET language values
$createlang = array(
"err_message_length" => array("default" => "maaf, pesan anda lebih dari 165 huruf (dipotong)", "english" => "sorry, your message was longer that 165 characters (trimmed)"),
"err_rec_email" => array("default" => "maaf, alamat email teman belum diisi", "english" => "sorry, you didn't fill in your friends address"),
"err_bad_recmail" => array("default" => "maaf, $recmail bukan alamat email yang benar", "english" => "sorry, $recmail is not a valid email address"),
"err_send_email" => array("default" => "maaf, alamat email saya belum diisi", "english" => "sorry, you haven't entered your email address"),
"err_bad_sendmail" => array("default" => "maaf, $sendmail bukan alamat email yang benar", "english" => "sorry, $sendmail is not a valid email address"),
"to" => array("default" => "Kepada", "english" => "To"),
"from" => array("default" => "Dari", "english" => "From"),
"success" => array("default" => "sukses", "english" => "it worked"),
"card_sent" => array("default" => "kartu anda sudah dikirim", "english" => "your card has been sent"),
"card_to_be_sent" => array("default" => "kartu anda akan dikirim<br>pada tanggal", "english" => "your card will be sent<br>on"),
"thanks_card_url" => array(
	"default" => "terima kasih untuk menggunakan kartu $reactorname.  anda bisa melihat kartu ini di", 
	"english" => "thank you for using $reactorname cards.  you can see this card at"
	),
"send_another" => array("default" => "kirim kartu $reactorname lain", "english" => "send another $reactorname card"),
"or" => array("default" => "atau", "english" => "or"),
"send_again" => array("default" => "kirim kartu ini ke teman lain", "english" => "send this card to another friend"),
"rec_name" => array("default" => "nama teman (penerima)", "english" => "friend's name (recipient)"),
"send_name" => array("default" => "nama saya (pengirim)", "english" => "my name (sender)"),
"rec_email" => array("default" => "alamat email teman", "english" => "friend's email"),
"send_email" => array("default" => "alamat email saya", "english" => "my email"),
"choose_font" => array("default" => "pilih font", "english" => "choose font"),
"choose_color" => array("default" => "pilih warna tulisan", "english" => "choose a text color"),
"navy_blue" => array("default" => "biru tua", "english" => "navy blue"),
"black" => array("default" => "hitam", "english" => "black"),
"blue" => array("default" =>"biru", "english" => "blue"),
"red" => array("default" => "merah", "english" => "red"),
"green" => array("default" => "hijau", "english" => "green"),
"yellow" => array("default" => "kuning", "english" => "yellow"),
"dark_red" => array("default" => "merah tua", "english" => "dark red"),
"grey" => array("default" => "abu-abu", "english" => "grey"),
"choose_midi" => array( "default" => "pilih lagu", "english" => "choose music"),
"no_midi" => array( "default" => "tanpa musik", "english" => "no music"),
"notify_me" => array("default" => "kasihtau saya kalau teman saya sudah buka kartu ini", "english" => "notify me when my friend has read this card"),
"preview" => array("default" => "cek kartu ini", "english" => "check my card"),
"again" => array("default" => "lagi", "english" => "again"),
"now" => array("default" => "sekarang", "english" => "now"),
"send" => array("default" => "kirim kartu ini", "english" => "send this card"),
"click_once" => array("default" => "klik sekali saja", "english" => "click once")
);

//SET language values
$pickuplang = array(
"to" => array("default" => "Kepada", "english" => "To"),
"from" => array("default" => "Dari", "english" => "From"),
"thanks" => array("default" => "terima kasih untuk menggunakan kartu eKilat", "english" => "thank you for using eKilat cards"),
"see_url" => array("default" => "anda bisa melihat kartu ini selama 45 hari di", "english" => "you can see this card for approximately 45 days at"),
"choose" => array("default" => "pilih kartu eKilat", "english" => "choose an eKilat card"),
"or" => array("default" => "atau", "english" => "or"),
"reply" => array("default" => "balas kartu ini", "english" => "reply to this card"),
"favorites" => array("default" => "simpan kartu ini di favorites-ku", "english" => "save this card in my favorites")
);

?>
