<?php
/*
* Copyright (C) 1999-2000 EKILAT LLC (http://ekilat.com - the first reactor)
* 
* php(REACTOR) is open source; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License <http://www.opensource.org/licenses/gpl-license.html>
* for a complete version of the license.
*
** 				./conf/bbs.conf.php
* configuration for the bbs system.   
*/

// tell everyone we're already loaded
define("REACTOR_CONF_BBS", 1);

//what directory are the icons for the forums stored in
$icondir = $reactorcore."/img/";//relative to document root, include trailing /

/*
* WARNING: allowing tags like <img>, <iframe> and other may open your
* site to XSS (Cross Site Scripting) attacks. Only use those tags when
* you have a trusted user base or are running in a closed environment,
* eg. an intranet.
*/
$allowedtags = "<b>,<i>,<font>";

// THE MAXIMUM NUMBER OF RECORDS YOU WANT TO DISPLAY ON ANY PAGE VIEW
//this is already specified in global.inc.php but you can change it here
#$showmax = 14;  // this could be hacke into a user pref

//TURN ON EMAIL REPLIES? - MAKE SURE YOUR BBSMAIL CRONJOB IS SET FIRST
$allowemailreplies = false; //false or true

//ALLOW SEARCHES?  THIS PUTS A MEAN LOAD ON THE DATABASE
$allowsearches = true; //false or true

//how many days until a subforum is not shown (inactive forums disappear)
$daystodie = 31;

//set the default display mode - this could be hacked to a user pref
if(!isset($mode)) $mode = "flat"; //flat, threaded, or ranked

//set the default threshold - no posts with a rank less tha or equal to
// threshhold will be shown
// could be hacked into a user pref
$threshold = -2;

//SET YOUR LANGUAGE VALUES.
$bbslang = array(
"last_post" => array("default" => "last&nbsp;post", "english" => "last&nbsp;post"),
"today_active_topics" => array("default" => "today's active topics", "english" => "today's active topics"),
"total" => array("default" => "total", "english" => "total"),
"new" => array("default" => "new", "english" => "new"),
"prev_forums" => array("default" => "prev forums", "english" => "prev forums"),
"more_forums" => array("default" => "more forums", "english" => "more forums"),
"last_visit" => array("default" => "last visit", "english" => "last visit"),
"signup" => array("default" => "signup", "english" => "signup"),
"lost_password" => array("default" => "lost password", "english" => "lost password"),
"comments" => array("default" => "comments", "english" => "comments"),
"prev_clubs" => array("default" => "prev clubs", "english" => "prev clubs"),
"more_clubs" => array("default" => "more clubs", "english" => "more clubs"),
"flat_view" => array("default" => "flat view", "english" => "flat view"),
"threaded_view" => array("default" => "threaded view", "english" => "threaded view"),
"ranked_view" => array("default" => "ranked view", "english" => "ranked view"),
"request_forum" => array("default" => "request a new forum", "english" => "request a new forum"),
"post_topic" => array("default" => "post new topic", "english" => "post new topic"),
"topics" => array("default" => "topics", "english" => "topics"),
"prev_topics" => array("default" => "previous topics", "english" => "previous topics"),
"other_forums" => array("default" => "other forums", "english" => "other forums"),
"next_topics" => array("default" => "next topics", "english" => "next topics"),
"rank" => array("default" => "rank", "english" => "rank"),
"reply_to_post" => array("default" => "reply to this post", "english" => "reply to this post"),
"about" => array("default" => "about", "english" => "about"),
"rank_up" => array("default" => "rank up", "english" => "rank up"),
"rank_down" => array("default" => "rank down", "english" => "rank down"),
"edit_delete" => array("default" => "edit / delete", "english" => "edit / delete"),
"closed" => array("default" => "closed", "english" => "closed"),
"previous_comments" => array("default" => "previous comments", "english" => "previous comments"),
"start" => array("default" => "start", "english" => "start"),
"other_topics" => array("default" => "other topics", "english" => "other topics"),
"end" => array("default" => "end", "english" => "end"),
"next_comments" => array("default" => "next comments", "english" => "next comments"),
"reply" => array("default" => "reply", "english" => "reply"),
"previous" => array("default" => "previous", "english" => "previous"),
"next" => array("default" => "next", "english" => "next"),
"regarding_topic" => array("default" => "Regarding your topic at", "english" => "Regarding your topic at"),
"double_vote" => array("default" => "sorry, your IP address has been blocked temporarily.  please try again in a moment.", "english" => "sorry, your IP address has been blocked temporarily.  please try again in a moment."),
"close_win" => array("default" => "close", "english" => "close"),
"thank_opinion" => array("default" => "thank you for your opinion", "english" => "thank you for your opinion"),
"recent_activity" => array("default" => "recent activity in", "english" => "recent activity in"),
"search_for" => array("default" => "search for", "english" => "search for"),
"search_in" => array("default" => "in", "english" => "in"),
"search_all_forums" => array("default" => "all forums", "english" => "all forums"),
"search" => array("default" => "search", "english" => "search"),
"search_disabled" => array("default" => "the search function for our forums has been disabled", "english" => "the search function for our forums has been disabled")
);

?>
