<?php
/*
* Copyright (C) 1999-2000 EKILAT LLC (http://ekilat.com - the first reactor)
* 
* php(REACTOR) is open source; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License <http://www.opensource.org/licenses/gpl-license.html>
* for a complete version of the license.
*
** ./inc/cards.inc.php
*/

// tell everyone we're already loaded
define("REACTOR_CONF_CARDS", 1);

//directory where cards are stored
$imgdir = "/img/";
$iframedir = "/iframe/";
$scriptdir = "/script/";
$mididir = "/midi/";

//set the amount of thumbnails you want to display per category
$tablecols = 3;
$tablerows = 2;
//3*2 = 6 :)

//default height and width of cards - this can be customized when each card is created
$cardheight = 265;
$cardwidth = 412;

//midi files
//these should be stored in the /cards/midi/ directory - use descriptive names
#$midis = array("song1.midi", "song2.midi", "song3.midi", "song4.midi");
$midis = false;//to turn off midis

//spacer image (1x1 transparent gif)
$spacer = "/img/spacer.gif";

//SET language values
$cardlang = array(
"select_category" => array("default" => "select a category", "english" => "select a category"),
"select_card" => array("default" => "choose a $catname card", "english" => "choose a $catname card"),
"prev_cat" => array("default" => "prev categories", "english" => "prev categories"),
"prev_cat_cards" => array("default" => "prev $catname cards", "english" => "prev $catname cards"),
"other_cat" => array("default" => "other categories", "english" => "other categories"),
"next_cat" => array("default" => "next categories", "english" => "next categories"),
"next_cat_cards" => array("default" => "next $catname cards", "english" => "next $catname cards"),
"new_cards" => array("default" => "new cards", "english" => "new cards"),
"pop_cards" => array("default" => "most popular cards", "english" => "most popular cards"),
"enter_message" => array("default" => "enter message", "english" => "enter message")
);

//SET language values
$createlang = array(
"err_message_length" => array("default" => "sorry, your message was longer that 165 characters (trimmed)", "english" => "sorry, your message was longer that 165 characters (trimmed)"),
"err_rec_email" => array("default" => "sorry, you didn't fill in your friends address", "english" => "sorry, you didn't fill in your friends address"),
"err_bad_recmail" => array("default" => "sorry, $recmail is not a valid email address", "english" => "sorry, $recmail is not a valid email address"),
"err_send_email" => array("default" => "sorry, you haven't entered your email address", "english" => "sorry, you haven't entered your email address"),
"err_bad_sendmail" => array("default" => "sorry, $sendmail is not a valid email address", "english" => "sorry, $sendmail is not a valid email address"),
"to" => array("default" => "To", "english" => "To"),
"from" => array("default" => "From", "english" => "From"),
"success" => array("default" => "it worked", "english" => "it worked"),
"card_sent" => array("default" => "your card has been sent", "english" => "your card has been sent"),
"card_to_be_sent" => array("default" => "your card will be sent<br>on", "english" => "your card will be sent<br>on"),
"thanks_card_url" => array(
"default" => "thank you for using $reactorname cards.  you can see this card at", 
"english" => "thank you for using $reactorname cards.  you can see this card at"
),
"send_another" => array("default" => "send another $reactorname card", "english" => "send another $reactorname card"),
"or" => array("default" => "or", "english" => "or"),
"send_again" => array("default" => "send this card to another friend", "english" => "send this card to another friend"),
"rec_name" => array("default" => "friend's name (recipient)", "english" => "friend's name (recipient)"),
"send_name" => array("default" => "my name (sender)", "english" => "my name (sender)"),
"rec_email" => array("default" => "friend's email", "english" => "friend's email"),
"send_email" => array("default" => "my email", "english" => "my email"),
"choose_font" => array("default" => "choose font", "english" => "choose font"),
"choose_color" => array("default" => "choose a text color", "english" => "choose a text color"),
"navy_blue" => array("default" => "navy blue", "english" => "navy blue"),
"black" => array("default" => "black", "english" => "black"),
"blue" => array("default" =>"blue", "english" => "blue"),
"red" => array("default" => "red", "english" => "red"),
"green" => array("default" => "green", "english" => "green"),
"yellow" => array("default" => "yellow", "english" => "yellow"),
"dark_red" => array("default" => "dark red", "english" => "dark red"),
"grey" => array("default" => "grey", "english" => "grey"),
"choose_midi" => array( "default" => "choose music", "english" => "choose music"),
"no_midi" => array( "default" => "no music", "english" => "no music"),
"notify_me" => array("default" => "notify me when my friend has read this card", "english" => "notify me when my friend has read this card"),
"preview" => array("default" => "check my card", "english" => "check my card"),
"again" => array("default" => "again", "english" => "again"),
"now" => array("default" => "now", "english" => "now"),
"send" => array("default" => "send this card", "english" => "send this card"),
"click_once" => array("default" => "click once", "english" => "click once")
);


//SET language values
$pickuplang = array(
"to" => array("default" => "To", "english" => "To"),
"from" => array("default" => "From", "english" => "From"),
"thanks" => array("default" => "thank you for using $reactorname cards", "english" => "thank you for using $reactorname cards"),
"see_url" => array("default" => "you can see this card for approximately 90 days at", "english" => "you can see this card for approximately 90 days at"),
"choose" => array("default" => "choose an $reactorname card", "english" => "choose an $reactorname card"),
"or" => array("default" => "or", "english" => "or"),
"reply" => array("default" => "reply to this card", "english" => "reply to this card"),
"favorites" => array("default" => "save this card in my favorites", "english" => "save this card in my favorites")
);

?>
