<?php
/*
* Copyright (C) 1999-2000 EKILAT LLC (http://ekilat.com - the first reactor)
* 
* php(REACTOR) is open source; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License <http://www.opensource.org/licenses/gpl-license.html>
* for a complete version of the license.
*
**			./conf/users.conf.php
* this file contains all the variables for validating users, showing login
* status, etc.
* SPECIAL: THIRD PARTY WEBMAIL
* we have incorporated a facility for retreiving session information from third
* party webmail services. Basically,
* you can incorporate any third party webmail service which:
* - stores session information in cookies
* - is customizable enough for you to put an <img> tag (which points to your main
*   webserver) into their webmail interface.
* - running a webmail service is not a trivial operation.  people get _VERY_
*   upset when they cannot reach their mail.  that's why we leave this to the
*   third party.
* the webmail login here is defaulted to our service at http://webmail.ekilat.com 
* you'll have to make the necessary changes if you want to use it.
* BEWARE THE PROXY SERVER!
*
* to customize this to incorporate existing users databases, just update the
* respective functions.
*/

// tell everyone we're already loaded
define("REACTOR_CONF_USERS", 1);

//THIS IS THE PRIVATE KEY FOR YOUR LOGIN COOKIES.  CHANGE IT!
//this will expire once a day
//IT DOESN'T MATTER MUCH IF YOUR CHANGE THIS FREQUENTLY
$bbs_private_key = "youbetterchangethis".date($datestringshort, time() + $timeadj);

//THIS IS THE PRIVATE KEY FOR THE USER DB PASSWORDS.  CHANGE IT!!
//ONCE YOU SET THIS, YOU CAN NEVER CHANGE IT AGAIN!!!!
//WRITE IT DOWN IN SEVENTEEN DIFFERENT PLACES ON FIVE DIFFERENT CONTINENTS!!!
$userdb_private_key = "changethisoncethenneveragain";

//THIS IS THE URL TO THE INBOX OF THE THIRD PARTY WEBMAIL
$webmail_inbox = "http://webmail.ekilat.com/email.fcgi?folder=INBOX&passed=go_index";

//the action attribute of the webmail login form
$webmail_action = "http://webmail.ekilat.com/email.fcgi";

//the url to the login page of the third party webmail
$webmail_login = "http://webmail.ekilat.com/email.fcgi?type=english";

//the url to the logout page of the third party webmail
$webmail_logout = "http://webmail.ekilat.com/email.fcgi?folder=INBOX&passed=logout";

//the users table name
$userstable = "users";

//how many posts are needed to be a power user
//should correspond with a level in quickuserstatus()
$powerthreshold = 75;

//SET the language values for the users functions
$userlang = array(
"err_invalid_email" => array("default" => "sorry, ($email) is not a valid email address", "english" => "sorry, ($email) is not a valid email address"),
"err_password_not_match" => array("default" => "sorry, the passwords you entered did not match", "english" => "sorry, the passwords you entered did not match"),
"err_password_bad_format" => array("default" => "sorry, your password has to be between 4 and 20 letters or numbers", "english" => "sorry, your password has to be between 4 and 20 letters or numbers"),
"err_username_bad_format" => array("default" => "sorry, your username must start with a letter or number, and be between 2 and 20 letters, numbers, dots ( . ), or underscores ( _ )", "english" => "sorry, your username must start with a letter or number, and be between 2 and 20 letters, numbers, dots ( . ), or underscores ( _ )"),
"err_db_problem" => array("default" => "sorry, we had a problem connecting to our database.  please contact an administrator", "english" => "sorry, we had a problem connecting to our database.  please contact an administrator"),
"err_username_taken" => array("default" => "sorry, $username has already been taken.  try another one", "english" => "sorry, $username has already been taken.  try another one"),
"err_username_empty" => array("default" => "sorry, you haven't entered your nick", "english" => "sorry, you haven't entered your nick"),
"err_password_empty" => array("default" => "sorry, you haven't entered your password", "english" => "sorry, you haven't entered your password"),
"not_power_user" => array("default" => "you are not a ".quickuserstatus($powerthreshold, 0)." yet", "english" => "you are not a ".quickuserstatus($powerthreshold, 0)." yet"),
"logout" => array("default" => "logout", "english" => "logout"),
"not_signed_up" => array("default" => "don't have one?", "english" => "don't have one?"),
"signup" => array("default" => "signup", "english" => "signup"),
"forgot_password" => array("default" => "lost password", "english" => "lost password"),
"check_email" => array("default" => "check email", "english" => "check email"),
"comments" => array("default" => "comments", "english" => "comments"),
"member_since" => array("default" => "member since", "english" => "member since"),
"last_post" => array("default" => "last post", "english" => "last post"),
"change" => array("default" => "change", "english" => "change")
);


//SET language values
$proflang = array(
"click_once" => array("default" => "click once", "english" => "click once"),
"cancel" => array("default" => "cancel", "english" => "cancel"),
"err_username_empty" => array("default" => "sorry, you haven't entered your nick", "english" => "sorry, you haven't entered your nick"),
"err_password_empty" => array("default" => "sorry, you haven't entered your password", "english" => "sorry, you haven't entered your password"),
"err_invalid_email" => array("default" => "sorry, ($email) is not a valid email address", "english" => "sorry, ($email) is not a valid email address"),
"err_long_profile" => array("default" => "your profile is longer than 255 characters.  (trimmed)", "english" => "your profile is longer than 255 characters.  (trimmed)"),
"err_unknown_user" => array("default" => "sorry, (<i>$username</i>) is not in our database", "english" => "sorry, (<i>$username</i>) is not in our database"),
"err_bad_user_or_pass" => array("default" => "sorry, your nick or password is incorrect", "english" => "sorry, your nick or password is incorrect"),
"edit_profile" => array("default" => "edit profile", "english" => "edit profile"),
"success" => array("default" => "Thanks $username", "english" => "Thanks $username"),
"profile_updated" => array("default" => "we have updated your email and profile.", "english" => "we have updated your email and profile."),
"forgot_password" => array("default" => "lost password", "english" => "lost password"),
"email" => array("default" => "my email", "english" => "my email"),
"profile" => array("default" => "about me", "english" => "about me"),
"allowed_tags" => array("default" => "allowed tags", "english" => "allowed tags"),
"profile_help" => array("default" => "enter a few facts about yourself", "english" => "enter a few facts about yourself"),
"save" => array("default" => "save", "english" => "save")
);


//SET language values
$forgotlang = array(
"lost_password" => array("default" => "forgot password", "english" => "forgot password"),
"err_no_username" => array("default" => "sorry, you didn't fill in your nick", "english" => "sorry, you didn't fill in your nick"),
"for" => array("default" => "for", "english" => "for"),
"forgot_message" => array("default" => "Thank you for your continued support", "english" => "Thank you for your continued support"),
"err_unlisted_username" => array("default" => "sorry, (<i>$username</i>) is not listed in our database", "english" => "sorry, (<i>$username</i>) is not listed in our database"),
"click_once" => array("default" => "click once", "english" => "click once"),
"cancel" => array("default" => "cancel", "english" => "cancel"),
"case_sensitive" => array("default" => "remember passwords are case sensitive", "english" => "remember passwords are case sensitive"),
"enter_nick_below" => array("default" => "to get your password, enter your nick below", "english" => "to get your password, enter your nick below"),
"password_to_email" => array("default" => "your password will be sent to your email address", "english" => "your password will be sent to your email address"),
"get_password" => array("default" => "get password", "english" => "get password"),
"success" => array("default" => "it worked!", "english" => "it worked!"),
"password_sent" => array("default" => "your password has been sent to", "english" => "your password has been sent to"),
"close" => array("default" => "close", "english" => "close")
);


//SET language values
$logoutlang = array(
"has_logged_out" => array("default" => "has logged out", "english" => "has logged out"),
"home" => array("default" => "home", "english" => "home")
);


//SET language values
$signlang = array(
"click_once" => array("default" => "click once", "english" => "click once"),
"cancel" => array("default" => "cancel", "english" => "cancel"),
"err_no_agree" => array("default" => "sorry, you have to agree with $reactorname's terms of use", "english" => "sorry, you have to agree with $reactorname's terms of use"),
"err_long_profile" => array("default" => "your profile is longer than 255 characters.  (trimmed)", "english" => "your profile is longer than 255 characters.  (trimmed)"),
"welcome" => array("default" => "welcome", "english" => "welcome"),
"welcome_message" => array("default" => "<h2>welcome</h2>we have successfully added $username into our system.  you are now logged in and can partake in the advanced funtionality of our site.<br>\n", "english" => "<h2>welcome</h2>we have successfully added $username into our system.  you are now logged in and can partake in the advanced funtionality of our site.<br>\n"),
"continue" => array("default" => "continue &gt;&gt;", "english" => "continue &gt;&gt;"),
"signup" => array("default" => "signup", "english" => "signup"),
"back_message" => array("default" => "back and try again", "english" => "back and try again"),
"badpass_message" => array("default" => "we did not recognize your username and password combination. you must register to post to our system. you can click above to try again, or confirm your password if you <a href=$reactorcore/forgot.php tabindex=200>forgot</a> it.  if you are a new user, use the form below to signup.", "english" => "we did not recognize your username and password combination. you must register to post to our system. you can click above to try again, or confirm your password if you <a href=$reactorcore/forgot.php tabindex=200>forgot</a> it.  if you are a new user, use the form below to signup."),
"choose" => array("default" => "choose a", "english" => "choose a"),
"again" => array("default" => "again", "english" => "again"),
"email" => array("default" => "my email", "english" => "my email"),
"profile" => array("default" => "about me", "english" => "about me"),
"allowed_tags" => array("default" => "allowed tags", "english" => "allowed tags"),
"profile_help" => array("default" => "enter a few facts about yourself", "english" => "enter a few facts about yourself"),
"username_help" => array("default" => "2-20 characters", "english" => "2-20 characters"),
"password_help" => array("default" => "4-20 characters", "english" => "4-20 characters"),
"agree" => array("default" => "I agree with $reactorname's <a href=$reactorcore/termsofuse.html>terms of use</a>.", "english" => "I agree with $reactorname's <a href=$reactorcore/termsofuse.html>terms of use</a>.")
);

?>
