<?php
/*
* Copyright (C) 1999-2000 EKILAT LLC (http://ekilat.com - the first reactor)
* 
* php(REACTOR) is open source; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License <http://www.opensource.org/licenses/gpl-license.html>
* for a complete version of the license.
*
** ./admin/index.php - this file contains basic user functions as well as links
* to other admin modules in the php(REACTOR) system.
*/
//ALWAYS INCLUDE THIS
if(!defined("REACTOR_INC_GLOBAL")) { include("inc/global.inc.php"); }
//INCLUDE DB FUNCTIONS
if(!defined("REACTOR_INC_DB")) { include($pathtohomedir."/inc/db.inc.php"); }
//INCLUDE USERS FUNCTIONS
if(!defined("REACTOR_INC_USERS")) { include($pathtohomedir."/inc/users.inc.php"); }

//first, we'll see if it has already been installed.  this is done by checking
//for the existence of the $userstable table in the database.
$isinstalled = false;
$sql0 = "SHOW TABLES";
if($request0 = users_query($sql0, "r")) {
	//cycle through and see if any tables match the $ftable value
	while ($mytable = request_fetch_row($request0)) {
		if ($userstable == $mytable[0]) {
			$isinstalled = true;
			break;
		}
	}
}

//for initial install only - creates $userstable
if($do_install && !$isinstalled) {
	include($pathtohomedir."/sql/create_userstable.mysql.php");//see if this works
	if($request00 = users_query($sql00, "f")) {
		//all is ok
		$isinstalled = true;
	}
	else $errormessage .= "USERS INSTALL FAILED.  Please check to see if the table $userstable has already been created in your database.<br><br>\n";
}

//if not installed, show warning screen with install button, then exit
if (!$isinstalled) {
	echo "<html><head><title>install $userstable</title>";
	stylepicker();
	echo "</head><body>$errormessage<h2>$userstable install</h2><p><b style=\"color:#ff0000;\">WARNING:</b> we were unable to locate the table $userstable in your database.  If this is NOT your first install, there is a big problem.  Please inspect your database with a utility like phpMyAdmin - do no proceed any further here!!</p><p>If this is your first install, please confirm that you have updated the path information in your include files.  To install your $userstable table, click the button below, then add the users you want one by one.  Be sure to make one of the users an administrator.</p><form action=$PHP_SELF><input type=submit name=do_install value=\"install $userstable\"></form><br><br><br></body></html>";
	exit;
}

if($make_admin && isset($username)) {
	$sql1 = "UPDATE $userstable SET admin=2 WHERE username='".$username."'";
	if ($request1 = users_query($sql1, "w")) {
		$controlstatus = "user $username given ".quickuserstatus(0, 2)." status<br>\n";
	}
	else $errormessage .= "attempt to give user $username ".quickuserstatus(0, 2)." status failed.<br>\n";
	
}

?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">

<html>
<head>
	<title><?php echo $reactorname;?> control center</title>
<?php stylepicker(); ?>
<script type="text/javascript" src="<?php echo $reactorcore; ?>/global.js"></script>
</head>
<body bgcolor="<?php echo $reactorcolor[1];?>">
<h2 align=center><?php echo $reactorname;?> control center</h2>
<div align="center">
<p><b style="color:#ff0000;"><?php echo $errormessage; ?></b></p>
<p><b><?php echo $controlstatus; ?></b></p>
<table border=0 bgcolor=<?php echo $reactorcolor[2];?>>
<tr>
<td>
<form action="<?php echo $PHP_SELF; ?>">
make an <?php echo quickuserstatus(0, 2); ?>:
<input type=text name=username value="<?php echo $username; ?>" size=20 maxlength=20>&nbsp;<input type=submit name=make_admin value="make <?php echo quickuserstatus(0, 2); ?>">
</form>
[<a href=<?php echo $reactorcore; ?>/signup.php <?php echo jpopclick("signup", 400, 434); ?>>add new user</a>]
</td>
</tr>
<tr>
<td>
<?php
//you can add additional admin modules here to show how many new users there are,
//how many cards have been sent, etc.

$sql100 = "SELECT COUNT(*) AS count FROM $userstable";
$request100 = users_query($sql100, "r");
$mytotal = request_fetch_array($request100);
echo "<p>".$mytotal["count"]." registered users</p>";

$lastday = time() - 60*60*24;
$sql101 = "SELECT COUNT(*) AS count FROM $userstable WHERE UNIX_TIMESTAMP(created)>".$lastday;
$request101 = users_query($sql101, "r");
$mytotal = request_fetch_array($request101);
echo "<p>".$mytotal["count"]." new users today</p>";

$lastweek = time() - 60*60*24*7;
$sql102 = "SELECT COUNT(*) AS count FROM $userstable WHERE UNIX_TIMESTAMP(created)>".$lastweek;
$request102 = users_query($sql102, "r");
$mytotal = request_fetch_array($request102);
echo "<p>".$mytotal["count"]." new users this week</p>";

$lastmonth = time() - 60*60*24*31;
$sql103 = "SELECT COUNT(*) AS count FROM $userstable WHERE UNIX_TIMESTAMP(created)>".$lastmonth;
$request103 = users_query($sql103, "r");
$mytotal = request_fetch_array($request103);
echo "<p>".$mytotal["count"]." new users this month</p>";

$sql104 = "SELECT COUNT(*) AS count FROM $userstable WHERE status=0";
$request104 = users_query($sql104, "r");
$mytotal = request_fetch_array($request104);
echo "<p>".$mytotal["count"]." suspended users</p>";

?>
</td>
</tr>
</table>
<br><br>
<table border=0 cellpadding=10><tr><td align=center valign=top>
<h2 align=center>administration</h2>
<p><a href=<?php echo $reactorcore; ?>/forums/admin/>forums</a></p>
<br>
<p><a href=<?php echo $reactorcore; ?>/cmsadmin/>cms</a></p>
<br>
<p><a href=<?php echo $reactorcore; ?>/cards/admin/>cards</a></p>
<br>
<p><a href=<?php echo $reactorcore; ?>/polls/admin/>polls</a></p>
<br>
<p><a href=<?php echo $reactorcore; ?>/articles/admin/>articles</a></p>
<br>
<p><a href=<?php echo $reactorcore; ?>/chat/admin/>chat events</a></p>
<br>
<p><a href=<?php echo $reactorcore; ?>/comments/admin/>comments</a></p>
<br>
</td>
<td align=center valign=top bgcolor=<?php echo $reactorcolor[2];?>>
<h2 align=center>utilities</h2>
<p><a href=<?php echo $reactorcore; ?>/admin/phpMyAdmin/>phpMyAdmin</a></p>
<br>
<p><a href=<?php echo $reactorcore; ?>/admin/file.php>file manager</a></p>
<br>
<p><a href=<?php echo $reactorcore; ?>/admin/phpinfo.php>phpinfo() for *.php</a></p>
<br>
<p><a href=<?php echo $reactorcore; ?>/admin/phpinfo.php3>phpinfo() for *.php3</a></p>
<br>
</td>
<td align=center valign=top>
<h2 align=center>resources</h2>
<p><a href=http://phpreactor.org/>php(Reactor)</a></p>
<br>
<p><a href=http://www.apache.org/>apache</a></p>
<br>
<p><a href=http://www.php.net/>PHP</a></p>
<br>
<p><a href=http://www.mysql.com/>MySQL</a></p>

</td></tr></table>
<br><br>
<p><b><a href=<?php echo $reactorcore; ?>><?php echo $reactorname; ?> online</a></b></p>



</div>
</body>
</html>
