<?php
/*
* Copyright (C) 1999-2000 EKILAT LLC (http://ekilat.com - the first reactor)
* 
* php(REACTOR) is open source; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License <http://www.opensource.org/licenses/gpl-license.html>
* for a complete version of the license.
*
** bbsmail.php
* this script sends all the latest posts out to those people who have requested them.
* it is designed to run as a cron job called with lynx at a specified interval.
* action-
* 1.  query for forums which have been modified within the last interval
* 2.  for each forum quesry the topic which have been created within the past half hour
*	which are comments (i.e. t.tid != r.rid)
* 3.  produce a list of usernames where people have requested replies by mail,
* 	which exludes the original poster.
* 4.  query the userdb for each nick's email address.
* 5.  mail the new comment to each user.
* 
* OUTPUT:  only errors
*/

//check to see that this is running from your webserver only
//UPDATE THIS IP ADDRESS OR IT WILL NOT WORK!!!!
if (getenv("REMOTE_ADDR") != "127.0.0.1") {
	echo "\nunauthorized access from $REMOTE_ADDR\n";
	exit;
}

//ALWAYS INCLUDE THIS
if(!defined("REACTOR_INC_GLOBAL")) { include("inc/global.inc.php"); }
//INCLUDE DB FUNCTIONS
if(!defined("REACTOR_INC_DB")) { include($pathtohomedir."/inc/db.inc.php"); }
//INCLUDE BBS FUNCTIONS
if(!defined("REACTOR_INC_BBS")) { include($pathtohomedir."/inc/bbs.inc.php"); }
//INCLUDE USERS FUNCTIONS
if(!defined("REACTOR_INC_USERS")) { include($pathtohomedir."/inc/users.inc.php"); }

//define globals
$interval = 1800; //make sure this corresponds exactly with the interval of your cron jobs
$lastupdate = time() - $interval;
$errormessage = "";

//SET YOUR BOARDNAME VARIABLE!!
$boardname="forums";
$forumlist=$boardname;

//select last 3 active forums
$sql = "SELECT fmname, fid FROM $forumlist WHERE status=1 AND UNIX_TIMESTAMP(modified)>$lastupdate";
if ($request = forumquery($sql,"r")) {
	while ($myforum = request_fetch_array($request)) {
		$ftable = $forumlist."topics".$myforum["fid"];
		//select all pasts which have been created within past half hour
		$sql2 = "SELECT tid, pid, rid, subject, body, username, user_addr, created FROM $ftable  WHERE status=1 AND UNIX_TIMESTAMP(created)>$lastupdate";
		if ($request2 = forumquery($sql2,"r")) {
			while ($newtopic = request_fetch_array($request2)) {
				//format the posting
				$body = revertpost(str_replace($editcore, "", $newtopic["body"]));
				$body = strip_tags($body);
				$body = str_replace("&lt;", "<", $body);
				$body = str_replace("&gt;", ">", $body);
				$body = str_replace("&quot;", '"', $body);
				//get the email address of the poster
				$sql4 = "SELECT email FROM $userstable WHERE username='".$newtopic["username"]."'";
				if ($request4 = users_query($sql4,"r")) {
					$sender = request_fetch_array($request4);
				}
				//select all who have requested email replies and who posted earlier than this post
				$sql3 = "SELECT DISTINCT username FROM $ftable WHERE mailreply=1 AND status=1 AND rid=".$newtopic["rid"]." AND username!='".$newtopic["username"]."' AND created<".$newtopic["created"];
				if ($request3 = forumquery($sql3,"r")) {
					while ($mailme = request_fetch_array($request3)) {
						//now for each user query their email address and send the new topic.
						#echo "<br><br><br>\n\n\nTo:  ".$mailme["username"];
						#echo "<br>\nParent: ".$parent["username"];
						#echo "<br>\nFrom: ".$newtopic["username"];
						#echo "<br>\nSubject: ".$newtopic["subject"];
						#echo "<br>\nuser_addr: ".$newtopic["user_addr"];
						#echo "<br>\nBody: ".$newtopic["body"];
						mailuser($mailme["username"], $newtopic["username"], $sender["email"], $newtopic["subject"], $body, $newtopic["user_addr"], $myforum["fid"], $newtopic["rid"]);
					}
				}
			}
		}
	}
}

// NOW DO IT AGAIN FOR COMMENTS

//SET YOUR BOARDNAME VARIABLE!!
$boardname="comments";
$forumlist=$boardname;

//select last 3 active forums
$sql = "SELECT fmname, fid FROM $forumlist WHERE status=1 AND UNIX_TIMESTAMP(modified)>$lastupdate";
if ($request = forumquery($sql,"r")) {
	while ($myforum = request_fetch_array($request)) {
		$ftable = $forumlist."topics".$myforum["fid"];
		//select all pasts which have been created within past half hour
		$sql2 = "SELECT tid, pid, rid, subject, body, username, user_addr, created FROM $ftable  WHERE status=1 AND UNIX_TIMESTAMP(created)>$lastupdate";
		if ($request2 = forumquery($sql2,"r")) {
			while ($newtopic = request_fetch_array($request2)) {
				//format the posting
				$body = revertpost(str_replace($editcore, "", $newtopic["body"]));
				$body = strip_tags($body);
				$body = str_replace("&lt;", "<", $body);
				$body = str_replace("&gt;", ">", $body);
				$body = str_replace("&quot;", '"', $body);
				//get the email address of the poster
				$sql4 = "SELECT email FROM $userstable WHERE username='".$newtopic["username"]."'";
				if ($request4 = users_query($sql4,"r")) {
					$sender = request_fetch_array($request4);
				}
				//select all who have requested email replies and who posted earlier than this post
				$sql3 = "SELECT DISTINCT username FROM $ftable WHERE mailreply=1 AND status=1 AND rid=".$newtopic["rid"]." AND username!='".$newtopic["username"]."' AND created<".$newtopic["created"];
				if ($request3 = forumquery($sql3,"r")) {
					while ($mailme = request_fetch_array($request3)) {
						//now for each user query their email address and send the new topic.
						#echo "<br><br><br>\n\n\nTo:  ".$mailme["username"];
						#echo "<br>\nParent: ".$parent["username"];
						#echo "<br>\nFrom: ".$newtopic["username"];
						#echo "<br>\nSubject: ".$newtopic["subject"];
						#echo "<br>\nuser_addr: ".$newtopic["user_addr"];
						#echo "<br>\nBody: ".$newtopic["body"];
						mailuser($mailme["username"], $newtopic["username"], $sender["email"], $newtopic["subject"], $body, $newtopic["user_addr"], $myforum["fid"], $newtopic["rid"]);
					}
				}
			}
		}
	}
}
echo $errormessage;
?>
