<?php
/*
* Copyright (C) 1999-2000 EKILAT LLC (http://ekilat.com - the first reactor)
* 
* php(REACTOR) is open source; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License <http://www.opensource.org/licenses/gpl-license.html>
* for a complete version of the license.
*
** index.php
* this is the admin program
*/
//ALWAYS INCLUDE THIS
if(!defined("REACTOR_INC_GLOBAL")) { include("inc/global.inc.php"); }
//INCLUDE CARDS FUNCTIONS
if(!defined("REACTOR_INC_CARDS")) { include($pathtohomedir."/inc/cards.inc.php"); }

//RESET the boardname variable for the admin directory /boardname/admin/
//Don't touch this if you don't know what you're doing
$tmp_array = explode("/" , getenv("REQUEST_URI"));
$boardname = $tmp_array[count($tmp_array) - 3];
//define some table names - you can change these, just be consistent.
$cattable = $boardname."categories";
$cardstable = $boardname."cards";
$personaltable = $boardname."personal";

//first, we'll see if it has already been installed.  this is done by checking
//for the existence of the $cattable table in the database.
$catisinstalled = false;
$sql0 = "SHOW TABLES";
if($request0 = cards_query($sql0, "r")) {
	//cycle through and see if any tables match the $ftable value
	while ($mytable = request_fetch_row($request0)) {
		if ($cattable == $mytable[0]) {
			$catisinstalled = true;
			break;
		}
	}
}

//for initial install only - creates $cattable
if($do_install && !$catisinstalled) {
	include($pathtohomedir."/sql/create_cattable.mysql.php");//see if this works
	if($request2008 = cards_query($sql2008, "f")) {
		//all is ok
		$catisinstalled = true;
	}
	else $errormessage .= "CARDS INSTALL FAILED.  Please check to see if the table $cattable has already been created in your database.<br><br>\n";
}

//if not installed, show warning screen with install button, then exit
if (!$catisinstalled) {
	echo "<html><head><title>install $cattable</title>";
	stylepicker();
	echo "</head><body>$errormessage<h2>$cattable install</h2><p><b style=\"color:#ff0000;\">WARNING:</b> we were unable to locate the table $cattable in your database.  If this is NOT your first install, there is a big problem.  Please inspect your database with a utility like phpMyAdmin - do no proceed any further here!!</p><p>If this is your first install, please confirm that you have updated the path information in your include files.  To install your $cattable table, click the button below.</p><form action=$PHP_SELF><input type=submit name=do_install value=\"install $cattable\"></form><br><br><br></body></html>";
	exit;
}

//first, we'll see if it has already been installed.  this is done by checking
//for the existence of the $cardstable table in the database.
$cardsisinstalled = false;
$sql0 = "SHOW TABLES";
if($request0 = cards_query($sql0, "r")) {
	//cycle through and see if any tables match the $ftable value
	while ($mytable = request_fetch_row($request0)) {
		if ($cardstable == $mytable[0]) {
			$cardsisinstalled = true;
			break;
		}
	}
}

//for initial install only - creates $cardstable
if($do_install && !$cardsisinstalled) {
	include($pathtohomedir."/sql/create_cardstable.mysql.php");//see if this works
	if($request2007 = cards_query($sql2007, "f")) {
		//all is ok
		$cardsisinstalled = true;
	}
	else $errormessage .= "CARDS INSTALL FAILED.  Please check to see if the table $cardstable has already been created in your database.<br><br>\n";
}

//if not installed, show warning screen with install button, then exit
if (!$cardsisinstalled) {
	echo "<html><head><title>install $cardstable</title>";
	stylepicker();
	echo "</head><body>$errormessage<h2>$cardstable install</h2><p><b style=\"color:#ff0000;\">WARNING:</b> we were unable to locate the table $cardstable in your database.  If this is NOT your first install, there is a big problem.  Please inspect your database with a utility like phpMyAdmin - do no proceed any further here!!</p><p>If this is your first install, please confirm that you have updated the path information in your include files.  To install your $cardstable table, click the button below.</p><form action=$PHP_SELF><input type=submit name=do_install value=\"install $cardstable\"></form><br><br><br></body></html>";
	exit;
}

//first, we'll see if it has already been installed.  this is done by checking
//for the existence of the $personaltable table in the database.
$personalisinstalled = false;
$sql0 = "SHOW TABLES";
if($request0 = cards_query($sql0, "r")) {
	//cycle through and see if any tables match the $ftable value
	while ($mytable = request_fetch_row($request0)) {
		if ($personaltable == $mytable[0]) {
			$personalisinstalled = true;
			break;
		}
	}
}

//for initial install only - creates $cardstable
if($do_install && !$personalisinstalled) {
	include($pathtohomedir."/sql/create_personaltable.mysql.php");//see if this works
	if($request2010 = cards_query($sql2010, "f")) {
		//all is ok
		$personalisinstalled = true;
	}
	else $errormessage .= "CARDS INSTALL FAILED.  Please check to see if the table $personaltable has already been created in your database.<br><br>\n";
}

//if not installed, show warning screen with install button, then exit
if (!$personalisinstalled) {
	echo "<html><head><title>install $personaltable</title>";
	stylepicker();
	echo "</head><body>$errormessage<h2>$personaltable install</h2><p><b style=\"color:#ff0000;\">WARNING:</b> we were unable to locate the table $personaltable in your database.  If this is NOT your first install, there is a big problem.  Please inspect your database with a utility like phpMyAdmin - do no proceed any further here!!</p><p>If this is your first install, please confirm that you have updated the path information in your include files.  To install your $personaltable table, click the button below.</p><form action=$PHP_SELF><input type=submit name=do_install value=\"install $personaltable\"></form><br><br><br></body></html>";
	exit;
}

?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">

<html>
<head>
	<title><?php echo $reactorname." ".$boardname; ?> administration</title>
<?php stylepicker(); ?>
</head>
<body>
<div align="center">
<h2><?php echo $reactorname." ".$boardname; ?> administration</h2>
<?php
if ($cards) {//this section deals only with the cards.

	//make an array of categories
	$sql11 = "SELECT name, id FROM $cattable";
	if ($request11 = cards_query($sql11, "r")) {
		while($mycat = request_fetch_array($request11)) {
			$catlist[$mycat["id"]] = $mycat["name"];
		}
	}
	//if save, write to database.
	if ($save) {
		$card_hits = 0;
		$sql = "INSERT INTO $cardstable (id, type, name, image, hits, last, thumb, status, cat, height, width) VALUES (NULL, '$card_type', '$card_name', '$card_image', '$card_hits', NULL, '$card_thumb', $card_status, $card_cat, '$card_height', '$card_width')";
		if ($request = cards_query($sql,"w")) {
			echo "<p><b>the card was saved</b></p><br>";
		}
	}
	//if edit, update record.
	else if ($edit) {
		$sql = "UPDATE $cardstable SET height='$card_height', width='$card_width', type='$card_type', name='$card_name', image='$card_image', thumb='$card_thumb', status=$card_status, cat=$card_cat WHERE id=$card_id";
		if ($request = cards_query($sql, "w")) {
			echo "<p><b>the changes were saved</b></p><br>";
		}

	}
	else if ($delete) {
		$sql = "DELETE FROM $cardstable WHERE id=$card_id";
		if ($request = cards_query($sql,"f")) {
			echo "<p><b>the card was deleted</b></p><br>";
		}
	}

	//print form to add card
	?>
<form action="<?php echo $PHP_SELF;?>">
<input type="hidden" name="start" value="<?php echo $start; ?>">
card name: <input size="25" type="text" name="card_name" value="<?php echo $card_name;?>" maxlength="25"><br>
card url: <input size="60" type="text" name="card_image" value="<?php if($card_image) echo $card_image; else echo $reactorcore."/".$boardname.$imgdir;?>" maxlength="60"><br>
thumbnail url: <input size="60" type="text" name="card_thumb" value="<?php if($card_thumb) echo $card_thumb; else echo $reactorcore."/".$boardname.$imgdir;?>" maxlength="60"><br>
card height: <input size=4 type=text name="card_height" value="<?php if($card_height) echo $card_height; else echo $cardheight;?>" maxlength="4">
card width: <input size=4 type=text name="card_width" value="<?php if($card_width) echo $card_width; else echo $cardwidth;?>" maxlength="4"><br>
status: <input size="1" type="text" name="card_status" value="<?php if(isset($card_status)) echo $card_status; else echo "1";?>"> 1 is on, 0 is off<br>
type:
<select name=card_type>
<option value="img" <?php echo ($card_type == "img")? "selected" : ""; ?>>img</option>
<option value="iframe" <?php echo ($card_type == "iframe")? "selected" : ""; ?>>iframe</option>
<option value="script" <?php echo ($card_type == "script")? "selected" : ""; ?>>script</option>
</select>
category: 
<select name=card_cat>
<?php
reset($catlist);
do {
	$onecat = each($catlist);
?>
<option value=<?php echo $onecat[0]; ?> <?php echo ($card_cat == $onecat[0])? "selected" : ""; ?>><?php echo $onecat[1]; ?></option>
<?php
	prev($catlist);
} while(next($catlist));
?>
</select>
<br><br><br>
<input type="hidden" name="cards" value="1">
<?php
	if ($card_id && !$delete) {
?>
<input type="hidden" name="card_id" value="<?php echo $card_id;?>">
<input type="submit" name="edit" value="save changes to this card">
<input type="submit" name="delete" value="delete this card"></form><br>
<p><b><a href="<?php echo $PHP_SELF."?cards=1"; ?>">add a new card</a></b></p>
<?php
	} else {
?>
<input type="submit" name="save" value="save a new card"></form><br><br><br>
	<?php
	}
	
	if (!$start) $start = 0;
	$end = $start + 10;
	$next = $end + 1;
	$more = 1;

	//list all current cards by po.
	$sql = "SELECT * FROM $cardstable ORDER BY id LIMIT $start, $next";
	$request = cards_query($sql,"r");
	for ($i = 0; $i < $end - $start; $i++ ) {
		$c = request_fetch_array($request);
		if ($c) {
			$editurl = "?cards=1&card_id=".$c["id"]."&card_name=".urlencode($c["name"])."&&card_image=".urlencode($c["image"])."&card_thumb=".urlencode($c["thumb"])."&card_status=".$c["status"]."&card_cat=".$c["cat"]."&start=".($c["id"] - 5);
	
			?>
		
<table style="border:1px solid black" border="0" cellpadding="15" cellspacing="0" bgcolor="<?php echo $c["bgcolor"];?>">
<tr>
<td><?php echo "id: ".$c["id"]." <b>".$c["name"]."</b><br>  cat: ".$catlist[$c["cat"]]."  hits: ".$c["hits"]."  status: ".$c["status"];?>  <br><a href="<?php echo $c["image"];?>"><img border="0" src="<?php echo $c["thumb"];?>"></a>  <br><br><a href="<?php echo $PHP_SELF.$editurl;?>">edit this card</a></td>
</tr>
</table>
<br>
		
			<?php
		} else {
			$more = 1;
		    break;//add this to  other scripts
		}	
		//check for next card
	} 
	
	echo "<br><br><p align=right>";
	if($start > 0) {
		$start = $start - 10;
		if ($start > -1) {
			?>
<a href="<?php echo $PHP_SELF;?>?cards=1&start=<?php echo $start; ?>" target="_top">&lt;&lt;previous 10 cards</a>&nbsp;			
	        <?php
		}
		else {
			$start = 0;
		}
	}
	if ($more == 1) {
		$c = request_fetch_array($request);
		if ($c) {
			?>
<a href="<?php echo $PHP_SELF;?>?cards=1&start=<?php echo $end; ?>" target="_top">&nbsp;next 10 cards&gt;&gt;</a>&nbsp;&nbsp;&nbsp;
			<?php
		}
	}
	echo "</p>";
 
}

else if ($categories) {
	//this section deals only with categories
	//if save, write to database.
	if ($save) {
		$sql = "INSERT INTO $cattable (id, last, status, name, thumb, display)  VALUES (NULL, NULL, '$cat_status', '$cat_name', '$cat_thumb', '$cat_display')";
		if ($request = cards_query($sql, "w")) {
			echo "<p><b>the category was saved</b></p><br>";
		}
	}
	//if edit, update record.
	else if ($edit) {
		$sql = "UPDATE $cattable SET display='$cat_display', name='$cat_name', thumb='$cat_thumb', status=$cat_status WHERE id=$cat_id";
		if ($request = cards_query($sql, "w")) {
			echo "<p><b>the changes were saved</b></p><br>";
		}

	}
	else if ($delete) {
		$sql = "DELETE FROM $cattable WHERE id=$cat_id";
		if ($request = cards_query($sql,"f")) {
			echo "<p><b>the category was deleted</b></p><br>";
		}
	}

	//print form to add card
	?>
<form action="<?php echo $PHP_SELF;?>">
category name: <input size="25" type="text" name="cat_name" value="<?php echo $cat_name;?>" maxlength="25"><br>
thumbnail url: <input size="60" type="text" name="cat_thumb" value="<?php if($cat_thumb) echo $cat_thumb; else echo $reactorcore."/".$boardname.$imgdir;?>" maxlength="60"><br>
display: <input size="1" type="text" name="cat_display" value="<?php if(isset($cat_display)) echo $cat_display; else echo "0";?>"> 1 shows thumb, 0 shows link<br>
status: <input size="1" type="text" name="cat_status" value="<?php if($cat_status) echo $cat_status; else echo "1";?>"> 1 is on, 0 is off<br>
<input type="hidden" name="categories" value="1">
<br><br>
<?php
	if ($cat_id && !$delete) {
?>
<input type="hidden" name="cat_id" value="<?php echo $cat_id;?>">
<input type="submit" name="edit" value="save changes to this category">
<input type="submit" name="delete" value="delete this category"></form><br>
<p><b><a href="<?php echo $PHP_SELF."?categories=1"; ?>">add a new category</a></b></p>
<?php
	} else {
?>
<input type="submit" name="save" value="save new category"></form><br>
	<?php
	}
	//list all current categories.
	$sql = "SELECT * FROM $cattable";
	$request = cards_query($sql,"r");
	while($c = request_fetch_array($request)) {
	$editurl = "?categories=1&cat_id=".$c["id"]."&cat_display=".urlencode($c["display"])."&cat_name=".urlencode($c["name"])."&cat_thumb=".urlencode($c["thumb"])."&cat_status=".$c["status"];
	
		?>
		
<br><br><table style="border:1px solid black" border="0" cellpadding="15" cellspacing="0"><tr><td><?php echo "id: ".$c["id"]." <b>".$c["name"]."</b><br>status: ".$c["status"];?><br>display: <?php echo $c["display"]; ?>   <br><img border="0" src="<?php echo $c["thumb"];?>">  <br><br><a href="<?php echo $PHP_SELF.$editurl;?>">edit this category</a></td></tr></table>
		
		<?php
	}

}
else {
	if($cleanup) {
		$ninetydaysago = time() - 60*60*24*90;
		$sql = "UPDATE $personaltable SET status=0 WHERE UNIX_TIMESTAMP(sent)<$ninetydaysago";
		$request = cards_query($sql, "w");
		echo "<p><b>".get_affected_rows()." cleaned</b></p><br>";
	}
	else if($fullcleanup) {
		$sql = "DELETE FROM $personaltable WHERE status=0";
		$request = cards_query($sql, "w");
		echo "<p><b>".get_affected_rows()." deleted</b></p><br>";
	}

		?>
<form action="<?php echo $PHP_SELF;?>">
<input type="submit" name="cleanup" value="cleanup cards older than 90 days">
<input type="submit" name="fullcleanup" value="delete cleaned cards">
</form><br><br>
		<?php  

		//print basic statistics like total cards sent. select count (*)
		$sql = "SELECT COUNT(*) FROM $personaltable WHERE status=1";
		if ($request = cards_query($sql, "r")) {
			$c = request_fetch_row($request);
			echo $c[0]." active cards<br><br>";
		}
		//cleaned cards
		$sql = "SELECT COUNT(*) FROM $personaltable WHERE status=0";
		if ($request = cards_query($sql, "r")) {
			$c = request_fetch_row($request);
			echo $c[0]." inactive cards<br><br>";
		}
		//count how many cards are seen more than once (notify > 3)
		$sql = "SELECT COUNT(*) FROM $personaltable WHERE notify > 3";
		if ($request = cards_query($sql, "r")) {
			$c = request_fetch_row($request);
			echo $c[0]." cards seen more than once.<br><br>";
		}
		//count how many cards have not been seen (notify < 2)
		$sql = "SELECT COUNT(*) FROM $personaltable WHERE notify < 2";
		if ($request = cards_query($sql, "r")) {
			$c = request_fetch_row($request);
			echo $c[0]." cards not seen yet.<br><br>";
		}
		//count how many cards have not been sent (notify < 0)
		$sql = "SELECT COUNT(*) FROM $personaltable WHERE notify < 0";
		if ($request = cards_query($sql, "r")) {
			$c = request_fetch_row($request);
			echo $c[0]." cards not sent yet.<br><br>";
		}
		//count how many cards were sent in the last week 
		$sql = "SELECT COUNT(*) FROM $personaltable WHERE UNIX_TIMESTAMP(sent)<UNIX_TIMESTAMP(NOW()+0) AND UNIX_TIMESTAMP(sent)>(UNIX_TIMESTAMP(NOW()+0) - 604800)";
		if ($request = cards_query($sql, "r")) {
			$c = request_fetch_row($request);
			echo $c[0]." cards sent in the last week.<br><br>";
		}
		//count how many cards were sent in the last day 
		$sql = "SELECT COUNT(*) FROM $personaltable WHERE UNIX_TIMESTAMP(sent)<UNIX_TIMESTAMP(NOW()+0) AND UNIX_TIMESTAMP(sent)>(UNIX_TIMESTAMP(NOW()+0) - 86400)";
		if ($request = cards_query($sql, "r")) {
			$c = request_fetch_row($request);
			echo $c[0]." cards sent in the last day.<br><br>";
		}
		//The oldest cards and newest active cards.
		$sql = "SELECT MIN(sent) AS min, MAX(sent) AS max FROM $personaltable WHERE status=1";
		if ($request = cards_query($sql, "r")) {
			$c = request_fetch_array($request);
			echo "the oldest active card is ".$c["min"]." and the newest card is ".$c["max"].".<br><br>";
		}
		//The oldest cards and newest inactive cards.
		$sql = "SELECT MIN(sent) AS min, MAX(sent) AS max FROM $personaltable WHERE status=0";
		if ($request = cards_query($sql, "r")) {
			$c = request_fetch_array($request);
			echo "the oldest inactive card is ".$c["min"]." and the newest card is ".$c["max"].".<br><br>";
		}

}

?>
<br><br><br>
<form action="<?php echo $PHP_SELF;?>">
<input type=submit value="current usage stats">
<input type="Submit" name="cards" value="administer cards">  
<input type="submit" name="categories" value="administer categories">
</form>
<br><br>
<p align=center><a href=<?php echo $reactorcore; ?>/<?php echo $boardname; ?>/><?php echo $boardname; ?> online</a>&nbsp;<a href=<?php echo $reactorcore; ?>/admin/>php(REACTOR) control</a></p>

</div>


</body>
</html>
