<?php
/*
* Copyright (C) 1999-2000 EKILAT LLC (http://ekilat.com - the first reactor)
* 
* php(REACTOR) is open source; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License <http://www.opensource.org/licenses/gpl-license.html>
* for a complete version of the license.
*
** ./chat/admin/index.php - this file contains basic user functions as well as links
* to other admin modules in the php(REACTOR) system.
*/
//ALWAYS INCLUDE THIS
if(!defined("REACTOR_INC_GLOBAL")) { include("inc/global.inc.php"); }
//INCLUDE DB FUNCTIONS
if(!defined("REACTOR_INC_DB")) { include($pathtohomedir."/inc/db.inc.php"); }
//INCLUDE USERS FUNCTIONS
if(!defined("REACTOR_INC_USERS")) { include($pathtohomedir."/inc/users.inc.php"); }
//INCLUDE BBS FUNCTIONS
if(!defined("REACTOR_INC_CHAT")) { include($pathtohomedir."/inc/chat.inc.php"); }

//RESET the boardname variable for the admin directory /boardname/admin/
//Don't touch this if you don't know what you're doing
$tmp_array = explode("/" , getenv("REQUEST_URI"));
$boardname = $tmp_array[count($tmp_array) - 3];
//what table are the chat events stored in
$chattable = $boardname;//don't mess with this unless you know what you're doing

//first, we'll see if it has already been installed.  this is done by checking
//for the existence of the $userstable table in the database.
$isinstalled = false;
$sql0 = "SHOW TABLES";
if($request0 = chat_query($sql0, "r")) {
	//cycle through and see if any tables match the $ftable value
	while ($mytable = request_fetch_row($request0)) {
		if ($chattable == $mytable[0]) {
			$isinstalled = true;
			break;
		}
	}
}

//for initial install only - creates $userstable
if($do_install && !$isinstalled) {
	include($pathtohomedir."/sql/create_chattable.mysql.php");//see if this works
	if($request007 = chat_query($sql007, "f")) {
		//all is ok
		$isinstalled = true;
	}
	else $errormessage .= "CHAT INSTALL FAILED.  Please check to see if the table $chattable has already been created in your database.<br><br>\n";
}

//if not installed, show warning screen with install button, then exit
if (!$isinstalled) {
	echo "<html><head><title>install $chattable</title>";
	stylepicker();
	echo "</head><body>$errormessage<h2>$chattable install</h2><p><b style=\"color:#ff0000;\">WARNING:</b> we were unable to locate the table $chattable in your database.  If this is NOT your first install, there is a big problem.  Please inspect your database with a utility like phpMyAdmin - do no proceed any further here!!</p><p>If this is your first install, please confirm that you have updated the path information in your include files.  To install your $chattable table, click the button below.</p><form action=$PHP_SELF><input type=submit name=do_install value=\"install $chattable\"></form><br><br><br></body></html>";
	exit;
}

if($suspend) {
	$sql1 = "UPDATE $chattable SET status=0 WHERE cid=".$suspend;
	if ($request1 = chat_query($sql1, "w")) {
		$controlstatus = "chat event $suspend suspended<br>\n";
	}
	else $errormessage .= "attempt to suspend chat event $suspend failed.<br>\n";
	
}

/*
* showchatevents_admin() queries the chat db for the upcoming events.  
* it displays an option to suspend the events
*/
######## v.1.0.0
function showchatevents_admin() {
global $reactorcore, $datestringlong, $chattable, $showmax, $timeadj, $chatlang, $PHP_SELF;
$mytime = time() + $timeadj - 1800;//the 1800 is to show the events that are happening in this half-hour

	//query upcoming events
	//for all events in the chat db
	$sql = "SELECT subject, username, room, UNIX_TIMESTAMP(wen) AS start, cid, fromboard, boardid FROM $chattable WHERE UNIX_TIMESTAMP(wen)>".$mytime." AND status=1 ORDER BY wen ASC, created ASC LIMIT $showmax";
	if($request = chat_query($sql,"r")) {
		while ($myevent = request_fetch_array($request)) {
			$outputhtml .= "\n<li> <p><b>".$myevent["subject"]."</b></p> - ".date($datestringlong, $myevent["start"])." ".picklang($chatlang["in"])." ".$myevent["room"]." ".picklang($chatlang["with"])." <b>".$myevent["username"]."</b> ";
			if ($myevent["fromboard"]) $outputhtml .= " posted in <a href=$reactorcore/".$myevent["fromboard"]."/".(($myevent["boardid"]) ? "browse.php?fid=".$myevent["boardid"] : "").">".$myevent["fromboard"]."/".(($myevent["boardid"]) ? $myevent["boardid"] : "")."</a> ";
			if ($myevent["start"] < ($mytime + 1800)) $outputhtml .= " <b style=\"color:#ff0000;font-size:medium;\">-@<b style=\"color:#ff0000;font-size:xx-small;\">&gt;</b>@-</b>";
			$outputhtml .= " <a href=$PHP_SELF?suspend=".$myevent["cid"].">suspend</a>";
		}
	}
	return $outputhtml;
}


?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">

<html>
<head>
	<title><?php echo $boardname; ?> control center</title>
<?php stylepicker(); ?>
<script type="text/javascript" src="<?php echo $reactorcore; ?>/global.js"></script>
</head>
<body bgcolor="<?php echo $reactorcolor[1];?>">
<h2 align=center><?php echo $boardname; ?> control center</h2>
<div align="center">
<p><b style=\"color:#ff0000;\"><?php echo $errormessage; ?></b></p>
<p><b><?php echo $controlstatus; ?></b></p>
<table border=0 bgcolor=<?php echo $reactorcolor[2];?>>
<tr>
<td>
<p><b>pending events</b></p>
<ul>
<?php echo showchatevents_admin();?>
</ul>
</td>
</tr>
<tr>
<td align=center>
[<a href=<?php echo $reactorcore; ?>/<?php echo $boardname; ?>/post.php <?php echo jpopclick("chatpost",400,434); ?>>post a chat event</a>]
</td>
</tr>
</table>
<br><br>
<p align=center><a href=<?php echo $reactorcore; ?>/<?php echo $boardname; ?>/><?php echo $boardname; ?> online</a>&nbsp;<a href=<?php echo $reactorcore; ?>/admin/>php(REACTOR) control</a></p>

</div>
</body>
</html>
