<?php
/*
* ./chat/post.php - add new chat events into teh database
*/
//ALWAYS INCLUDE THIS
if(!defined("REACTOR_INC_GLOBAL")) { include("inc/global.inc.php"); }
//check for banned ip.
filterbannedips();
//INCLUDE BBS FUNCTIONS
if(!defined("REACTOR_INC_CHAT")) { include($pathtohomedir."/inc/chat.inc.php"); }
//INCLUDE LANGUAGE FUNCTIONS
if(!defined("REACTOR_INC_LANG")) { include($pathtohomedir."/inc/lang.inc.php"); }
//INCLUDE USERS FUNCTIONS
if(!defined("REACTOR_INC_USERS")) { include($pathtohomedir."/inc/users.inc.php"); }

//validate input
$username = strip_tags($username);
$username = eregi_replace("[^[:alnum:]._]","", $username);
$password = strip_tags($password);
$password = eregi_replace("[^[:alnum:]]","", $password);
$subject = substr(strip_tags($subject), 0, 80);
$daysahead = strip_tags($daysahead);
$timeofday = strip_tags($timeofday);
$room = strip_tags($room);
$boardid = strip_tags($boardid);
$fromboard = strip_tags($fromboard);
$myaction = picklang($chatpostlang["post_event"]);
$returnto = $PHP_SELF."?fromboard=$fromboard&fid=$fid";

if ($upload) {
	//censor
	$subject = censor($subject, $badwords);
	$room = censor($room, $badwords);
	if($subject == "") $errormessage .= picklang($chatpostlang["err_no_subject"])."<br>";
	else if($room == "") $errormessage .= picklang($chatpostlang["err_no_room"])."<br>";
	//validate user
	else {
		//validate user
		$myuser = verifyuser(&$username, &$password, $bbs_login, $bbs_public_key, $returnto);
	}
	if($myuser) {
		if (!$errormessage) {
			//calculate the when factor
			$myyear = date("Y", time() + $timeadj);
			$mymonth = date("m", time() + $timeadj);
			$myday = date("d", time() + $timeadj);
			$unixwhen = mktime(0,0,0,$mymonth,$myday,$myyear) + $daysahead*60*60*24 + $timeofday;
			$when = date("YmdHis", $unixwhen);//make into a mysql timestamp
			//check to see if this is in the future
			if($unixwhen < time() + $timeadj) $errormessage .= picklang($chatpostlang["too_late"])." ".date($datestringlong, $unixwhen)." $timezone <br>\n";
			//insert a new topic
			else if(addchatevent($username, $subject, $room, $when, $fromboard, $boardid)) {
				//log user into the system
				bbs_login($username);
				//display sccess message
				$tpl_title = picklang($chatpostlang["success"]);
				$tpl_message .= picklang($chatpostlang["post_success"]);
				//include simple template
				include($pathtohomedir."/templates/simple.tpl.php");
				exit;

			} 
		}			
	}
}

if (!$upload || $errormessage) {

?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">

<html>
<head>
	<title><?php echo $boardname." : ".$myaction;?></title>
<meta http-equiv="content-type" content="text/html;charset=iso-8859-1">
<?php stylepicker(); ?>
</head>
<body bgcolor="<?php echo $reactorcolor[1];?>">
<center><font color="#ff0000" size="4" face="verdana, arial, sans-serif"><b><?php echo $errormessage; ?></b></font></center>
<hr align="center" color="<?php echo $reactorcolor[0];?>" width="100%" size="2">
<form enctype="application/x-www-form-urlencoded" action="<?php echo $PHP_SELF ;?>" method="post">
<input type=hidden name=boardid value="<?php echo $boardid; ?>">
<input type=hidden name=fromboard value="<?php echo $fromboard; ?>">
<table align=center width=95% bgcolor="<?php echo $reactorcolor[2];?>" cellpadding=2 cellspacing=0>
<?php bbs_login_box($bbs_login, $bbs_public_key); ?>
<tr><td align="right"><p><b><?php echo picklang($chatpostlang["room"]); ?>:</b></p></td><td width="80%">
<select name=room size=1>
<option <?php echo ($room == "") ? "selected" : ""; ?> value="">+- <?php echo picklang($chatpostlang["choose"]); ?> -+</option>
<option <?php echo ($room == "IndoLoca") ? "selected" : ""; ?> value="IndoLoca">IndoLoca</option>
<option <?php echo ($room == "#ekilat") ? "selected" : ""; ?> value="#ekilat">#ekilat</option>
<option <?php echo ($room == "PojokAsmara") ? "selected" : ""; ?> value="PojokAsmara">PojokAsmara</option>
<option <?php echo ($room == "Demo") ? "selected" : ""; ?> value="Demo">Demo</option>
<option <?php echo ($room == "Semanggi") ? "selected" : ""; ?> value="Semanggi">Semanggi</option>
<option <?php echo ($room == "BlokM") ? "selected" : ""; ?> value="BlokM">BlokM</option>
<option <?php echo ($room == "Senayan") ? "selected" : ""; ?> value="Senayan">Senayan</option>
<option <?php echo ($room == "TamanAnggrek") ? "selected" : ""; ?> value="TamanAnggrek">TamanAnggrek</option>
<option <?php echo ($room == "InsideTA") ? "selected" : ""; ?> value="InsideTA">InsideTA</option>
</select>
</td></tr>
<tr><td align="right"><p><b><?php echo picklang($chatpostlang["date"]); ?>:</b></p></td><td width="80%">
<select name="daysahead"><option value="0" <?php if (!$daysahead) echo "selected"; ?>><?php echo picklang($chatpostlang["today"]); ?></option>
<?php
	for($x = 1; $x < 20; $x++) {
?>
<option value="<?php echo $x;?>" <?php if ($daysahead == $x) echo "selected"; ?>><?php echo date($datestringwday, time() + $x*86400 + $timeadj);?></option>
<?php } ?>
</select>
</td></tr>
<tr><td align="right"><p><b><?php echo picklang($chatpostlang["time"]); ?>:</b></p></td><td width="80%">
<select name="timeofday">
<?php
	for($h = 0; $h < 24; $h++) {
		for($m = 0; $m < 60; $m +=30) {
?>
<option value="<?php echo $h*3600 + $m*60;?>" <?php if ($timeofday == $h*3600 + $m*60) echo "selected"; ?>><?php echo ($m<10) ? "$h:0".$m : "$h:".$m;?></option>
<?php }} ?>
</select>
<?php echo $timezone; ?></td></tr>
<tr><td colspan="2"><hr align="center" color="<?php echo $reactorcolor[0];?>" width="100%" size="1"></td></tr>
<tr><td valign="top" colspan="2"><p><b><?php echo picklang($chatpostlang["event"]); ?>:</b></p></td></tr>
<tr><td colspan="2" align="center"><textarea name="subject" cols="35" rows="4" wrap="virtual"><?php echo textarea_prep(stripslashes($subject));?></textarea><br>max 80 char</td></tr>
<tr><td colspan="2"><hr align="center" color="<?php echo $reactorcolor[0];?>" width="100%" size="1"></td></tr>
<tr><td colspan="2" align="center">
<input type="button" value="<?php echo picklang($chatpostlang["cancel"]); ?>" onclick="javascript:window.close();">&nbsp;<input type="submit" name="upload" value="<?php echo picklang($chatpostlang["post"]); ?> &gt;&gt;" style="font-weight:bold;"> (<?php echo picklang($chatpostlang["click_once"]); ?>!)</td></tr>
</table>
</form>
<hr align="center" color="<?php echo $reactorcolor[0];?>" width="100%" size="2">
</body>
</html>
<?php 
} 
?>
