<?php
/*
* Copyright (C) 1999-2000 EKILAT LLC (http://ekilat.com - the first reactor)
* 
* php(REACTOR) is open source; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License <http://www.opensource.org/licenses/gpl-license.html>
* for a complete version of the license.
*
** editprofile.php - this file is used to update user profiles
* uses "w" permissions
* this script ignores any session cookies to prevent inadvertent hacking of
* of a login state.
*/
//ALWAYS INCLUDE THIS
if(!defined("REACTOR_INC_GLOBAL")) { include("inc/global.inc.php"); }
//check for banned ip.
filterbannedips();
//INCLUDE DB FUNCTIONS
if(!defined("REACTOR_INC_DB")) { include($pathtohomedir."/inc/db.inc.php"); }
//INCLUDE LANGUAGE FUNCTIONS
if(!defined("REACTOR_INC_LANG")) { include($pathtohomedir."/inc/lang.inc.php"); }
//INCLUDE USERS FUNCTIONS
if(!defined("REACTOR_INC_USERS")) { include($pathtohomedir."/inc/users.inc.php"); }
//INCLUDE BBS FUNCTIONS
if(!defined("REACTOR_INC_BBS")) { include($pathtohomedir."/inc/bbs.inc.php"); }

$authorized = false;
$username = strtolower(trim(strip_tags($username)));//always lowercase
$password = strip_tags($password);

$bbs_public_key = "";//cancel login -> force authentication

if (!$upload) {
	if (!$username) $errormessage = picklang($proflang["err_username_empty"])."<br>\n";
	else {
		$sql = "SELECT email, profile FROM $userstable WHERE username='".$username."' AND status=1";
		if ($request = users_query($sql,"w")) {
			if($myuser = request_fetch_array($request)) {
				$email = $myuser["email"];
				$profile = $myuser["profile"];
			}
			else $errormessage .= picklang($proflang["err_unknown_user"])."<br>\n";
		}
		else $errormessage .= picklang($proflang["err_unknown_user"])."<br>\n";
	} 
}
if ($upload) {
	//check for nasties
	$password = strip_tags($password);
	$password = eregi_replace("[^[:alnum:]]","", $password);
	$email = strip_tags($email);
	$profile = censor(trim(strip_tags($profile, $allowedtags)),$badwords);
	//authorize user
	$authorized = verifyuser($username, $password, "", "", "");//cancel login -> force authentication
	if (!$authorized) {
		$errormessage .= picklang($proflang["err_bad_user_or_pass"])."<br>\n";
	}
	if(!$email) $errormessage .= picklang($proflang["err_invalid_email"])."<br>\n";
	else if(!emailformat($email)) {
		$errormessage .= picklang($proflang["err_invalid_email"])."<br>\n";
		$email = "";
	}
	if (strlen($profile) > 255) {
		$errormessage .= picklang($proflang["err_long_profile"])."<br>\n";
		$profile = substr($profile, 0, 255);
	}
	if (!$errormessage && $authorized) {
		//insert new user
		$sql2 = "UPDATE $userstable SET email='".$email."', profile='".$profile."' WHERE username='".$username."'";
		if ($request2 = users_query($sql2,"w")) {
			//show success message
			$tpl_title = picklang($proflang["edit_profile"]);
			$tpl_message = "<h2>".picklang($proflang["success"])."</h2><p>".picklang($proflang["profile_updated"])."</p>";
			//include simple template
			include($pathtohomedir."/templates/simple.tpl.php");
			exit;
		} 
	}
}

if ($errormessage || !$upload) {
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">

<html><head><title><?php echo $reactorname; ?> : <?php echo picklang($proflang["edit_profile"]); ?></title>
<meta http-equiv="content-type" content="text/html;charset=iso-8859-1">
<?php stylepicker(); ?>
</head>
<body bgcolor="<?php echo $reactorcolor[1];?>">
<center><font color="#ff0000" size="4" face="verdana, arial, sans-serif"><b><?php echo $errormessage; ?></b></font></center>
<hr align="center" color="<?php echo $reactorcolor[0];?>" width="100%" size="2">
<form enctype="application/x-www-form-urlencoded" action="<?php echo $PHP_SELF;?>" method="post">
<table align=center width=95% bgcolor="<?php echo $reactorcolor[2];?>" cellpadding=2 cellspacing=0>
<?php bbs_login_box($bbs_login, $bbs_public_key); ?>
<tr><td colspan="2"><hr align="center" color="<?php echo $reactorcolor[0];?>" width="100%" size="1"></td></tr>
<tr><td align="right"><p><b><?php echo picklang($proflang["email"]); ?>:</b></p></td><td width="50%"><input type="text" name="email" value="<?php echo $email;?>" size="12" maxlength="80"></td></tr>
<tr><td valign="top" colspan="2"><p><b><?php echo picklang($proflang["profile"]); ?>:</b></p></td></tr>
<tr><td colspan="2" align="center"><textarea name="profile" cols="35" rows="5" wrap="virtual"><?php echo textarea_prep(stripslashes($profile));?></textarea><br>[<?php echo picklang($proflang["profile_help"]); ?>]<br><?php echo picklang($proflang["allowed_tags"]); ?>: <?php echo htmlspecialchars(str_replace(",", " ", $allowedtags)); ?>&nbsp;&nbsp;max 255 char</td></tr>
<tr><td colspan="2"><hr align="center" color="<?php echo $reactorcolor[0];?>" width="100%" size="1"></td></tr>
<tr><td colspan="2" align="center">
<input type="button" value="<?php echo picklang($proflang["cancel"]); ?>" onclick="javascript:window.close();">&nbsp;<input type="submit" name="upload" value="<?php echo picklang($proflang["save"]); ?> &gt;&gt;" style="font-weight:bold;"> (<?php echo picklang($proflang["click_once"]); ?>!)</td></tr>
</table>
</form>
<hr align="center" color="<?php echo $reactorcolor[0];?>" width="100%" size="2">
</body>
</html>
<?php
}
?>
