<?php
/*
* Copyright (C) 1999-2000 IMEXIS LLC <http://imexis.com>
* 
* phod is open source; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License <http://www.opensource.org/licenses/gpl-license.html>
* for a complete version of the license.
*
** /phod.php
* customized for php(REACTOR)
*
* Credit should be given to
* J. Grohol http://www.grohol.com/ ,
* R. Chiswell http://www.beebware.com/ and
* R. Faulds http://www.computer-mentors.co.uk/download.html
* whose POD script was the inspiration for this.
* (POD + _extreme_ annoyance with Perl => phod.php)
*
*/

//include files that we'll need - check first
if(!defined("REACTOR_INC_GLOBAL")) { include("inc/global.inc.php"); }
if(!defined("REACTOR_INC_LANG")) { include($pathtohomedir."/inc/lang.inc.php"); }
if(!defined("REACTOR_INC_USERS")) { include($pathtohomedir."/inc/users.inc.php"); }

//******************************************************************************//
//CONFIGURATION VARIABLES! YOU CAN CHANGE THESE FREELY!
$phod_title = "phod";  //what will you name your PHOD?
$phod_header = ""; 	//this is the relative file path to a header file e.g. "header.html".
					//control colors, fonts, etc, using this file and css.
					//HEADER FILE MUST CONTAIN AT LEAST: <HTML><HEAD><TITLE></title></head><BODY>
$phod_footer = ""; 	//this is the relative file path to a footer file e.g. "footer.html".
					//FOOTER FILE MUST CONTAIN AT LEAST: </body></html>
					//if you leave the header and footer blank it will default to standard PHOD
$phod_table_color = $reactorcolor[3]; //This replaces DMOZ's green color
$phod_table2_color = $reactorcolor[2]; //THis replaces DMOZ's grey color

//******************************************************************************//
//ADVANCED CONFIGURATION.  THINK TWICE BEFORE CHANGING THESE!
$phod_url = $PHP_SELF; //this should be ok.  If not, use the URL to your script.
$debug = 0;  	//this is for debugging.  1 = On, 0 = Off.
$odp_base = "http://dmoz.org/"; //the base url of the ODP (keep trailing slash)
$odp_search = "http://search.dmoz.org/cgi-bin/search"; //The url of ODP's search engine
$odp_orig_search = "http://search.dmoz.org/cgi-bin/osearch";  //the url of ODP original search.

$phod_ver = "v1.0";
$phod_copy = '<b><font face="verdana, arial, sans-serif" size="1" color="#000077"><a href="http://imexis.com/phod.php3.txt">phod</a></b> '.$phod_ver.' is copyright &copy; 2000 <a href="http://imexis.com/">IMEXIS</a></font>';
$allowed_tags = "<textarea>,<a>,<h1>,<h2>,<h3>,<h4>,<h5>,<h6>,<br>,<ol>,<i>,<b>,<table>,<tr>,<td>,<form>,<p>,<center>,<small>,<input>,<select>,<option>,<ul>,<li>,<blockquote>";

//NOW we're not playing around.  Meddle below only if you know what you're doing
//***********************************************************************************//

$REQUEST_URI = strip_tags($REQUEST_URI);
$res = explode("$PHP_SELF?", $REQUEST_URI);
$odp_cat = $res[1];
//fix /Regional/US/ and /Regional/Canada/
$odp_cat = str_replace("/Regional/US/", "/Regional/North_America/United_States/", $odp_cat);
$odp_cat = str_replace("/Regional/Canada/", "/Regional/North_America/Canada/", $odp_cat);
$odp_cat = str_replace("/Regional/UK/", "/Regional/Europe/United_Kingdom/", $odp_cat);

if (substr($odp_cat,0,1) == "/") $odp_cat = substr($odp_cat,1);
else if (strstr($odp_cat, "asearch")) {
	$requesturl = $odp_orig_search;
	$requesturl .= strstr($REQUEST_URI,"?");
	$requesturl = str_replace("?asearch","?a.x=0",$requesturl);
	$cat = "search";
} else if (strstr($odp_cat, "osearch=")) {
	$requesturl = $odp_orig_search;
	$requesturl .= strstr($REQUEST_URI,"?");
	$requesturl = str_replace("?osearch=","?search=",$requesturl);
	$cat = "search";
} else if (strstr($odp_cat, "search=")) {
	$requesturl = $odp_search;
	$requesturl .= strstr($REQUEST_URI,"?");
	$cat = "search";
}
if(!$cat) {
	if (strstr($odp_cat, "where=")){
		$cat = str_replace("where=","",strstr($odp_cat,"where="));
	} else {
		$cat = $odp_cat;
	}
}

	//next, we call the appropriate page ay DMOZ
	if (!$requesturl) $requesturl = $odp_base.$odp_cat;
		if ($debug) echo '$requesturl: '.$requesturl."<br>";
	if ($requesturl) {
		$fp = fopen("$requesturl", "r");
		if(!$fp) {
			$line = "<center><br><br><font size=4 face=verdana color=#ff0000><b>Direktori DMOZ sedang offline.<br><br>&lt;mohon dicoba beberapa saat lagi&gt;</b></font><br><br><br>phod error: could not open the url: $requesturl<br></center><br><br><br>\n";
		} else {
			//fputs($fp,"$requesturl");
			$line = "";
			while(!feof($fp)) {
				$xyz = fgets($fp,256);
				if(strstr($xyz, "<META") || strstr($xyz, "<meta"))
					$phod_meta .= $xyz;
				else
					$line .= $xyz;
			}
			fclose($fp);
			//first, take out the newlines - this way we don't get crossed tags.
			$line = str_replace("\n"," ",$line);
			//take out the title
			$line = eregi_replace("<title>.*</title>","",$line);
			//Insert our copyright message
			$line = ereg_replace("Copyright &copy; [0-9]{4}-?[0-9]{0,4} Netscape",$phod_copy, $line);
			//change <p> tags to <br> 
			$line = str_replace("<p>","<br><br>",$line);
			$line = str_replace("<P>","<br><br>",$line);
			//change <hr> to <br> as well
			$line = str_replace("<hr>","<br><br>",$line);
			$line = str_replace("<HR>","<br><br>",$line);
			//remove all unwanted tags!
			$line = strip_tags($line, $allowed_tags);
			//customize colors
			$line = str_replace("#669933",$phod_table_color,$line);			
			$line = str_replace("#cccccc",$phod_table2_color,$line);			
			//map urls back to our script (use ereg_replace ?);
			//this is the only tricky part.  some of the urls I mapped
			//back to DMOZ to avoid the hassle.
			$line = str_replace('href="/',"href=\"$phod_url?/", $line);
			$line = str_replace($odp_base,"$phod_url?/",$line);
			$line = str_replace('href="http://search.dmoz.org/cgi-bin/search?a.x=0"',"href=\"$phod_url?asearch\"",$line);			
			$line = str_replace($odp_search."?search=","$phod_url?search=",$line);
			$line = str_replace($odp_search,"$phod_url",$line);
			$line = str_replace($odp_orig_search."?search=","$phod_url?osearch=",$line);
			$line = str_replace($odp_orig_search,"$phod_url",$line);
			$line = str_replace('ACTION="search"',"action=\"$phod_url\"",$line);
			$line = str_replace('href="search',"href=\"$phod_url",$line);
			$line = str_replace('HREF="/cgi-bin/search?search=',"href=\"$phod_url?search=",$line);
			$line = str_replace('HREF="osearch?search=',"href=\"$phod_url?osearch=",$line);
			$line = str_replace('ACTION="osearch"',"action=\"$phod_url\"",$line);
			$line = str_replace('action="add2.cgi"',"action=\"".$odp_base."cgi-bin/add2.cgi\"",$line);
			$line = str_replace('action="update2.cgi"',"action=\"".$odp_base."cgi-bin/update2.cgi\"",$line);
			$line = str_replace('action="apply2.cgi"',"action=\"".$odp_base."cgi-bin/apply2.cgi\"",$line);
			$line = str_replace('action="forgot.cgi"',"action=\"".$odp_base."cgi-bin/forgot.cgi\"",$line);
			$line = str_replace('action="/cgi-bin/feedback2.cgi"',"action=\"".$odp_base."cgi-bin/feedback2.cgi\"",$line);
			$line = str_replace('href="desc.html"','href="'.$phod_url."?/".$odp_cat.'desc.html"',$line);
			$line = str_replace('href="faq.html"','href="'.$phod_url."?/".$odp_cat.'faq.html"',$line);
			$line = str_replace('HREF="/searchguide.html"','href="'.$phod_url.'?/searchguide.html"',$line);
			$line = str_replace('HREF="searchguide.html"','href="'.$phod_url.'?/searchguide.html"',$line);
			$line = str_replace('width="100%"','width="98%"',$line);
			$line = str_replace('<table border=0 bgcolor="#dddddd" cellpadding=2 cellspacing=0 width="98%">','<table align=center border=0 bgcolor="#dddddd" cellpadding=2 cellspacing=0 width="98%">',$line);
		}
	}

	
//******************************************************************************//
//THIS IS TO INTEGRATE WITH EXISTING TEMPLATES
//declare vairables
$tpl_title = $phod_title;
if ($cat) $tpl_title .= " : ".str_replace("/"," : ",str_replace("_"," ",$cat));


//declare subroutines
function tpl_additional_head() {
	global $HTTP_USER_AGENT;
	global $phod_meta;
	if (!strstr($phod_meta, "name=\"description\"") && !strstr($phod_meta, "name=\"keywords\""))
		echo "\n".$phod_meta;
	if (strstr($HTTP_USER_AGENT, "MSIE")){
		?>
<style type="text/css">
<!-- 
B { 
	font-size : x-small;
}
-->
</style>
		<?php
	} 
}

function tpl_page_top() {
}


function tpl_page_foot() {
}


function tpl_body() {
global $line;
global $HTTP_USER_AGENT;
global $cat;
	//put the newlines back so I can see what's up
	//if ($debug) $line = str_replace("<br>","<br>\n",$line);
	//stop the center effect of the template
if (strstr($HTTP_USER_AGENT, "MSIE 5")){
	echo '<div align=left style="width:98%;">';
} else {
	echo '<table width="98%" border="0" cellpadding="4" cellspacing="0"><tr><td>';
}
	//first, define all of our variables.
/*REMOVED DEBUGGING
	global $debug;
		if($debug) echo "<h2 align=center>phod Debugging Mode</h2>\n";
	global $phod_ver;
		if($debug) echo '$phod_ver: '.$phod_ver."<br>\n";
	global $phod_table_color;
		if($debug) echo '$phod_table_color: '.$phod_table_color."<br>\n";
	global $phod_table2_color;
		if($debug) echo '$phod_table2_color: '.$phod_table2_color."<br>\n";
	global $phod_copy;
		if($debug) echo '$phod_copy: '.htmlspecialchars($phod_copy)."<br>\n";
	global $PHP_SELF;
		if ($debug) echo '$PHP_SELF: '.$PHP_SELF."<br>\n";
	global $REQUEST_URI;
		if($debug) echo '$REQUEST_URI: '.$REQUEST_URI."<br>\n";
	global $allowed_tags;
		if ($debug) echo '$allowed_tags: '.htmlspecialchars($allowed_tags)."<br>\n";	
	global $phod_url;  
		if ($debug) echo '$phod_url: '.$phod_url."<br>\n";
	global $odp_base;
		if ($debug) echo '$odp_base: '.$odp_base."<br>\n";
	global $odp_search;
		if ($debug) echo '$odp_search: '.$odp_search."<br>\n";
	global $odp_orig_search;
		if ($debug) echo '$odp_orig_search: '.$odp_orig_search."<br>\n";
	global $odp_cat;
		if ($debug) echo '$odp_cat: '.$odp_cat."<br>\n";
	global $cat;
		if ($debug) echo '$cat: '.$cat."<br>\n";
	global $requesturl;
		if ($debug) echo '$requesturl: '.$requesturl."<br>";
		if ($debug) echo "<br>ODP output starts here---------------<br>\n\n";
REMOVED DEBUGGING */
			echo $line;
			//if ($debug) echo "<br>ODP output ends here---------------<br>\n\n";
			
			//add html required by licence of ODP DO NOT REMOVE!
			?>
<center>

<p><table border="0" bgcolor="#336600" cellpadding="3" cellspacing="0">
<tr>
<td>
    <table width="100%" cellpadding="2" cellspacing="0" border="0">
        <tr align="center">
        <td><font face="sans-serif, Arial, Helvetica" size="2"
            color="#FFFFFF">Help build the largest human-edited
            directory on the web.</font></td></tr>
        <tr bgcolor="#CCCCCC" align="center">
        <td><font face="sans-serif, Arial, Helvetica" size="2">&nbsp;<a
            href="http://dmoz.org/cgi-bin/add.cgi?where=<?php echo $cat;?>">Submit
            a Site</a> - <a href="http://dmoz.org/about.html"><b>Open Directory
            Project</b></a> -
            <a href="http://dmoz.org/cgi-bin/apply.cgi?where=<?php echo $cat;?>">Become
            an Editor</a>&nbsp;</font>
        </td></tr>
    </table>
</td>
</tr>
</table>

</center>			
			<?php
	//start the center effect of the template

if (strstr($HTTP_USER_AGENT, "MSIE 5")){
	echo '</div>';
} else {
	echo '</td></tr></table>';
}

}


//throw it into the template
{ include($pathtohomedir."/templates/int.tpl.php"); }
?>

