<?php
/*
* Copyright (C) 1999-2000 EKILAT LLC (http://ekilat.com - the first reactor)
* 
* php(REACTOR) is open source; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License <http://www.opensource.org/licenses/gpl-license.html>
* for a complete version of the license.
*
** signup.php - add users into the system
*/
//ALWAYS INCLUDE THIS
if(!defined("REACTOR_INC_GLOBAL")) { include("inc/global.inc.php"); }
//check for banned ip.
filterbannedips();
//INCLUDE DB FUNCTIONS
if(!defined("REACTOR_INC_DB")) { include($pathtohomedir."/inc/db.inc.php"); }
//INCLUDE BBS FUNCTIONS
if(!defined("REACTOR_INC_BBS")) { include($pathtohomedir."/inc/bbs.inc.php"); }
//INCLUDE LANGUAGE FUNCTIONS
if(!defined("REACTOR_INC_LANG")) { include($pathtohomedir."/inc/lang.inc.php"); }
//INCLUDE USERS FUNCTIONS
if(!defined("REACTOR_INC_USERS")) { include($pathtohomedir."/inc/users.inc.php"); }

if ($upload) {
	//watch out for nasties
	$username = strip_tags($username);
	$username = eregi_replace("[^[:alnum:]\._]","", $username);
	$password = strip_tags($password);
	$password2 = strip_tags($password2);
	$email = strip_tags($email);
	$profile = trim(strip_tags($profile, $allowedtags));
	$agree = strip_tags($agree);
	$agree = eregi_replace("[^[:digit:]]","", $agree);
	$returnto= strip_tags($returnto);
	
	//validate
	if (!$agree) $errormessage .= picklang($signlang["err_no_agree"]).".<br>";
	if (strlen($profile) > 255) {
		$errormessage .= picklang($signlang["err_long_profile"])."]<br>\n";
		$profile = substr($profile, 0, 255);
	}
	if (!$errormessage) {
		//insert new user
		if (adduser($username, $password, $password2, $email, $profile)) {
			if (!$errormessage) {
				//set a cookie for their username
				bbs_login($username);
				//display success message
				$tpl_title = picklang($signlang["welcome"]);
				$tpl_message = picklang($signlang["welcome_message"]);
				if ($returnto) $tpl_message .= "<br><a href=$returnto>".picklang($signlang["continue"])."</a><br>";
				//include simple template
				include($pathtohomedir."/templates/simple.tpl.php");
				exit;
			}
		} 
	}
}

if ($errormessage || !$upload) {
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">

<html><head><title><?php echo $reactorname; ?> : <?php echo picklang($signlang["signup"]); ?></title>
<meta http-equiv="content-type" content="text/html;charset=iso-8859-1">
<?php stylepicker(); ?>
</head>
<body bgcolor="<?php echo $reactorcolor[1];?>">
<center><font color="#ff0000" size="4" face="verdana, arial, sans-serif"><b><?php echo $errormessage; ?></b></font></center>
<?php if($badpass) { ?>
<p><b><a href="javascript:history.back();">&lt;&lt; <?php echo picklang($signlang["back_message"]); ?></a></b><br>
<?php echo picklang($signlang["badpass_message"]); ?>
</p>
<?php } ?>
<hr align="center" color="<?php echo $reactorcolor[0];?>" width="100%" size="2">
<form enctype="application/x-www-form-urlencoded" action="<?php echo $PHP_SELF;?>" method="post">
<input type=hidden name=returnto value="<?php echo $returnto;?>">
<table align=center width=95% bgcolor="<?php echo $reactorcolor[2];?>" cellpadding=2 cellspacing=0>
<tr><td align="right"><p><b><?php echo picklang($signlang["choose"]); ?> nick:</b></p></td><td width="50%"><input type="text" name="username" value="<?php echo $username;?>" size="12" maxlength="20"> (<?php echo picklang($signlang["username_help"]); ?>)</td></tr>
<tr><td align="right"><p><b><?php echo picklang($signlang["choose"]); ?> password:</b></p></td><td width="50%"><input type="password" name="password" value="<?php echo $password;?>" size="12" maxlength="20"> (<?php echo picklang($signlang["password_help"]); ?>)</td></tr>
<tr><td align="right"><p><b>password <?php echo picklang($signlang["again"]); ?>:</b></p></td><td width="50%"><input type="password" name="password2" value="<?php echo $password2;?>" size="12" maxlength="20"></td></tr>
<tr><td colspan="2"><hr align="center" color="<?php echo $reactorcolor[0];?>" width="100%" size="1"></td></tr>
<tr><td align="right"><p><b><?php echo picklang($signlang["email"]); ?>:</b></p></td><td width="50%"><input type="text" name="email" value="<?php echo $email;?>" size="12" maxlength="80"></td></tr>
<tr><td valign="top" colspan="2"><p><b><?php echo picklang($signlang["profile"]); ?>:</b></p></td></tr>
<tr><td colspan="2" align="center"><textarea name="profile" cols="35" rows="3" wrap="virtual"><?php echo textarea_prep(stripslashes($profile));?></textarea><br>[<?php echo picklang($signlang["profile_help"]); ?>]
<br><?php echo picklang($signlang["allowed_tags"]); ?>: <?php echo htmlspecialchars(str_replace(",", " ", $allowedtags)); ?>&nbsp;&nbsp;max 255 char</td></tr>
<tr><td colspan="2"><hr align="center" color="<?php echo $reactorcolor[0];?>" width="100%" size="1"></td></tr>
<tr><td colspan="2"><input type="checkbox" name="agree" value="1" <?php if($agree) echo "checked";?> style="background-color:#eeeeee;"> 
<?php echo picklang($signlang["agree"]); ?>
</td></tr>
<tr><td colspan="2" align="center">
<input type="button" value="<?php echo picklang($signlang["cancel"]); ?>" onclick="javascript:window.close();">&nbsp;<input type="submit" name="upload" value="<?php echo picklang($signlang["signup"]); ?> &gt;&gt;" style="font-weight:bold;"> (<?php echo picklang($signlang["click_once"]); ?>!)</td></tr>
</table>
</form>
<hr align="center" color="<?php echo $reactorcolor[0];?>" width="100%" size="2">
</body>
</html>
<?php
}
?>
