<?php
/*
* Copyright (C) 1999-2000 EKILAT LLC (http://ekilat.com - the first reactor)
* 
* php(REACTOR) is open source; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License <http://www.opensource.org/licenses/gpl-license.html>
* for a complete version of the license.
*
** 				./inc/bbs.inc.php
* shared functions for the bbs system.  This is the most complicated of the 
* files used in php(REACTOR);.  If you make any mods, make sure they are clearly
* noted.
* A NOTE ON HOW COMMENTS ARE STORED IN THE DB:
* The users' commemts are stored in that database as the would appear on the page.
* newlines are converted to <br> tags, smileys :) are converted to image tags,
* hyperlinks http:// are made active.  all other tags not specified in 
* $allowedtags are stripped.  if users want to submit code, the are given an
* javascript button when posting which converts > to &lt; etc. before they post.
*/

// tell everyone we're already loaded
define("REACTOR_INC_BBS", 1);

//include files that we'll need - check first
if(!defined("REACTOR_INC_GLOBAL")) { include("inc/global.inc.php"); }
if(!defined("REACTOR_INC_DB")) { include($pathtohomedir."/inc/db.inc.php"); }
if(!defined("REACTOR_INC_LANG")) { include($pathtohomedir."/inc/lang.inc.php"); }
if(!defined("REACTOR_INC_USERS")) { include($pathtohomedir."/inc/users.inc.php"); }

//include language and configuration variables
if(!defined("REACTOR_CONF_BBS")) { include($pathtohomedir."/conf/bbs.conf.php"); }

//WHAT IS THE TABLE THAT CONTAINS THE LIST OF FORUMS?
$forumlist = $boardname;

//THESE TABLES CONTAIN THE TOPIC POSTS FOR EACH FORUM
$ftable = $forumlist."topics".$fid;//you'd better not change this

//initialize variables
if(!isset($fid)) $fid = 0;
if(!isset($start)) $start = 0;
if(!isset($finaltid)) $finaltid = 0;

//DO NOT CHANGE THESE - THEY SEPARATE EDIT MARKERS FROM THE COMMENT BODY.
$editcore = "##:*$$";
$editkey = "\n".$editcore."[ ";

/*
* forumquery() - tells us where the tables for the forums are stored.  if you
* have multiple forums (different directories on your server),
* you may want to store them in separate databases.  an
* example of how to do that is below:
######## example
function forumquery($sql, $mode) {
global $boardname;
	if ($boardname == "movies") {
		$result = db1_query($sql, $mode);
	}
	else if ($boardname == "music") {
		$result = db2_query($sql, $mode);
	}
	return $result;
}
*/
######## v1.0.0
function forumquery($sql, $mode) {
	return db1_query($sql, $mode);
}

/*
* markvisit() - this sets a cookie which determines which posts are new.  if 
* they have been surfing for more than an hour, it will reset.
*/
######## v.1.0.0
function markvisit() {
global $currentvisit, $lastvisit;
$path = "";//available to this forum only
$sec2expire = 60*60*24*365;//one year
$sec2reset = 60*60;//1 hr
$expires = time()+$sec2expire;
$domain = "";
$secure = 0;
	//they have never been here before
	if (!isset($currentvisit)) {
		setcookie("currentvisit", time(), $expires , $path, $domain, $secure);
	}
	//they have been here before - check to see how long ago it was
	//if longer than reset time, move currentvisit to last and set current to now
	else if ($currentvisit + $sec2reset < time()) {
		setcookie("currentvisit", time(), $expires, $path, $domain, $secure);
		setcookie("lastvisit", $currentvisit, $expires, $path, $domain, $secure);
		$lastvisit = $currentvisit;		
	}
}

/*
* whereami() - this function looks at the forum directory tree and builds a
* chain to the current location in the forum structure.
*/
######## v.1.0.0
function whereami($boardname, $fid, $go) {
global $PHP_SELF, $forumlist;
static $output;
	if ($go) $output = " : ".stripslashes($go); 
	//first, get name and parents of current forum
	$sql = "SELECT fmname, pfid, rfid FROM $forumlist WHERE fid=$fid";
	if($result = forumquery($sql, "r")) {
		if($myforum = request_fetch_array($result)) {
			//add ourselves to the chain
			$output = " : <a href=$PHP_SELF?fid=$fid>".$myforum["fmname"]."</a>".$output;
			if($fid == $myforum["rfid"]) {
				//we're at the top
				$output = "<a href=$PHP_SELF>$boardname</a>".$output;
				return $output;
			}
			else {
				//we have a parent
				 return whereami($boardname, $myforum["pfid"], false);
			}
		} else return "noresulterror : ".$output;
	} else return "noconnecterror : ".$output;
}

/*
* forumlist() - queries the $forumlist table for all active forums, 
* and shows $showmax of them.
*/
######## v.1.0.0
function forumlist() {
global $reactorcore, $timezone, $allowsearches, $bbslang, $reactorcolor, $datestringlong, $errormessage, $boardname, $lastvisit, $icondir, $timeadj, $start, $showmax, $forumlist, $PHP_SELF, $datestringshort;
$numrows = $showmax + 1;
$next = $start + $numrows;
$more = 1;
$prev = $start - $showmax;

	$sql = "SELECT DISTINCT t.fid, t.fmname, t.descr, t.moderator, t.totalposts, UNIX_TIMESTAMP(t.modified) AS last FROM $forumlist t, $forumlist r WHERE t.fid=r.rfid AND t.status=1 LIMIT $start, $numrows";
	if ($request = forumquery($sql, "r")) {
		//write top table header row
		$outputhtml .= mktable("98%", $reactorcolor[1], "2");
		$outputhtml .= "<tr bgcolor=".$reactorcolor[3].">";
		$outputhtml .= "<td width=60% class=bordbot><p><b>&nbsp;".$boardname."</b>&nbsp;&nbsp;[<a href=$PHP_SELF?active=1 style=\"font-size:smaller;\">".picklang($bbslang["today_active_topics"])."</a>] ".(($allowsearches)? "[<a href=search.php style=\"font-size:smaller;\">".picklang($bbslang["search"])."</a>]" :"")."</p></td>";
		$outputhtml .= "<td class=bordbot align=center><p><b>".picklang($bbslang["last_post"])."</b></p></td>";
		$outputhtml .= "<td class=bordbot align=center><p><b>".quickuserstatus(0, 1)."</b></p></td>";
		$outputhtml .= "<td align=center class=bordbot colspan=2 width=1%><p><b>".picklang($bbslang["total"])."</b></p></td>";
		$outputhtml .= "</tr>\n";
		//write the records for each forum one at a time
		for ($i = 0; $i < $showmax; $i++) {
			if($myforum = request_fetch_array($request)) {
				$outputhtml .= "<tr valign=top>";
				$outputhtml .= "<td class=bordbot><p><b><a href=$PHP_SELF?fid=".$myforum["fid"].">".$myforum["fmname"]."</a></b></p>&nbsp;&nbsp;&nbsp;".$myforum["descr"]."</td>";
				$outputhtml .= "<td bgcolor=".$reactorcolor[2]." align=center class=bordbot><p>".date($datestringshort, $myforum["last"] + $timeadj)."</p></td>\n";
				$outputhtml .= "<td align=center class=bordbot><p>".$myforum["moderator"]."</p></td>";
				$outputhtml .= "<td align=center bgcolor=".$reactorcolor[2]." class=bordbot><p>".$myforum["totalposts"]."</p></td>";
				//show the newpost image if the post is new.
				if($lastvisit && ($lastvisit < $myforum["last"]))
					$outputhtml .= "<td bgcolor=".$reactorcolor[4]." class=bordbot><img width=20 height=20 align=center src=".$icondir."new.gif border=0 alt=\"[".picklang($bbslang["new"])."]\"></td>";
				else $outputhtml .= "<td bgcolor=".$reactorcolor[4]." class=bordbot>&nbsp;</td>";
				$outputhtml .= "</tr>\n";
			}
			else {
				$more = 0;
				break;
			}
		}
		$outputhtml .= "</table>\n";
		//display the next and prev links if they are appropriate
		if ($more) {
			if(!($mytopic = request_fetch_array($request))) $more = 0; 
		}
		$prevon = 0;
		if($prev > - 1) {
			$prevon = 1;
		}
		else if($start > 0) {
			$prevon = 1;
			$prev = 0;
		}
		if ($more || $prevon) {
			$outputhtml .= mktable("98%", $reactorcolor[3], "2");
			$outputhtml .= "<tr>";
			$outputhtml .= "<td align=center width=33%>&nbsp;";
			if($prevon) $outputhtml .= "&lt;&lt; <a href=$PHP_SELF?start=".$prev.">".picklang($bbslang["prev_forums"])."</a>";
			$outputhtml .= "</td>";
			$outputhtml .= "<td align=center width=33%>&nbsp;</td>\n";
			$outputhtml .= "<td align=center width=33%>";
			if($more) $outputhtml .= "<a href=$PHP_SELF?start=".($next - 1).">".picklang($bbslang["more_forums"])."</a> &gt;&gt;";
			$outputhtml .= "&nbsp;</td>";
			$outputhtml .= "</tr>\n";
			$outputhtml .= "</table>\n";
		}
		$outputhtml .= mktable("98%", $reactorcolor[3], "2");
		$outputhtml .= "<tr>";
		$outputhtml .= "<td width=60%>&nbsp;";
		if ($lastvisit) $outputhtml .= picklang($bbslang["last_visit"]).": ".date($datestringlong,$lastvisit+$timeadj)." ".$timezone;
		$outputhtml .= "</td>";
		$outputhtml .= "<td align=right width=40%>[<a href=$reactorcore/signup.php ".jpopclick("signup",400,434).">".picklang($bbslang["signup"])."</a>]&nbsp;&nbsp;&nbsp;[<a href=$reactorcore/forgot.php ".jpopclick("lupa",400,434).">".picklang($bbslang["lost_password"])."</a>]&nbsp;</td>";
		$outputhtml .= "</tr>\n";
		$outputhtml .= "</table>\n";
	}
return $outputhtml;
}

/*
* fastforumlist() simliar to forumlist() but list the forums in a unordered list
* makes for a faster interface. usually used to list subforums of forums
*/
######## v.1.0.0
function fastforumlist($pfid = "") {
global $daystodie, $bbslang, $errormessage, $datestringshort, $boardname, $lastvisit, $icondir, $timeadj, $start, $showmax, $forumlist, $PHP_SELF;
$numrows = $showmax + 1;
$next = $start + $numrows;
$more = 1;
$prev = $start - $showmax;
// //how many days until a forum is not shown (inactive forums disappear)
// $daystodie = 31; moved to conf/
$timetodie = time() - 24*60*60*$daystodie;

	if ($pfid) $sql = "SELECT *, UNIX_TIMESTAMP(modified) AS last FROM $forumlist WHERE pfid=$pfid AND fid!=$pfid AND status=1 AND UNIX_TIMESTAMP(modified)>$timetodie ORDER BY modified DESC LIMIT $start, $numrows";
	else $sql = "SELECT *, UNIX_TIMESTAMP(modified) AS last FROM $forumlist WHERE status=1 LIMIT $start, $numrows";
	if ($request = forumquery($sql, "r")) {
			$exists = get_num_rows($request);
			$split = ($exists > floor($showmax/2)) ? floor($exists/2) : ($showmax*2);
			if ($exists) $outputhtml .= "<br>\n<table width=98%><tr><td>\n<ul>";
			for ($i = 0; $i < $showmax; $i++) {
			if($myforum = request_fetch_array($request)) {
				//split into 2 table cells if there are enough rows
				if(!(($i + 1) % $split)) $outputhtml .= "</td><td>";
				$outputhtml .= "\n<li> ";
				$outputhtml .= "<b style=\"font-size:larger;\"><a href=$PHP_SELF?fid=".$myforum["fid"].">".$myforum["fmname"]."</a></b>";
				$outputhtml .= " - ".$myforum["descr"];
				$outputhtml .= " - ".picklang($bbslang["last_post"]).": <b>".date($datestringshort, $myforum["last"] + $timeadj)."</b>";
				$outputhtml .= " - ".quickuserstatus(0, 1).": <b>".$myforum["moderator"]."</b>";
				$outputhtml .= " - ".picklang($bbslang["comments"]).": <b>".$myforum["totalposts"]."</b>";
				//see if the post is new for the user
				if($lastvisit && ($lastvisit < $myforum["last"]))
					$outputhtml .= " <b style=\"color:#ff0000;\">[".picklang($bbslang["new"])."]</b> ";
			}
			else {
				$more = 0;
				break;
			}
		}
		if ($more) {
			if(!($mytopic = request_fetch_array($request))) $more = 0; 
		}
		if ($exists) $outputhtml .= "\n</ul></td></tr>\n</table>\n";
		$prevon = 0;
		if($prev > - 1) {
			$prevon = 1;
		}
		else if($start > 0) {
			$prevon = 1;
			$prev = 0;
		}
		if (($more || $prevon) && $exists) {
			if($prevon) {
				$outputhtml .= "&nbsp;&nbsp;&lt;&lt; <a href=$PHP_SELF?fid=$pfid&start=".$prev.">".picklang($bbslang["prev_clubs"])."</a>";
			}
			if($more) $outputhtml .= "&nbsp;&nbsp;<a href=$PHP_SELF?fid=$pfid&start=".($next - 1).">".picklang($bbslang["more_clubs"])."</a> &gt;&gt;";
		}
	}
return $outputhtml;
}

/*
* thread_nav() - this function displays links to the other modes (flat, threaded, ranked)
*/
######## v.1.0.0
function thread_nav($fid, $go, $tid) {
global $bbslang, $icondir, $PHP_SELF;	
	$outputhtml .= "<a href=$PHP_SELF?fid=$fid&tid=$tid&go=".urlencode(stripslashes($go))."&mode=flat><img width=20 height=20 src=".$icondir."flat.gif border=0 alt=\"[".picklang($bbslang["flat_view"])."]\"></a>";
	$outputhtml .= "<a href=$PHP_SELF?fid=$fid&tid=$tid&go=".urlencode(stripslashes($go))."&mode=threaded><img width=20 height=20 src=".$icondir."threads.gif border=0 alt=\"[".picklang($bbslang["threaded_view"])."]\"></a>";
	$outputhtml .= "<a href=$PHP_SELF?fid=$fid&tid=$tid&go=".urlencode(stripslashes($go))."&mode=ranked><img width=20 height=20 src=".$icondir."rank.gif border=0 alt=\"[".picklang($bbslang["ranked_view"])."]\"></a>";
return $outputhtml;
}

/*
* onetopic_td() - displays a single topic (subject, user, last comment) 
* to be used in a list of topics
*/
######## v.1.0.0
function onetopic_td($mytopic) {
global $bbslang, $reactorcolor, $PHP_SELF, $datestringlong, $fid, $icondir, $lastvisit, $timeadj;

	$outputhtml .= "<td><p>&nbsp;<b><a href=$PHP_SELF?fid=$fid&tid=".$mytopic["tid"]."&go=".urlencode($mytopic["subject"]).">".$mytopic["subject"]."</a></b> - ".$mytopic["username"]."</p></td>";
	$outputhtml .= "<td align=center><a href=$PHP_SELF?fid=$fid&tid=".$mytopic["tid"]."&go=".urlencode($mytopic["subject"])."&start=last >".date($datestringlong, $mytopic["last"] + $timeadj)."</a></td>";
	$outputhtml .= "<td>&nbsp;<b>".$mytopic["children"]."</b>&nbsp;</td>";
	$outputhtml .= "<td bgcolor=".$reactorcolor[4]." width=60 nowrap>".thread_nav($fid, $mytopic["subject"], $mytopic["tid"])."</td>";
	//display a new marker if the topic is new
	if($lastvisit && ($lastvisit < $mytopic["last"]))
		$outputhtml .= "<td bgcolor=".$reactorcolor[4]."><img width=20 height=20 align=center src=".$icondir."new.gif border=0 alt=\"[".picklang($bbslang["new"])."]\"></td>";
	else $outputhtml .= "<td width=1 bgcolor=".$reactorcolor[4].">&nbsp;</td>";

return $outputhtml;
}

/*
* topiclist() - displays a list of topics for a given forum.  root topics are
* shown, with the most recently commented topic shown first.
* this currently uses tables.  I don't separate the HTML from the code because
* I find that that would make things MUCH more complicated, and make
* customization that much harder.   if you want to customize the interface, 
* I suggest you build another function called fasttopiclist() or xmltopiclist()
* and put them inot module form ...
*/
######## v.1.0.0
function topiclist($fid, $start) {
global $threshold, $bbslang, $reactorcolor, $reactorcore, $boardname, $errormessage, $showmax, $icondir, $lastvisit, $timeadj, $ftable, $forumlist, $PHP_SELF;
$numrows = $showmax + 1;
$next = $start + $numrows;
$more = 1;
$prev = $start - $showmax;

 $myloc = whereami($boardname, $fid, "");
	$sql = "SELECT DISTINCT t.tid, t.subject, t.username, t.children, t.rank, UNIX_TIMESTAMP(t.created) AS first, UNIX_TIMESTAMP(t.modified) AS last FROM $ftable t, $ftable r WHERE t.tid=r.rid AND t.status=1 ORDER BY t.modified DESC LIMIT $start, $numrows";
	if ($request = forumquery($sql, "r")) {
		//dislay links to requesting forums and posting new topics
		$outputhtml .= "<table width=98%>";
		$outputhtml .= "<tr>";
		$outputhtml .= "<td><p><b>[<a href=requestforum.php?&fid=$fid ".jpopclick("klub",400,434).">".picklang($bbslang["request_forum"])."</a>]</b></p></td>";
		$outputhtml .= "<td><p align=right><b>[<a href=post.php?fid=$fid ".jpopclick("post",400,434).">".picklang($bbslang["post_topic"])."</a>]</b></p></td>";
		$outputhtml .= "</tr>\n";
		$outputhtml .= "</table>\n";
		$outputhtml .= mktable("98%", $reactorcolor[1], "2");
		$outputhtml .= "<tr bgcolor=".$reactorcolor[3].">";
		$outputhtml .= "<td class=bordbot ><p><b>&nbsp;".$myloc."</b></p></td>";
		$outputhtml .= "<td class=bordbot align=center><p><b>".picklang($bbslang["last_post"])."</b></p></td>";
		$outputhtml .= "<td class=bordbot colspan=3 width=1><p>&nbsp;<b>".picklang($bbslang["comments"])."</b></p></td>";
		$outputhtml .= "</tr>\n";
		//display each topic
		for ($i = 0; $i < $showmax; $i++) {
			if($mytopic = request_fetch_array($request)) {
			  if ($mytopic["rank"] > $threshold) {
			    $bgcolor = "";
			    if ($i%2) $bgcolor = $reactorcolor[2];
			    if ($bgcolor) $outputhtml .= "<tr bgcolor=".$bgcolor.">\n";
			    else $outputhtml .= "<tr>";
			    $outputhtml .= onetopic_td($mytopic);
			    $outputhtml .= "</tr>\n";
			  }
			}
			else {
				$more = 0;
				break;
			}
		}
		if ($more) {
			if(!($mytopic = request_fetch_array($request))) $more = 0; 
		}
		$outputhtml .= "</table>\n";
		//display links to previous and next topics if applicable
		$outputhtml .= mktable("98%", $reactorcolor[3], "2");
		$outputhtml .= "<tr>";
		$outputhtml .= "<td align=center width=33% class=bordtop><p><b>&nbsp;";
		if($prev > - 1) {
			$outputhtml .= "&lt; <a href=$PHP_SELF?fid=$fid&start=".$prev.">".picklang($bbslang["prev_topics"])."</a>";
		}
		else if($start > 0) {
			$prev = 0;
			$outputhtml .= "&lt; <a href=$PHP_SELF?fid=$fid&start=".$prev.">".picklang($bbslang["prev_topics"])."</a>";
		}
		$outputhtml .= "</b></p></td>";
		$outputhtml .= "<td align=center width=33% class=bordtop><p><b>[<a href=$PHP_SELF>".picklang($bbslang["other_forums"])."</a>]</b></p></td>\n";
		$outputhtml .= "<td align=center width=33% class=bordtop><p><b>";
		if($more) $outputhtml .= "<a href=$PHP_SELF?fid=$fid&start=".($next - 1).">".picklang($bbslang["next_topics"])."</a> &gt;";
		$outputhtml .= "&nbsp;</b></p></td>";
		$outputhtml .= "</tr>\n";
		$outputhtml .= "</table>\n";
		//display link to post a new topic
		$outputhtml .= "<p align=left>&nbsp;<b>[<a href=post.php?fid=$fid ".jpopclick("post",400,434).">".picklang($bbslang["post_topic"])."</a>]</b></p><br>\n";
	}
return $outputhtml;
}

/*
* listchildren() - this recursively lists the children of a given topic.  
* children are indented wrt their parent topic with simple <ul> lists.
* fast and easy.  threads which are greater then ten posts deep are jumped
* out of the <ul> to prvent the horizonatl scrolllbar.
* credits to webmonkey on this one, folks.
*/
######## v.1.0.0
function listchildren($fid, $tid, $mytid, $level) {
global $threshold, $bbslang, $reactorcolor, $errormessage, $datestringlong, $finaltid, $timeadj, $ftable, $forumlist, $PHP_SELF, $lastvisit;
$comments = 0;

	$sql = "SELECT tid, subject, username, status, rank, UNIX_TIMESTAMP(created) AS first FROM $ftable WHERE pid=$tid AND tid!=$tid ORDER BY created, tid";
	if ($request = forumquery($sql, "r")) {
		while ($mytopic = request_fetch_array($request)) {
			if ($level && !$comments)
				$outputhtml .= "\n<ul>\n";
			$comments++;
			$finaltid = $mytopic["tid"];
			if ($mytopic["status"] && ($mytopic["rank"] > $threshold)) {
				$outputhtml .= "\n<li style=\"color:".$reactorcolor[0].";\"> ";
				//if new, display new tag
				if($lastvisit && ($lastvisit < $mytopic["first"])) $outputhtml .= " <b style=\"color:#ff0000;\">[".picklang($bbslang["new"])."]</b> ";
				if ($mytid != $mytopic["tid"]) $outputhtml .= "<a href=$PHP_SELF?fid=$fid&tid=".$mytopic["tid"]."&go=".urlencode($mytopic["subject"])."&mode=threaded>";
				else $outputhtml .= "<i style=\"font-size:small;\">";
				$outputhtml .= "<b>".$mytopic["subject"]."</b>";
				if ($mytid != $mytopic["tid"]) $outputhtml .= "</a>";
				else $outputhtml .= "</i>";
				$outputhtml .= " - ".$mytopic["username"]." - ".date($datestringlong, $mytopic["first"] + $timeadj)."</li>\n";
			}
			//check to see if we're too deep in a list
			if ($level > 10) {
				$outputhtml .= "\n</ul></ul></ul></ul></ul></ul></ul></ul></ul></ul></ul>&nbsp;&nbsp;&lt;&lt;----<br>\n";
				//this might be a bug maybe it should be $level=1
				$level = 0;
			}
			$outputhtml .= listchildren($fid, $mytopic["tid"], $mytid, $level+1);
		}
		if ($level && $comments)
			$outputhtml .= "\n</ul>\n";
	}
return $outputhtml;
} 

/*
* addsmileys() - this function makes normal ascii smileys :), :(, etc into
* funky images.  the default images were created by JC Falch, and are used with
* permission of eKilat.com.  the smiley conversion is done before the posts
* are stored in the database.
*/
######## v.1.0.0
function addsmileys($body) {
global $icondir;
	$body = str_replace(":)"," <img src=".$icondir."happy.gif border=0> ",$body);
	$body = str_replace(":("," <img src=".$icondir."sad.gif border=0> ",$body);
	$body = str_replace(":["," <img src=".$icondir."angry.gif border=0> ",$body);
	$body = str_replace(":o"," <img src=".$icondir."scared.gif border=0> ",$body);
	$body = str_replace("8)"," <img src=".$icondir."sly.gif border=0> ",$body);
	$body = str_replace(";)"," <img src=".$icondir."wink.gif border=0> ",$body);
	return $body;
}

/*
* dropsmileys() - just returns the graphical smileys to ascii form.  used when
* sending mail or uploading posts for editing.
*/
######## v.1.0.0
function dropsmileys($body) {
global $icondir;
	$body = str_replace(" <img src=".$icondir."happy.gif border=0> ",":)",$body);
	$body = str_replace(" <img src=".$icondir."sad.gif border=0> ",":(",$body);
	$body = str_replace(" <img src=".$icondir."angry.gif border=0> ",":[",$body);
	$body = str_replace(" <img src=".$icondir."scared.gif border=0> ",":o",$body);
	$body = str_replace(" <img src=".$icondir."sly.gif border=0> ","8)",$body);
	$body = str_replace(" <img src=".$icondir."wink.gif border=0> ",";)",$body);
	return $body;
}

/*
* convertpost() - converts the posts to be stored in the database.  changes
* URLs to hyperlinks, converts smileys, and makes newlines \n into <br> tags.
*/
######## v1.0.0
function convertpost($body) {
	$body = nl2br(addsmileys(makelinks($body)));
	return $body;
}

/*
* revertpost() - basically undoes convertpost() - this is used when topics are
* pulled out for editing purposes of sent out for mailing.
*/
######## v.1.0.0
function revertpost($body) {
global $allowedtags;
	$body = strip_tags(dropsmileys(str_replace("<br>\n", "", $body)), $allowedtags);
	return $body;
}

/*
* showrank() displays the rank of the current post.  ranking is done simply (+1
* or -1), like slashdot, with the exception that everyone is a moderator. 
* topics may be displayed by rank, but the real reason we use ranks is to
* determine what topics can be shown where.  for instance, if you wanted to show
* the latest posts from your forums on the front page, you wouldn't want joe 
* "newbie" spammer's posts to show up there.
*/
######## v.1.0.0
function showrank($rank) {
global $bbslang, $icondir;
	if($rank > 4) {
		for ($i=0;$i<4;$i++) {
			$outputhtml .= "<img width=15 height=15 src=".$icondir."good.gif border=0 alt=\"".picklang($bbslang["rank"]).": $rank\">";
		}
	}
	else if($rank > 0) {
		for ($i=0;$i<$rank;$i++) {
			$outputhtml .= "<img width=15 height=15 src=".$icondir."good.gif border=0 alt=\"".picklang($bbslang["rank"]).": $rank\">";
		}
	}
	else if($rank == 0)
		$outputhtml .= "<img width=15 height=15 src=".$icondir."even.gif border=0 alt=\"".picklang($bbslang["rank"]).": $rank\">";
	else if($rank > -4) {
		for ($i=0;$i>$rank;$i--) {
			$outputhtml .= "<img width=15 height=15 src=".$icondir."bad.gif border=0 alt=\"".picklang($bbslang["rank"]).": $rank\">";
		}
	}
	if($rank < -4) {
		for ($i=0;$i<4;$i++) {
			$outputhtml .= "<img width=15 height=15 src=".$icondir."bad.gif border=0 alt=\"".picklang($bbslang["rank"]).": $rank\">";
		}
	}
return $outputhtml;
}

/*
* commentfunctions() - this displays a menu of all of the actions that can be
* taken with regards to a certain post: comment, about the poster, rank +/-, edit
*/
######## v.1.0.0
function commentfunctions($mytid,$myusername) {
global $bbslang, $PHP_SELF, $boardname, $icondir, $fid;

	//reply to this post
	$outputhtml .= "<a href=post.php?fid=$fid&tid=".$mytid." ".jpopclick("post",400,434)."><img width=20 height=20 src=".$icondir."comment.gif border=0 alt=\"[".picklang($bbslang["reply_to_post"])."]\"></a>";
	//find out about the poster
	$outputhtml .= "<a href=$PHP_SELF?profile=".$myusername."><img width=20 height=20 src=".$icondir."info.gif border=0 alt=\"[".picklang($bbslang["about"])." ".$myusername."]\"></a>";
	//rank this post up
	$outputhtml .= "<a href=rank.php?fid=$fid&tid=".$mytid."&rank=up ".jpopclick("rank",400,434)."><img width=20 height=20 src=".$icondir."rateup.gif border=0 alt=\"[".picklang($bbslang["rank_up"])."]\"></a>";
	//rank this post down
	$outputhtml .= "<a href=rank.php?fid=$fid&tid=".$mytid."&rank=dn ".jpopclick("rank",400,434)."><img width=20 height=20 src=".$icondir."ratedn.gif border=0 alt=\"[".picklang($bbslang["rank_down"])."]\"></a>";
	//edit/delete this post
	$outputhtml .= "<a href=edit.php?fid=$fid&tid=".$mytid." ".jpopclick("edit",400,434)."><img width=20 height=20 src=".$icondir."edit.gif border=0 alt=\"[".picklang($bbslang["edit_delete"])."]\"></a>\n";
return $outputhtml;
}

/*
* onepost_td() - this function just displays a single post.  it takes the array
* of the post returned by the database as an argument
*/
######## v.1.0.0
function onepost_td($mytopic) {
global $bbslang, $reactorcolor, $fid, $datestringlong, $icondir, $boardname, $PHP_SELF, $editcore, $timeadj;

	//left side - username and status
	$outputhtml .= "<td width=118 valign=top class=bordbotrt><p><b>".$mytopic["username"]."</b></p>&nbsp;&nbsp;".$mytopic["userstatus"]."</td>";
	//right side
	$outputhtml .= "<td class=bordbot>\n";
	$outputhtml .= "<table bgcolor=".$reactorcolor[4]." width=100% border=0 cellpadding=0 cellspacing=0  class=borddblbot>";
	$outputhtml .= "<tr>";
	//date of posting and rank
	$outputhtml .= "<td align=left>&nbsp;".date($datestringlong, $mytopic["first"] + $timeadj)."&nbsp;&nbsp;[".$mytopic["user_addr"]."]&nbsp;&nbsp;".showrank($mytopic["rank"])."</td>";
	//comment functions, or, closed topic
	$outputhtml .= "<td width=100 nowrap>";
	if(!$mytopic["closed"])
		$outputhtml .= commentfunctions($mytopic["tid"],$mytopic["username"]);
	else $outputhtml .= "<p><b>[".picklang($bbslang["closed"])."]</b></p>";
	$outputhtml .= "</td>";
	$outputhtml .= "</tr>\n";
	$outputhtml .= "</table>\n";
	//subject
	$outputhtml .= "<p><b>".$mytopic["subject"]."</b><br><br>";
#//this is for the vestigal system which added smileys and made links on the fly :(
#//JUST IGNORE IT, DON'T REMOVE IT!
#if ($mytopic["created"] < 20000608155000) 
#	$outputhtml .= convertpost(str_replace($editcore,"",$mytopic["body"]));
#else $outputhtml .= str_replace($editcore,"",$mytopic["body"]);
	$outputhtml .= str_replace($editcore,"",$mytopic["body"]);
	$outputhtml .= "</p></td>";
return $outputhtml;
}

/*
* prev_next() - this just displays links to the previous and next groups of
* posts.  it also displays links to the first and last posts
*/
######## v.1.0.0
function prev_nex($prev, $start, $more, $next) {
global $bbslang, $reactorcolor, $PHP_SELF, $go, $fid, $tid, $mode;

	$outputhtml .= mktable("98%", $reactorcolor[3], "2");
	$outputhtml .= "<tr>";
	$outputhtml .= "<td align=left width=33%><p><b>&nbsp;";
	//display links to previous topics if they exist
	if($prev > - 1) {
		$outputhtml .= "&lt; <a href=$PHP_SELF?fid=$fid&tid=$tid&go=".urlencode(stripslashes($go))."&start=".$prev."&mode=$mode >".picklang($bbslang["previous_comments"])."</a>";
	}
	else if($start > 0) {
		$prev = 0;
		$outputhtml .= "&lt; <a href=$PHP_SELF?fid=$fid&tid=$tid&go=".urlencode(stripslashes($go))."&start=".$prev."&mode=$mode>".picklang($bbslang["previous_comments"])."</a>";
	}
	$outputhtml .= "</b></p></td>";
	$outputhtml .= "<td align=center width=33% nowrap><p><b>";
	//display a link to the first topic
	if($prev > - 1) $outputhtml .= "&lt;&lt; <a href=$PHP_SELF?fid=$fid&tid=$tid&go=".urlencode(stripslashes($go))."&start=0&mode=$mode >".picklang($bbslang["start"])."</a>&nbsp;&nbsp;";
	//display a link to other topics ("up")
	$outputhtml .= "[<a href=$PHP_SELF?fid=$fid>".picklang($bbslang["other_topics"])."</a>]";
	//display a link to the last topic
	if($more) $outputhtml .= "&nbsp;&nbsp;<a href=$PHP_SELF?fid=$fid&tid=$tid&go=".urlencode(stripslashes($go))."&start=last&mode=$mode>".picklang($bbslang["end"])."</a> &gt;&gt;";
	$outputhtml .= "</b></p></td>";
	$outputhtml .= "<td align=right width=33%><p><b>";
	//disply links to the next topics
	if($more) $outputhtml .= "<a href=$PHP_SELF?fid=$fid&tid=$tid&go=".urlencode(stripslashes($go))."&start=".($next-1)."&mode=$mode>".picklang($bbslang["next_comments"])."</a> &gt;";
	$outputhtml .= "&nbsp;</b></p></td>";
	$outputhtml .= "</tr>\n";
	$outputhtml .= "</table>\n";
return $outputhtml;
}

/*
* showpostheader() - used at the top of a list of comments to show the posts 
* location is the system, as well as links allowing the user to change display
* modes.
*/
######## v.1.0.0
function showpostheader($boardname, $fid, $tid, $go) {
global $reactorcolor;

	$outputhtml .= mktable("98%", $reactorcolor[3], "2");
	$outputhtml .= "<tr>";
	//display our current position
	$outputhtml .= "<td class=bordbot><p><b>&nbsp;".whereami($boardname, $fid, $go)."</b></p></td>";
	//show display mode buttons
	$outputhtml .= "<td width=60 class=bordbot nowrap>".thread_nav($fid, $go, $tid)."</td>";
	$outputhtml .= "</tr>\n";
	$outputhtml .= "</table>\n";
return $outputhtml;
}

/*
* showtopic() - OK, this one is a doozy.  it basically pulls a thread from the
* database and shows it.  the key value is $mode (flat, single, threaded, ranked)
* flat is the default - you can change the default at the top of bbs.inc.php
* single shows one post only with links to direct parts and direct children
* - this is currently used for the "threaded" mode, and will be used later for
* search engine spidering.
* threaded shows a single post and all subject links to all other posts on that
* thread - THIS PUTS THE MOST LOAD ON YOUR SERVER.  BE CAREFUL IF YOU SET THIS
* TO THE DEFAULT MODE.
* ranked shows the posts in ranked orded, from greatest to least.
*/
######## v.1.0.0
function showtopic($fid, $tid, $mode, $start, $inside) {
global $threshold, $bbslang, $reactorcolor, $icondir, $datestringlong, $boardname, $errormessage, $showmax, $go, $finaltid, $editcore, $timeadj, $forumlist, $ftable, $PHP_SELF;
//if start is set to last, query the number of children on that thread
if($start == "last") {
	$sql0 = "SELECT COUNT(*) FROM $ftable WHERE rid=$tid AND status=1";
	if($request0 = forumquery($sql0, "r")) {
		$tot = request_fetch_row($request0);
		if ($tot[0] > $showmax) {
		  $start = $tot[0] - floor($showmax/2);
		}
		else $start = 0;
	}
	else $start=0;
}
$numrows = $showmax + 1;
$next = $start + $numrows;
$more = 1;
$prev = $start - $showmax;

//if we're not being called recursively, display post and reply links and current postion in forums
if(!$inside) {
	$outputhtml .= "<p align=right><b>[<a href=post.php?fid=$fid ".jpopclick("post",400,434).">".picklang($bbslang["post_topic"])."</a>]&nbsp;&nbsp;[<a href=post.php?fid=$fid&tid=$tid ".jpopclick("post",400,434).">".picklang($bbslang["reply"])."</a>]</b>&nbsp;</p>";
	$outputhtml .= showpostheader($boardname, $fid, $tid, $go);
}
	switch ($mode) {
case "single":
//shows a single topic with links to the previous and next topics
	$sql = "SELECT  *, UNIX_TIMESTAMP(created) AS first, UNIX_TIMESTAMP(modified) AS last FROM $ftable WHERE tid=$tid AND status=1 ORDER BY created, tid LIMIT 1";
	if ($request = forumquery($sql,"r")) {
		//display one topic at a time ...
		$outputhtml .= mktable("98%", $reactorcolor[1], "2");
		if($mytopic = request_fetch_array($request)) {
			$finaltid = $mytopic["tid"];
			$outputhtml .= "<tr>";
			$outputhtml .= onepost_td($mytopic);
			$outputhtml .= "</tr>\n";
		}
		$outputhtml .= "</table>\n";
		//display the previous and next links - 
		//this is different than the other views because it only diplay direct parents and children
		$outputhtml .= mktable("98%", $reactorcolor[3], "2");
		$outputhtml .= "<tr>";
		$outputhtml .= "<td align=left width=33%><p><b>&nbsp;";
		//find and display the parent
		if(($mytopic["pid"] != $mytopic["tid"])){
			$sql2 = "SELECT tid, subject FROM $ftable WHERE (tid=".$mytopic["pid"]." AND tid != $tid) AND status=1 ORDER BY created, tid LIMIT 1";
			if ($request2 = forumquery($sql2,"r")) {
				if($myparent = request_fetch_array($request2)) {
					$outputhtml .= "&lt; <a href=$PHP_SELF?fid=$fid&tid=".$myparent["tid"]."&go=".urlencode($myparent["subject"])."&mode=";
					if ($inside) $outputhtml .= "threaded";
					else $outputhtml .= "single";
					$outputhtml .= " >".picklang($bbslang["previous"])."</a>";
				}
			}
		}
		$outputhtml .= "</b></p></td>";
		//up to category
		$outputhtml .= "<td align=center width=33%><p><b>[<a href=$PHP_SELF?fid=$fid>".picklang($bbslang["other_topics"])."</a>]</b></p></td>";
		$outputhtml .= "<td align=right width=33%><p><b>";
		//find and display any children
		if($mytopic["children"]) {
			$sql3 = "SELECT tid, subject FROM $ftable WHERE (pid=$tid AND tid!=$tid) AND status=1 ORDER BY created, tid LIMIT 1";
			if ($request3 = forumquery($sql3,"r")) {
				if($mychild = request_fetch_array($request3)) {
					$outputhtml .= "<a href=$PHP_SELF?fid=$fid&tid=".$mychild["tid"]."&go=".urlencode($mychild["subject"])."&mode=";
					if ($inside) $outputhtml .= "threaded";
					else $outputhtml .= "single";
					$outputhtml .= ">".picklang($bbslang["next"])."</a> &gt;";
				}
			}
		}
		$outputhtml .= "&nbsp;</b></p></td>";
		$outputhtml .= "</tr>\n";
		$outputhtml .= "</table>\n";
	}

break;
case "threaded":
	$sql = "SELECT rid FROM $ftable WHERE tid=$tid";
	if ($result = forumquery($sql,"r")) {
		if($myroot = request_fetch_array($result)) {
			//display one topic with single mode
			$outputhtml .= showtopic($fid, $tid, "single", $start, true);
			//find the root topic on this thread
			$sql2 = "SELECT subject, username, UNIX_TIMESTAMP(created) AS first FROM $ftable WHERE status=1 AND tid=".$myroot["rid"];
			if ($result2 = forumquery($sql2,"r")) {
				if($myroottop = request_fetch_array($result2)) {
					$outputhtml .= "<div align=left><br><p>&nbsp;&nbsp;";
					if ($myroot["rid"] != $tid) $outputhtml .= "<a href=$PHP_SELF?fid=$fid&tid=".$myroot["rid"]."&go=".urlencode($myroottop["subject"])."&mode=threaded>";
					else $outputhtml .= "<i style=\"font-size:small;\">";
					$outputhtml .= "<b>".$myroottop["subject"]."</b>";
					if ($myroot["rid"] != $tid) $outputhtml .= "</a>";
					else $outputhtml .= "</i>";
					$outputhtml .= " - ".$myroottop["username"]." - ".date($datestringlong, $myroottop["first"] + $timeadj)."";
					$outputhtml .= "</p>";
					$outputhtml .= "\n<ul>\n";
					//recursively list all children
					$outputhtml .= listchildren($fid, $myroot["rid"], $tid, 0);
					$outputhtml .= "\n</ul></div><br><br>\n";
				}
			}
		}
	}
break;
case "ranked":
	//make sure we're starting at the root topic!
	$sql0 = "SELECT rid FROM $ftable WHERE tid=$tid";
	if ($request0 = forumquery($sql0,"r")) {
		if($myroot = request_fetch_array($request0)) {
			$tid = $myroot["rid"];
		}
	}

	//the ranked mode shows the topics in a flat style, ordered by ranking.
	$sql = "SELECT  *, UNIX_TIMESTAMP(created) AS first, UNIX_TIMESTAMP(modified) AS last FROM $ftable WHERE rid=$tid AND status=1 ORDER BY rank DESC, children DESC, created LIMIT $start, $numrows";
	if ($request = forumquery($sql,"r")) {
		$outputhtml .= mktable("98%", $reactorcolor[1], "2");
		for ($i = 0; $i < $showmax; $i++) {
			if($mytopic = request_fetch_array($request)) {
				$finaltid = $mytopic["tid"];
				$bgcolor = "";
				if ($i%2) $bgcolor = $reactorcolor[2];
				if ($bgcolor) $outputhtml .= "<tr bgcolor=".$bgcolor.">";
				else $outputhtml .= "<tr>";
				$outputhtml .= onepost_td($mytopic);
				$outputhtml .= "</tr>\n";
			}
			else {
				$more = 0;
				break;
			}
		}
		if ($more) {
			if(!($mytopic = request_fetch_array($request))) $more = 0; 
		}
		$outputhtml .= "</table>\n";
		$outputhtml .= prev_nex($prev, $start, $more, $next);
	}

break;
case "flat":
default:
	//make sure we're starting at the root topic!
	$sql0 = "SELECT rid FROM $ftable WHERE tid=$tid";
	if ($request0 = forumquery($sql0,"r")) {
		if($myroot = request_fetch_array($request0)) {
			$tid = $myroot["rid"];
		}
	}
	//the default case is to show the topics in flat mode, by date of post	
	$sql = "SELECT  *, UNIX_TIMESTAMP(created) AS first, UNIX_TIMESTAMP(modified) AS last FROM $ftable WHERE rid=$tid AND status=1 ORDER BY created LIMIT $start, $numrows";
	if ($request = forumquery($sql,"r")) {
		$outputhtml .= mktable("98%", $reactorcolor[1], "2");
		for ($i = 0; $i < $showmax; $i++) {
			if($mytopic = request_fetch_array($request)) {
			  //filter out low ranked posts
			  if ($mytopic["rank"] > $threshold) {
			    $finaltid = $mytopic["tid"];
			    $bgcolor = "";
			    if ($i%2) $bgcolor = $reactorcolor[2];
			    if ($bgcolor) $outputhtml .= "<tr bgcolor=".$bgcolor.">";
			    else $outputhtml .= "<tr>";
			    $outputhtml .= onepost_td($mytopic);
			    $outputhtml .= "</tr>\n";
			  }
			}
			else {
				$more = 0;
				break;
			}
		}
		if ($more) {
			if(!($mytopic = request_fetch_array($request))) $more = 0; 
		}
		$outputhtml .= "</table>\n";
		$outputhtml .= prev_nex($prev, $start, $more, $next);
	}
break;
	}
if(!$inside) {
	//display post and reply links
	$outputhtml .= "<p align=left>&nbsp;<b>[<a href=post.php?fid=$fid ".jpopclick("post",400,434).">".picklang($bbslang["post_topic"])."</a>]&nbsp;&nbsp;[<a href=post.php?fid=$fid&tid=$finaltid ".jpopclick("post",400,434).">".picklang($bbslang["reply"])."</a>]</b></p>";
}
return $outputhtml;
}

/*
* incrementforumtotal() - adds one post to the forum total for $fid
* uses "w" permissions
*/
######## v.1.0.0
function incrementforumtotal($fid) {
global $forumlist;
	//update to new value
	$sql2 = "UPDATE $forumlist SET totalposts=totalposts+1 WHERE fid=$fid";
	if ($request2 = forumquery($sql2,"w")) {
		return true;
	}
	else return false;
}

/*
* createtopic() - inserts a new topic into the database.
* 1. determines the rank of the topic
* 2. inserts it into the appropriate table
* 3. updates the posts total in the parent forum
* 4. updates the post total of the user
* uses all "w" permissions
*/
######## v.1.0.0
function createtopic($fid, $myuser, $subject, $body, $mailreply) {
global $errormessage, $mytid,$forumlist, $ftable;
$rank = 0;
//convert the body to be stored in the database
$body = convertpost($body);
//set the user status
$userstatus = quickuserstatus($myuser["posts"], $myuser["admin"]);
//determine rank from user status
$rank = setpostrank($myuser["admin"], $myuser["posts"]);
	
	//insert the topic into the appropriate table
	$sql = "INSERT INTO $ftable (tid, pid, rid, children, subject, body, username, user_addr, mailreply, rank, status, modified, created, lastip, userstatus) VALUES (NULL, 0, 0, 0, '".$subject."', '".$body."', '".$myuser["username"]."', '".getenv("REMOTE_ADDR")."', ".$mailreply.", ".$rank.", 1, NULL, NULL, '".getenv("REMOTE_ADDR")."', '".$userstatus."')";
	if($request = forumquery($sql,"w")) {
		$mytid = get_insert_id($ftable."_tid_seq");
		//set pid and rid to the appropriate values
		$sql2 = "UPDATE $ftable SET pid=$mytid, rid=$mytid WHERE tid=$mytid";
		if ($request2 = forumquery($sql2,"w")) {
			//update forum count (totalposts)
			if (incrementforumtotal($fid)) {
				//update user posts
				if (updateuserposts($myuser["username"], 1)) {
					return true;
				}
				else return false;
			}
			else return false;
		}
		else return false;
	}
	else return false;
}

/*
* mailuser() - mails an email replay to a user's comment. 
* mails the replya as plain text with a link to the topic.
*/
######## v.1.0.0
function mailuser($parentusername, $childusername, $childemail, $subject, $body, $ip, $fid, $tid) {
global $bbslang, $errormessage, $reactorcore, $reactortagline, $boardname, $userstable;
	$intro = "\n\n".picklang($bbslang["regarding_topic"]).":\n\n".$reactorcore."/".$boardname."/browse.php?fid=$fid&tid=$tid\n\n";
	$body = $intro.stripslashes($body).$reactortagline;
	$headers = "From: \"".$childusername."\" <".$childemail.">\nReply-To: ".$childemail."\nX-Originating-IP: ".$ip."\nX-Mailer: PHP/" . phpversion();
	//query parent's email address
	$sql = "SELECT email FROM $userstable WHERE username='".$parentusername."'";
	if($request = users_query($sql,"r")) {
		$myparent = request_fetch_array($request);
		$parentemail = $myparent["email"];
		mailfrom($childemail, $parentemail, $parentusername, $subject, $body, $headers);
	}
}

/*
* addcomment() - very similar to createtopic() - except this one updates the
* parent and root topics' children count.
* uses all "w" permissions
*/
######## v.1.0.0
function addcomment($fid, $tid, $rid, $myuser, $subject, $body, $mailreply) {
global $errormessage, $forumlist, $ftable;
$rank = 0;
//convert the body for storing in the database
$body = convertpost($body);
//set the user status
$userstatus = quickuserstatus($myuser["posts"], $myuser["admin"]);
//determine rank from user status
$rank = setpostrank($myuser["admin"], $myuser["posts"]);
	
	//insert the comment into the appropriate table
	$sql = "INSERT INTO $ftable (tid, pid, rid, children, subject, body, username, user_addr, mailreply, rank, status, modified, created, lastip, userstatus) VALUES (NULL, $tid, $rid, 0, '".$subject."', '".$body."', '".$myuser["username"]."', '".getenv("REMOTE_ADDR")."', ".$mailreply.", ".$rank.", 1, NULL, NULL, '".getenv("REMOTE_ADDR")."', '".$userstatus."')";
	if($request = forumquery($sql,"w")) {
		//update root topic (rid) count
		$sql7 = "UPDATE $ftable SET children=children+1 WHERE tid=$rid";
		if ($request7 = forumquery($sql7,"w")) {}
		else return false;
		//update parent comment count
		if ($tid != $rid) {
			$sql9 = "UPDATE $ftable SET children=children+1 WHERE tid=$tid";
			if ($request9 = forumquery($sql9,"w")) {}
			else return false;
		}
		//update forum count
		if (incrementforumtotal($fid)) {
			//update user posts
			if (updateuserposts($myuser["username"], 1)) {
				return true;
			}
			else return false;
		}
		else return false;
	}
	else return false;
}

/*
* makelinks - this adds hyperlinks to a post.  The hyperlinks must be surrounded
* by whitespace (this prevents A and IMG tags from getting screwed up/
*/
######## v.1.0.0
function makelinks($body) {
	$body=eregi_replace("([ \n\t]+)([http|news|ftp]+://[^ >\n\t]+)", "\\1<a href=\"\\2\" target=\"_blank\">\\2</a>", $body);	
	return $body;
}

/*
* changerank() - just increments or decrements the rank of a certain post.
* does not allow for someone from the same ip to rank a post twice in a row.
* uses "w" permissions
*/
######## v.1.0.0
function changerank($fid, $tid, $rank) {
global $bbslang, $reactorcolor, $errormessage, $forumlist, $ftable;
	//check lastip
	$sql = "SELECT username, rank, lastip, modified FROM $ftable WHERE tid=$tid";
	if($request = forumquery($sql,"w")) {
		if($myranking = request_fetch_array($request)) {
			if (getenv("REMOTE_ADDR") == $myranking["lastip"]) {
				$outputhtml .= "<center><font face=verdana size=4 color=#ff0000><b>".picklang($bbslang["double_vote"])."</b></font></center>";
			}
			else {
				if ($rank == "up") {
				  $newrank = $myranking["rank"] + 1;
				  $increment = 1;
				}
				else if ($rank == "dn") {
				  $newrank = $myranking["rank"] - 1;
				  $increment = -2;
				}
				$sql2 = "UPDATE $ftable SET rank=$newrank, lastip='".getenv("REMOTE_ADDR")."', modified=".$myranking["modified"]." WHERE tid=$tid";
				if ($request2 = forumquery($sql2,"w")) {
				// now update user table (#posts like karma)
				// +1 posts for rank up, -2 posts for rank down
				  if (updateuserposts($myranking["username"], $increment)) {
				    $outputhtml .= "<center><font face=verdana size=4 color=".$reactorcolor[0]."><b>".picklang($bbslang["thank_opinion"])."</b></font></center>";
				  }
				}
			}
		}
	}
	return $outputhtml;
}

/*
* getprofile() - show the information for this user, as well as their acitivty
* on this board (by fid).
*/
######## v.1.0.0
function getprofile($username) {
global  $allowsearches, $bbslang, $userstable, $reactorcolor, $reactorcore, $errormessage, $datestringshort, $boardname, $forumlist, $showmax, $PHP_SELF;

	//show basic information
	$outputhtml .= userprofile($username);
	//show post totals from each forum
	$sql2 = "SELECT fid, fmname FROM $forumlist WHERE status=1";
	if ($request2 = forumquery($sql2,"r")) {
		$outputhtml .= mktable("90%",$reactorcolor[1], "2");
		$outputhtml .= "<tr>";
		$outputhtml .= "<td><p><b>".picklang($bbslang["recent_activity"])." $boardname:</b></p><ul>";
		while ($myresult = request_fetch_array($request2)) {
			$myftable = $forumlist."topics".$myresult["fid"];
			$sql3 = "SELECT COUNT(*) AS count FROM $myftable WHERE username='".$username."' AND status=1";
			if($request3 = forumquery($sql3,"r")) {
				if($mycount = request_fetch_array($request3)) {
					if($mycount["count"]) {
						//this should be linked to a search by username - done :)
						$outputhtml .= "\n<li style=\"color:".$reactorcolor[0].";\"><p> <a href=$PHP_SELF?fid=".$myresult["fid"].">".$myresult["fmname"]."</a> : ";
						if($allowsearches) $outputhtml .= "<a href=search.php?fid=".$myresult["fid"]."&query=".urlencode($username).">";
						$outputhtml .= $mycount["count"]." ".picklang($bbslang["comments"]);
						if($allowsearches) $outputhtml .= "</a>";
						$outputhtml .= "</p>";
					}
				}
			}
		}
		$outputhtml .= "</ul></td>";
		$outputhtml .= "</tr>\n";
		$outputhtml .= "</table>\n";
	}
return $outputhtml;
}

/*
* getrecent() gets all topics modified (replied to) in the past 24 hours ...
* it gets the topics for a specific fid
*/
######## v.1.0.0
function getrecent($fid,$forum,$start,$top) {
global $bbslang, $reactorcolor, $boardname, $datestringlong, $errormessage, $icondir, $showmax, $timeadj, $forumlist, $PHP_SELF;
//we specify this one because it runs throught several forums
$ftable = $forumlist."topics".$fid;
$cutoff = time() - 86400;//24 hrs ago
$numrows = $showmax + 1;
$next = $start + $numrows;
$more = 1;
$prev = $start - $showmax;
$amnotempty = 0;
	
	//query root topics which have changed
	$sql = "SELECT DISTINCT t.tid, t.subject, t.username, t.children, UNIX_TIMESTAMP(t.modified) AS last FROM $ftable t, $ftable r WHERE (t.tid=r.rid AND t.status=1) AND UNIX_TIMESTAMP(t.modified) > $cutoff ORDER BY t.modified DESC LIMIT $start, $numrows";
	if ($request = forumquery($sql,"r")) {
		for ($i = 0; $i < $showmax; $i++) {
			if($mytopic = request_fetch_array($request)) {
				$amnotempty = 1;
				if ($i == 0) {
					//top of forum list - start a table
					$outputhtml .= mktable("98%", $reactorcolor[1], "2");
					$outputhtml .= "<tr bgcolor=".$reactorcolor[3].">";
					$outputhtml .= "<td width=50% class=bordbot ><p><b>&nbsp;<a href=$PHP_SELF>".$boardname."</a> : <a href=$PHP_SELF?fid=$fid>".$forum."</a></b></p></td>";
					$outputhtml .= "<td class=bordbot align=center>";
					//top of page, show a column heading
					if ($top) $outputhtml .= "<p><b>".picklang($bbslang["last_post"])."</b></p>";
					else $outputhtml .= "&nbsp;";
					$outputhtml .= "</td>";
					$outputhtml .= "<td class=bordbot colspan=2 width=60>";
					//top of page
					if ($top) $outputhtml .= "<p>&nbsp;<b>".picklang($bbslang["comments"])."</b></p>";
					else $outputhtml .= "&nbsp;";
					$outputhtml .= "</td>";
					$outputhtml .= "</tr>\n";
				}
				$bgcolor = "";
				if ($i%2) $bgcolor = $reactorcolor[2];
				if ($bgcolor) $outputhtml .= "<tr bgcolor=".$bgcolor.">";
				else $outputhtml .= "<tr>";
				$outputhtml .= "<td><p>&nbsp;<b><a href=$PHP_SELF?fid=$fid&tid=".$mytopic["tid"]."&go=".urlencode($mytopic["subject"]).">".$mytopic["subject"]."</a></b> - ".$mytopic["username"]."</p></td>";
				$outputhtml .= "<td align=center><a href=$PHP_SELF?fid=$fid&tid=".$mytopic["tid"]."&go=".urlencode($mytopic["subject"])."&start=last >".date($datestringlong, $mytopic["last"] + $timeadj)."</a></td>";
				//$outputhtml .= "<td align=center>".date($datestringlong, $mytopic["last"] + $timeadj)."</td>";
				$outputhtml .= "<td>&nbsp;<b>".$mytopic["children"]."</b>&nbsp;</td>";
				$outputhtml .= "<td bgcolor=".$reactorcolor[4]." width=60 nowrap>".thread_nav($fid, $mytopic["subject"], $mytopic["tid"])."</td>";
				$outputhtml .= "</tr>\n";
			}
			else {
				$more = 0;
				break;
			}
		}
		if ($more) {
			if(!($mytopic = request_fetch_array($request))) $more = 0; 
		}
		if ($amnotempty) {
			$outputhtml .= "</table>\n";
			$outputhtml .= mktable("98%", $reactorcolor[3], "2");
			$outputhtml .= "<tr>";
			$outputhtml .= "<td align=center width=33% class=bordtop>";
			if($prev > - 1) {
				$outputhtml .= "<p>&nbsp;&lt;&lt; <a href=$PHP_SELF?active=1&start=".$prev.">".picklang($bbslang["prev_topics"])."</a></p>";
			}
			else if($start > 0) {
				$prev = 0;
				$outputhtml .= "<p>&nbsp;&lt;&lt; <a href=$PHP_SELF?active=1&start=".$prev.">".picklang($bbslang["prev_topics"])."</a></p>";
			}
			else $outputhtml .= "&nbsp;";
			$outputhtml .= "</td>";
			$outputhtml .= "<td align=center width=33% class=bordtop>&nbsp;</td>";
			$outputhtml .= "<td align=center width=33% class=bordtop>";
			if($more) $outputhtml .= "<p><a href=$PHP_SELF?active=1&start=".($next - 1).">".picklang($bbslang["next_topics"])."</a> &gt;&gt;&nbsp;</p>";
			else $outputhtml .= "&nbsp;";
			$outputhtml .= "</td>";
			$outputhtml .= "</tr>\n";
			$outputhtml .= "</table>\n";
		}
	}
return $outputhtml;
}

/*
* allrecent() - this function queries which forums have been active in the past
* 24 hours and feeds them to getrecent().
*/
######## v.1.0.0
function allrecent() {
global $bbslang, $forumlist, $start;
$cutoff = time() - 86400;//24 hrs ago
	$outputhtml .= "<br>\n<h2 align=left>&nbsp;".picklang($bbslang["today_active_topics"]).":</h2>";
	$sql = "SELECT fmname, fid FROM $forumlist WHERE UNIX_TIMESTAMP(modified) > $cutoff ORDER BY modified DESC";
	if ($request = forumquery($sql,"r")) {
		$i = 0;
		while ($mynew = request_fetch_array($request)) {
			if ($i == 0) $top = 1;
			$outputhtml .= getrecent($mynew["fid"],$mynew["fmname"], $start, $top);
			$top = 0;
			$i++;
		}
	}
	$outputhtml .= "<br>\n";
return $outputhtml;
}

/*
* requestforum() - this is a request for a subforum.  It just build a link to 
* the approriate admin script and mails it to the reactor administrator.  The
* admin can then decide if he want to add the forums or not.
*/
######## v.1.0.0
function requestforum($moderator, $boardname, $pfid, $fmname, $descr) {
global $REMOTE_ADDR, $errormessage, $reactoradmin, $reactorcore, $reactortagline, $forumlist, $ftable;

	//here, just build a link to the admin function which will add the new forum and mail it
	//find the root.
	$sql = "SELECT rfid FROM $forumlist WHERE fid=$pfid";
	if ($request = forumquery($sql, "r")) {
		$myroot = request_fetch_array($request);
		$createlink = $reactorcore."/$boardname/admin/index.php?";
		$createlink = $createlink."rfid=".$myroot["rfid"];
		$createlink = $createlink."&pfid=$pfid&moderator=".urlencode($moderator);
		$createlink = $createlink."&fmname=".urlencode(stripslashes($fmname));
		$createlink = $createlink."&descr=".urlencode(stripslashes($descr));
		$addheaders = "From: \"Reactor Admin\" <$reactoradmin>\nReply-To: $reactoradmin\nX-Originating-IP: ".$REMOTE_ADDR."\nX-Mailer: PHP/" . phpversion();
		$body = "hello $reactoradmin.\n[$moderator] has requested a new forum\ncalled [$fmname]\nabout [$descr].\ntake a look at it and if its cool, click the link below to start it up\n\n";
		$body .= $createlink.$reactortagline;
		mail($reactoradmin,"REQUEST FOR NEW FORUM",$body,$addheaders);
		//for debugging
		#echo nl2br($body);
		return true;
	}
	else $errormessage .= "we could not create your forum.  please try again or contact $reactoradmin.";
}

/*
* tokenize_query() - takes a wuery string and breaks it into search tokens
* this could use a little work - discarding similar tokens
*/
######## v.1.0.0
function tokenize_query($query) {
	$query = strtoupper($query);//make case-insensitive
	//break into array by quotes - to keep phrases together
	$tokens = explode('"', $query);
	$num = count($tokens);
	$s = 0;
	//break each of those tokens up into pieces and add them to the tokens array
	for ($i=0;$i<$num;$i++) {	
		$innertokens = explode(" ", trim($tokens[$i]));
		if(count($innertokens) > 1) {
			for($t=0;$t<count($innertokens);$t++) {
				if(trim($innertokens[$t])) {
					$tokens[$num + $s] =  trim($innertokens[$t]);
					$s++;
				} 
			}
		}
	}
	//now, check for repeated tokens and eliminate
	for($x=0;$x<count($tokens);$x++) {
		if($tokens[$x]) {
			for($y=$x+1;$y<count($tokens);$y++) {
				if (trim($tokens[$x]) == trim($tokens[$y])) {
					$tokens[$y] = "";
				}
			}
		}
	}
	
	return $tokens;
}

/*
* search_forum() - does a search of username, subject, body in a single fid.
* stores the results in a temporary table for sorting. must be used in
* conjunction with do_full_search()
* NEEDS OPTIMIZATION!
*/
######## v.1.0.0
function search_forum($fid, $tokens) {
global $forumlist, $temptable;
$ftable = $forumlist."topics".$fid;
static $first = true;
	
	//build sql statement
	if($first) {
#		$sql = "CREATE TEMPORARY TABLE tmp\n";//mysql 3.23+
		$sql0 = "CREATE TABLE ".$temptable." (fid INT NOT NULL, tid INT NOT NULL, username VARCHAR(20), subject VARCHAR(60), created INT, jumble TEXT, PRIMARY KEY(fid, tid))";
		if ($request0 = forumquery($sql0, "f")) {}
		else return false;
		$first = false;
	}
	//add the tokens to the sql statement
	for ($i=0;$i<count($tokens);$i++) {	
		//check for existence
		if (trim($tokens[$i])) {
#			$sql .= "INSERT INTO tmp\n";//mysql 3.23+
			$sql = "INSERT INTO ".$temptable."\n";
			$sql .= "SELECT  '".$fid."' AS fid, tid, username, subject, UNIX_TIMESTAMP(created) AS created, UPPER(CONCAT(username, subject, body)) AS jumble FROM $ftable WHERE UPPER(CONCAT(username, subject, body)) LIKE";
			$sql .= " '%".trim($tokens[$i])."%' AND status=1 "; // make sure topic hadn't been deleted
			if($request = forumquery($sql, "w")) {}
			else return false;
		}
	}
	return true;
}

/*
* forum_array() returns a list of existing fid and fmname for all forums
*/
######## v.1.0.0
function forum_array() {
global $forumlist;
		//get array of all forums
		$sql1 = "SELECT fid, fmname FROM $forumlist WHERE status=1";
		if($request1 = forumquery($sql1, "r")) {
			while($myforum = request_fetch_array($request1)) {
				$forumarray[$myforum["fid"]] = $myforum["fmname"];
			}
			return $forumarray;
		}
		else return false;
}

/*
* do_full_search() - searches every forum, order results by their position in
* the original query string
*/
######## v.1.0.0
function do_full_search($query, $fid, $forumarray) {
global $forumlist, $start, $showmax, $prev, $temptable, $numresults;
	//tokenize query string
	$tokens = tokenize_query($query);
	if($fid) {
		//search in a distinct forum
		search_forum($fid, $tokens);
	}
	else {
		//cycle through each forum
	  foreach ($forumarray as $myfid => $fmname) {
                     search_forum($myfid, $tokens);   
	  }
	}
	//get number of results
	$sql5 = "SELECT COUNT(*) AS count FROM $temptable";
	if($request5 = forumquery($sql5, "r")) {
		$myresult = request_fetch_array($request5);
		$numresults = $myresult["count"];
	}
	//set offset if start=last
	if($start == "last") {
		$start = $numresults - floor($showmax/2);
		$prev = $start - $showmax;
	}
	//get results from searchtemp - try ordering?
	$sql4 = "SELECT * ";
	for($i=0;$i<count($tokens);$i++) {
		if(trim($tokens[$i])) {
			$sql4 .= ", LOCATE('".trim($tokens[$i])."',CONCAT(jumble,'".trim($tokens[$i])."')) AS loc$i";
		}
	}
#	$sql4 .= " FROM tmp ORDER BY ";//mysql 3.23+
	$sql4 .= " FROM ".$temptable." ORDER BY ";
	for($i=0;$i<count($tokens);$i++) {
		if(trim($tokens[$i])) {
			$sql4 .= " loc$i, ";
		}
	}
	//add limit statement
	$sql4 .= " created DESC LIMIT $start, ".($showmax + 1);
	//execute query
	$request4 = forumquery($sql4, "r");
	//drop temp table
#	$sql5 = "DROP TABLE tmp";//mysql 3.23+
	$sql5 = "DROP TABLE ".$temptable;
	if($request5 = forumquery($sql5, "f")) {
		return $request4;
	}
	else return false;
}

/*
* searchbox() - displays a form to input a query
*/
######## v.1.0.0
function searchbox($query, $fid, $forumarray) {
global $PHP_SELF, $bbslang;

	$outputhtml = "<form action=$PHP_SELF method=get enctype=application/x-www-form-urlencoded>";
	$outputhtml .= picklang($bbslang["search_for"]).": <input type=text name=query value=\"".str_replace('"', "&quot;", $query)."\" size=20 maxlength=60>&nbsp;";//'
	$outputhtml .= "&nbsp;&nbsp;".picklang($bbslang["search_in"]).": <select name=fid>";
	$outputhtml .= "<option value=\"\" ".((!$fid)? "selected": "").">".picklang($bbslang["search_all_forums"])."</option>"; 
//make forum list
 foreach ($forumarray as $myfid => $fmname) {
   $outputhtml .= "<option value=\"".$myfid."\" ";
   $outputhtml .= ($fid == $myfid)? "selected": " ";
   $outputhtml .= ">".$fmname."</option>";
 }
                     
	$outputhtml .= "</select>&nbsp;";
	$outputhtml .= "<input type=submit value=\"".picklang($bbslang["search"])." &gt;&gt;\">";
	$outputhtml .= "</form>\n";
return $outputhtml;
}

/*
* search() - formats the output of a search all nice and pretty
*/
######## v.1.0.0
function search($fid, $query, $start) {
global $PHP_SELF, $reactorcore, $boardname, $prev, $errormessage, $showmax, $temptable, $numresults, $bbslang, $datestringshort;
$numrows = $showmax + 1;
$next = $start + $numrows;
$more = 1;
$prev = $start - $showmax;

	//first, find out the forums
	$forumarray = forum_array();
	//if query is set, do a search
	if($query) {
		$searchresults = do_full_search($query, $fid, $forumarray);
		$outputhtml .= "<p>&nbsp;<b><a href=$reactorcore/$boardname/>$boardname</a> : ".picklang($bbslang["search_for"])." :</b> ".$query." : ".$numresults." ".picklang($bbslang["topics"])."</p>";
		//show the results (tabled to counter centering)
		$outputhtml .= "\n<table align=center width=98%>";
		$outputhtml .= "<tr>";
		$outputhtml .= "<td><ul>\n";
		for($i=0;$i<$showmax;$i++) {
			$myresult = request_fetch_array($searchresults);
			if($myresult) {
				$outputhtml .= "<li> <p><b><a href=browse.php?fid=".$myresult["fid"]."&tid=".$myresult["tid"]."&go=".urlencode($myresult["subject"])."&mode=threaded >".$myresult["subject"]."</a></b> - ".$myresult["username"]." - ".date($datestringshort, $myresult["created"] + $timeadj)."</p>\n";
			}
			else {
				$more = 0;
				break;
			}
		}
		$outputhtml .= "</ul></td>";
		$outputhtml .= "</tr>\n";
		$outputhtml .= "</table>\n";
		//show prev next links
		if($more) {
			if(!($myresult = request_fetch_array($searchresults))) $more = 0;
		}
		$outputhtml .= "<table>";
		$outputhtml .= "<tr>";
		$outputhtml .= "<td align=left width=33%><p><b>&nbsp;";
		//display links to previous topics if they exist
		if($prev > - 1) {
			$outputhtml .= "&lt; <a href=$PHP_SELF?fid=$fid&query=".urlencode(stripslashes($query))."&start=".$prev." >".picklang($bbslang["previous"])."</a>";
		}
		else if($start > 0) {
			$prev = 0;
			$outputhtml .= "&lt; <a href=$PHP_SELF?fid=$fid&query=".urlencode(stripslashes($query))."&start=".$prev.">".picklang($bbslang["previous"])."</a>";
		}
		$outputhtml .= "</b></p></td>";
		$outputhtml .= "<td align=center width=33% nowrap><p><b>";
		//display a link to the first topic
		if($prev > - 1) $outputhtml .= "&lt;&lt; <a href=$PHP_SELF?fid=$fid&query=".urlencode(stripslashes($query))."&start=0>".picklang($bbslang["start"])."</a>";
		$outputhtml .= "&nbsp;&nbsp;";
		//display a link to the last topic
		if($more) $outputhtml .= "<a href=$PHP_SELF?fid=$fid&query=".urlencode(stripslashes($query))."&start=last>".picklang($bbslang["end"])."</a> &gt;&gt;";
		$outputhtml .= "</b></p></td>";
		$outputhtml .= "<td align=right width=33%><p><b>";
		//disply links to the next topics
		if($more) $outputhtml .= "<a href=$PHP_SELF?fid=$fid&query=".urlencode(stripslashes($query))."&start=".($next-1).">".picklang($bbslang["next"])."</a> &gt;";
		$outputhtml .= "&nbsp;</b></p></td>";
		$outputhtml .= "</tr>\n";
		$outputhtml .= "</table>\n";
		$outputhtml .= "<br>\n<br>\n";
	}
	//show searchbox
	$outputhtml .= searchbox($query, $fid, $forumarray);
	if ($errormessage) $outputhtml .= "<br>\n<br>\n<p style=\"color:#ff0000;\"><b>$errormessage</b></p>";

return $outputhtml;
}

#######v.1.0.0
function get_commentboard_id($commentname) {
   global $errormessage;
   $sql="SELECT fid FROM comments WHERE fmname='$commentname'";
   if(!$request=forumquery($sql,"r")) {
       echo $errormessage; return false;
    }
   $row=request_fetch_array($request);
   return $row["fid"];
}


?>
