<?php
/*
* Copyright (C) 1999-2000 EKILAT LLC (http://ekilat.com - the first reactor)
* 
* php(REACTOR) is open source; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License <http://www.opensource.org/licenses/gpl-license.html>
* for a complete version of the license.
*
** bbspost.inc.php - this file contain all the posting functions for the bbs system
*/
//ALWAYS INCLUDE THIS
if(!defined("REACTOR_INC_GLOBAL")) { include("inc/global.inc.php"); }
//check for banned ip.
filterbannedips();
//INCLUDE DB FUNCTIONS
if(!defined("REACTOR_INC_DB")) { include($pathtohomedir."/inc/db.inc.php"); }
//INCLUDE BBS FUNCTIONS
if(!defined("REACTOR_INC_BBS")) { include($pathtohomedir."/inc/bbs.inc.php"); }
//INCLUDE LANGUAGE FUNCTIONS
if(!defined("REACTOR_INC_LANG")) { include($pathtohomedir."/inc/lang.inc.php"); }
//INCLUDE USERS FUNCTIONS
if(!defined("REACTOR_INC_USERS")) { include($pathtohomedir."/inc/users.inc.php"); }

//INCLUDE CONF
if(!defined("REACTOR_CONF_BBSPOST")) { include($pathtohomedir."/conf/bbspost.conf.php"); }


$myuser = "";
//watch out for scary stuff	
$fid = strip_tags($fid);
$fid = eregi_replace("[^[:digit:]]","", $fid);
$tid = strip_tags($tid);
$tid = eregi_replace("[^[:digit:]]","", $tid);
$rid = strip_tags($rid);
$rid = eregi_replace("[^[:digit:]]","", $rid);
$username = strip_tags($username);
$username = eregi_replace("[^[:alnum:]\._]","", $username);
$password = strip_tags($password);
$subject = strip_tags($subject);
$body = trim(strip_tags($body, $allowedtags));
$mailreply = strip_tags($mailreply);
$myaction = "post";
$returnto = $PHP_SELF."?fid=$fid&tid=$tid";
//intialize mailreply
if(!$mailreply) $mailreply = "0";

if ($fid && $upload) {
	//censor input
	$subject = censor($subject, $badwords);
	$body = censor($body, $badwords);
	//check for existence
	if($subject == "") $errormessage .= picklang($postlang["err_no_subject"])."<br>\n";
	else if($body == "")  $errormessage .= picklang($postlang["err_no_body"])."<br>\n";
	else {
		//validate user
		$myuser = verifyuser(&$username, &$password, $bbs_login, $bbs_public_key, $returnto);
	}
	if($myuser) {
		if (!$errormessage) {
			//if we get here that means we're validated
			//log user into the system
			bbs_login($username);
			if(!$tid) {
				//insert a new topic
				if(createtopic($fid, $myuser, $subject, $body, $mailreply)) {			
					$tpl_title = picklang($postlang["success"]);
					//javascript wich automatically closes the window
					$tpl_message = "<script type=text/javascript>\n<!-- \n	opener.location = \"$reactorcore/$boardname/browse.php?fid=$fid\";\n	window.close();\n//-->\n</script>\n";
					$tpl_message .= picklang($postlang["topic_success"]);
					$tpl_message .= "<br><br><a href=$reactorcore/$boardname/browse.php?fid=$fid>".picklang($postlang["to_topic"])."</a>";
					//include simple template
					include($pathtohomedir."/templates/simple.tpl.php");
					exit;
				}
			} 
			else {
				//check for $rid
				if($rid == "") $errormessage .= "sorry, unknown parent<br>";
				else {
					//insert a comment
					if(addcomment($fid, $tid, $rid, $myuser, $subject, $body, $mailreply)){
						$tpl_title = picklang($postlang["success"]);
						//javascript wich automatically closes the window
						$tpl_message = "<script type=text/javascript>\n<!-- \n	opener.location.reload();\n	window.close();\n//-->\n</script>\n";
						$tpl_message .= picklang($postlang["comment_success"]);
						$tpl_message .= "<br><br><a href=$reactorcore/$boardname/browse.php?fid=$fid&tid=$tid&go=".urlencode($subject).">".picklang($postlang["to_topic"])."</a>";
						//include simple template
						include($pathtohomedir."/templates/simple.tpl.php");
						exit;
					}
				}
			}
		}			
	}
}

if (!$upload || $errormessage) {
	if (!$fid) $errormessage .= "sorry, it is unclear which forum you wish to post to.  close this window and try again.<br>";
	else if (!$tid) {
		$quote = "";
		$myaction = picklang($postlang["post_topic"]);
	}
	else {
		$myaction = picklang($postlang["comment"]);
		$sql = "SELECT username, subject, body, rid, mailreply, closed FROM $ftable WHERE tid=$tid AND status=1";
		if($request = forumquery($sql,"w")) {
			$mytopic = request_fetch_array($request);
			$previousedits = strstr($mytopic["body"],$editkey);
			if ($previousedits) 
				$quote = "\n\n**********\n".picklang($postlang["according_to"])." ".$mytopic["username"]." ...\n\n".str_replace('"',"&quot;",revertpost(str_replace($previousedits, "", $mytopic["body"])))."\n**********\n";
			else 
				$quote = "\n\n**********\n".picklang($postlang["according_to"])." ".$mytopic["username"]." ...\n\n".str_replace('"',"&quot;",revertpost($mytopic["body"]))."\n**********\n";
			if(!strstr($mytopic["subject"], "Re: ")) $subject = "Re: ".$mytopic["subject"];
			else $subject = $mytopic["subject"];
			if($mytopic["closed"]) {
				$tpl_title = picklang($postlang["sorry"]);
				$tpl_message = picklang($postlang["closed_msg"]);
				//include simple template
				include($pathtohomedir."/templates/simple.tpl.php");
				exit;
			}
		}
	}


?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">

<html>
<head>
	<title><?php echo $boardname." : ".$myaction;?></title>
<meta http-equiv="content-type" content="text/html;charset=iso-8859-1">
<?php stylepicker(); ?>
<script type="text/javascript" src="<?php echo "$reactorcore"; ?>/global.js"></script>
</head>
<body bgcolor="<?php echo $reactorcolor[1];?>">
<center><font color="#ff0000" size="4" face="verdana, arial, sans-serif"><b><?php echo $errormessage; ?></b></font></center>
<hr align="center" color="<?php echo $reactorcolor[0];?>" width="100%" size="2">
<form name="pstfrm" enctype="application/x-www-form-urlencoded" action="<?php echo $PHP_SELF ;?>" method="post">
<input type="hidden" name="fid" value="<?php echo $fid;?>">
<input type="hidden" name="tid" value="<?php echo $tid;?>">
<input type="hidden" name="rid" value="<?php echo $mytopic["rid"];?>">
<table align=center width=95% bgcolor="<?php echo $reactorcolor[2];?>" cellpadding=2 cellspacing=0>
<?php bbs_login_box($bbs_login, $bbs_public_key); ?>
<tr><td align="right"><p><b><?php echo picklang($postlang["subject"]); ?>:</b></p></td><td width="80%"><input type="text" name="subject" value="<?php echo stripslashes($subject);?>" size="25" maxlength="60"></td></tr>
<tr><td colspan="2"><hr align="center" color="<?php echo $reactorcolor[0];?>" width="100%" size="1"></td></tr>
<tr><td valign="top"><p><b><?php echo picklang($postlang["comment"]); ?>:</b></p></td><td align=right><input name=italics type=button value="&lt;i&gt;" onclick="toitalic();"><input name=bold type=button value="&lt;b&gt;" onclick="tobold();"><input name=insert type=button value="&lt;img&gt;" onclick="insertimg();"><input name=encode type=button value="&lt;code&gt;" onclick="makecode();">&nbsp;</td></tr>
<tr><td colspan="2" align="center"><textarea name="body" cols="35" rows="9" wrap="virtual"><?php echo textarea_prep(stripslashes($body));?></textarea>
<br><?php echo picklang($postlang["allowed_tags"]); ?>: <?php echo htmlspecialchars(str_replace(",", " ", $allowedtags)); ?></td></tr>
<tr><td colspan="2"><hr align="center" color="<?php echo $reactorcolor[0];?>" width="100%" size="1"></td></tr>
<?php if($allowemailreplies) { ?>
<tr><td colspan="2"><input type="checkbox" name="mailreply" value="1" <?php if($mailreply) echo "checked";?> style="background-color:<?php echo $reactorcolor[2];?>;"> <?php echo picklang($postlang["mailreply_msg"]); ?></td></tr>
<?php } ?>
<tr><td colspan="2" align="center">
<?php if ($quote) { ?>
<input type="hidden" name="quote" value="<?php echo $quote; ?>"><input type="button" value="^ topik ^" onclick="javascript: this.form.body.value = this.form.body.value + this.form.quote.value; this.form.quote.value = '';">
<?php } ?>
&nbsp;<input type="button" value="<?php echo picklang($postlang["cancel"]); ?>" onclick="javascript:window.close();">&nbsp;<input type="submit" name="upload" value="<?php echo picklang($postlang["post"]); ?> &gt;&gt;" style="font-weight:bold;"> (<?php echo picklang($postlang["click_once"]); ?>!)</td></tr>
</table>
</form>
<hr align="center" color="<?php echo $reactorcolor[0];?>" width="100%" size="2">
</body>
</html>
<?php 
} 
?>
