<?php
/*
/*
* Copyright (C) 1999-2000 EKILAT LLC (http://ekilat.com - the first reactor)
* 
* php(REACTOR) is open source; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License <http://www.opensource.org/licenses/gpl-license.html>
* for a complete version of the license.
*
** bbsrequestforum.inc.php - add new forum
* AT THIS TIME THIS FUNCTION ONLY SEND A REQUEST EMAIL
* WHICH INCLUDES 1-click INFO FOR ADMINS TO ADD THE FORUM
* IN THE FUTURE, IT MAY BE FULLY AUTOMATED.  AND MAYBE NOT :)
* uses "r" permissions
*/
//ALWAYS INCLUDE THIS
if(!defined("REACTOR_INC_GLOBAL")) { include("inc/global.inc.php"); }
//check for banned ip.
filterbannedips();
//INCLUDE DB FUNCTIONS
if(!defined("REACTOR_INC_DB")) { include($pathtohomedir."/inc/db.inc.php"); }
//INCLUDE LANGUAGE FUNCTIONS
if(!defined("REACTOR_INC_LANG")) { include($pathtohomedir."/inc/lang.inc.php"); }
//INCLUDE USERS FUNCTIONS
if(!defined("REACTOR_INC_USERS")) { include($pathtohomedir."/inc/users.inc.php"); }
//INCLUDE BBS FUNCTIONS
if(!defined("REACTOR_INC_BBS")) { include($pathtohomedir."/inc/bbs.inc.php"); }

//INCLUDE CONF
if(!defined("REACTOR_CONF_BBSREQUESTFORUM")) { include($pathtohomedir."/conf/bbsrequestforum.conf.php"); }


//validate input
$username = strip_tags($username);
$username = eregi_replace("[^[:alnum:]\._]","", $username);
$password = strip_tags($password);
$fmname = substr(strip_tags($fmname), 0, 40);
$fid = strip_tags($fid);
$fid = eregi_replace("[^[:digit:]]","", $fid);
$descr = substr(strip_tags($descr), 0, 100);
if(!$fid) $errormessage .= "unknown forum<br>\n";

if ($upload) {
	//censor
	$descr = censor($descr, $badwords);
	$fmname = censor($fmname, $badwords);
	//validate data
	if($fmname == "") $errormessage .= picklang($requestlang["err_no_name"])."<br>";
	else if($descr == "") $errormessage .= picklang($requestlang["err_no_desc"])."<br>";
	else {
		//validate user
		$myuser = verifyuser($username, $password, $bbs_login, $bbs_public_key, $returnto);
		if ($myuser) {
			//check for power user
			if (!ispoweruser($myuser["admin"], $myuser["posts"])) {
				$tpl_title = picklang($requestlang["sorry"]);
				$tpl_message = $errormessage;
				//include simple template
				include($pathtohomedir."/templates/simple.tpl.php");
				exit;
			}	
			if (!$errormessage) {
				if(requestforum($username, $boardname, $fid, $fmname, $descr)) {
					//log user into the system
					bbs_login($username);
					$tpl_title = picklang($requestlang["success"]);
					$tpl_message = "<h2>".picklang($requestlang["success"])."</h2>";
					$tpl_message .= "<p><b>".picklang($requestlang["request_received"])."</b></p>";
					$tpl_message .= "<p>".picklang($requestlang["will_confirm"])."</p>";
					//include simple template
					include($pathtohomedir."/templates/simple.tpl.php");
					exit;
				}	
			}
		}			
	}
}

if (!$upload || $errormessage) {


?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">

<html>
<head>
	<title><?php echo $boardname." : ".picklang($requestlang["request_new"]);?></title>
<meta http-equiv="content-type" content="text/html;charset=iso-8859-1">
<?php stylepicker(); ?>
</head>
<body bgcolor="<?php echo $reactorcolor[1];?>">
<center><font color="#ff0000" size="4" face="verdana, arial, sans-serif"><b><?php echo $errormessage; ?></b></font></center>
<p><?php echo picklang($requestlang["user_requirements"]); ?>

</p>
<table width=95%><tr><td><ul>
<li> <?php echo picklang($requestlang["forum_guidelines"]); ?>

<li> <?php echo picklang($requestlang["moderator_requirements"]); ?>

<li> <?php echo picklang($requestlang["forum_time_limit"]); ?>

<li> <?php echo picklang($requestlang["choose_location"]); ?>
 
<b><?php echo strip_tags(whereami($boardname, $fid, ""));?></b>

<li> <?php echo picklang($requestlang["ultimate_power"]); ?>

<li> <?php echo picklang($requestlang["for_questions"]); ?>

</ul></td></tr></table>
<hr align="center" color="<?php echo $reactorcolor[0];?>" width="100%" size="2">
<form enctype="application/x-www-form-urlencoded" action="<?php echo $PHP_SELF ;?>" method="post">
<input type=hidden name=fid value="<?php echo $fid; ?>">
<table align=center width=95% bgcolor="<?php echo $reactorcolor[2];?>" cellpadding=2 cellspacing=0>
<?php bbs_login_box($bbs_login, $bbs_public_key); ?>
<tr><td colspan="2"><hr align="center" color="<?php echo $reactorcolor[0];?>" width="100%" size="1"></td></tr>
<tr><td align="right"><p><b><?php echo picklang($requestlang["forum_name"]); ?>:</b></p></td><td width="80%"><input type="text" name="fmname" value="<?php echo stripslashes($fmname);?>" size="20" maxlength="40"></td></tr>
<tr><td valign="top" colspan="2"><p><b>description:</b></p></td></tr>
<tr><td colspan="2" align="center"><textarea name="descr" cols="35" rows="3" wrap="virtual"><?php echo textarea_prep(stripslashes($descr));?></textarea><br>max 100 char</td></tr>
<tr><td colspan="2"><hr align="center" color="<?php echo $reactorcolor[0];?>" width="100%" size="1"></td></tr>
<tr><td colspan="2" align="center">
<input type="button" value="<?php echo picklang($requestlang["cancel"]); ?>" onclick="javascript:window.close();">&nbsp;<input type="submit" name="upload" value="<?php echo picklang($requestlang["submit"]); ?> &gt;&gt;" style="font-weight:bold;"> (<?php echo picklang($requestlang["click_once"]); ?>!)</td></tr>
</table>
</form>
<hr align="center" color="<?php echo $reactorcolor[0];?>" width="100%" size="2">
</body>
</html>
<?php 
} 
?>
