<?php
/*
* Copyright (C) 1999-2000 EKILAT LLC (http://ekilat.com - the first reactor)
* 
* php(REACTOR) is open source; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License <http://www.opensource.org/licenses/gpl-license.html>
* for a complete version of the license.
*
** ./inc/cards.inc.php
* this file contains the shared functions for the cards board.
* there can be three types of cards - img, iframe, or script.  the content for
* each type of card is located in separate subdirectories under /htdocs/cards/
* that is, img are stored in /cards/img/
* iframe (html pages) are stored in /cards/iframe/
* and script (javascript) are stored in /cards/script/
* the thumbnails for the cards are always img 70x105, but are stored in the
* same directory as their respective card.  by convention (not necessary) we
* usually name the thumbnails with *_th.gif or *_th.jpg - e.g., if the
* card is named funny.gif, the thumbnail will be funny_th.gif
*
* each category has a thumbnail as well - this is usually just a thumbnail
* for one of the cards in the category
*
* the cards can be any dimensions you want, but we recommend a maximum width of 412
* so that they fit nicely on a 640x480 screen 
*
* cards are the single best way topromote your site that i have come across.
* of course, it depends on your audience :)
*/

// tell everyone we're already loaded
define("REACTOR_INC_CARDS", 1);

//include files that we'll need - check first
if(!defined("REACTOR_INC_GLOBAL")) { include("inc/global.inc.php"); }
if(!defined("REACTOR_INC_DB")) { include($pathtohomedir."/inc/db.inc.php"); }
if(!defined("REACTOR_INC_LANG")) { include($pathtohomedir."/inc/lang.inc.php"); }

//include conf files
if(!defined("REACTOR_CONF_CARDS")) { include($pathtohomedir."/conf/cards.conf.php"); }

//declare some variables
$baseurl = $reactorcore."/".$boardname;//no trailing slash needed
$sendscript = "create.php";
$chooseurl = "choose.php";
$viewscript = "pickup.php";

//define some table names - you can change these, just be consistent.
$cattable = $boardname."categories";
$cardstable = $boardname."cards";
$personaltable = $boardname."personal";

//specify the database that the cards tables are located in
######## v.1.0.0
function cards_query($sql, $mode) {
	return db1_query($sql, $mode);
}

/*
* displaythumbs() - to show the cards in one category
*/
######## v.1.0.0
function displaythumbs($id, $catname, $start) {
global $spacer, $PHP_SELF, $tablecols, $tablerows, $cardstable, $cattable, $sendscript, $errormessage, $cardlang, $reactorcolor;
if (!$start) $start = 0;
$numrows = $tablecols*$tablerows + 1;
$next = $numrows + $start;
$prev = $start - $numrows + 1;
$more=1;
	
	if(!$id) {
		$outputhtml .= "<p class=n><b>".picklang($cardlang["select_category"])."</b></p>";	
	}
	else {
		$outputhtml .= "<p class=n><b>".picklang($cardlang["select_card"])."</b></p>";
	}
	//determine sql statement
	if (!$id) {
		//show categories
		$sql = "SELECT id, thumb, name FROM $cattable WHERE display=1 AND status=1 ORDER BY last DESC LIMIT $start, $numrows";
	}
	else if($id == "new") {
		//show new cards
		$sql = "SELECT id, thumb, name FROM $cardstable WHERE status=1 ORDER BY id DESC LIMIT $start, $numrows";
	}
	else if($id == "pop") {
		//show poular cards
		$sql = "SELECT id, thumb, name FROM $cardstable WHERE status=1 ORDER BY hits DESC LIMIT $start, $numrows";
	}
	else {
		//show a category
		$sql = "SELECT id, thumb, name FROM $cardstable WHERE cat=$id AND status=1 ORDER BY last DESC LIMIT $start,$numrows";
	}
	
	$outputhtml .= "<table bgcolor=".$reactorcolor[2]." align=center border=0 cellpadding=10 cellspacing=0 width=85%>";
	//display thumbnails
	$request = cards_query($sql, "r");
	//show each thumb
	for($tr=0;$tr<$tablerows;$tr++) {
		$outputhtml .= "<tr>";			
		for($td=0;$td<$tablecols;$td++) {
			$mythumb = request_fetch_array($request);
			$outputhtml .= "<td align=center>";
			if($mythumb) {
				if(!$id) {
					$outputhtml .= "<a class=k href=$PHP_SELF?id=".$mythumb["id"]."&catname=".urlencode($mythumb["name"])."><img height=70 width=105 border=0 src=".$mythumb["thumb"]."><br>".$mythumb["name"]."</a>";
				}
				else {
					$outputhtml .= "<a class=k href=$sendscript?cardid=".$mythumb["id"]."><img height=70 width=105 border=0 src=".$mythumb["thumb"]."><br>".$mythumb["name"]."</a>";
				}
			}
			else { 
				$more=0;
				$outputhtml .= "<img src=$spacer height=70 width=105 border=0>";
			}
			$outputhtml .= "</td>";
		}
		$outputhtml .= "</tr>\n";
	}
	$outputhtml .= "</table>\n";
	
	//display prev and next links
	$outputhtml .= "<br>\n";
	$outputhtml .= "<table align=center border=0 width=85%>";
	$outputhtml .= "<tr>";
	$outputhtml .= "<td width=33% align=left>";
	if($prev > -1) {
		if(!$id) {
			$outputhtml .= "&lt;&lt;&nbsp;<a href=$PHP_SELF?start=$prev>".picklang($cardlang["prev_cat"])."</a>";
		}
		else {
			$outputhtml .= "&lt;&lt;&nbsp;<a href=$PHP_SELF?id=$id&catname=".urlencode($catname)."&start=$prev>".picklang($cardlang["prev_cat_cards"])."</a>";
		}
	}
	else if($start > 0) {
		if(!$id) {
			$outputhtml .= "&lt;&lt;&nbsp;<a href=$PHP_SELF?start=$prev>".picklang($cardlang["prev_cat"])."</a>";
		}
		else {
			$outputhtml .= "&lt;&lt;&nbsp;<a href=$PHP_SELF?id=$id&catname=".urlencode($catname)."&start=$prev>".picklang($cardlang["prev_cat_cards"])."</a>";
		}
	}
	$outputhtml .= "&nbsp;</td>";
	$outputhtml .= "<td width=33% align=center>";
	if(!$id) {
		$outputhtml .= "&nbsp;";
	}
	else {
		$outputhtml .= "[<a href=$PHP_SELF>".picklang($cardlang["other_cat"])."</a>]";
	}
	$outputhtml .= "</td>";
	$outputhtml .= "<td width=33% align=right>&nbsp;";
	if ($more) {
		$mythumb = request_fetch_array($request);//check for next (7th) card.
		if ($mythumb) {
			if(!$id) {
				$outputhtml .= "<a href=$PHP_SELF?start=".($next - 1).">".picklang($cardlang["next_cat"])."</a>&nbsp;&gt;&gt;";
			}
			else {
				$outputhtml .= "<a href=$PHP_SELF?id=$id&catname=".urlencode($catname)."&start=".($next - 1).">".picklang($cardlang["next_cat_cards"])."</a>&nbsp;&gt;&gt;";
			}
		}
	}	
	$outputhtml .= "</td>";
	$outputhtml .= "</tr>\n";
	$outputhtml .= "</table>\n";

return $outputhtml;
}

/*
* displaylinks() - shows hyperlinks to all categories with display=0
*/
######## v.1.0.0
function displaylinks() {
global $errormessage, $PHP_SELF, $cardlang, $cattable, $reactorcolor;

	$outputhtml .= "<p><b>".picklang($cardlang["other_cat"])."</b></p>";
	$outputhtml .= mktable("85%", $reactorcolor[2], 10);
	$outputhtml .= "<tr>";
	$outputhtml .= "<td align=center>";
	$sql = "SELECT id, name FROM $cattable WHERE display=0 AND status=1 ORDER BY last DESC";
	$request = cards_query($sql, "r");
	while($listcat = request_fetch_array($request)) {
		$outputhtml .= "<a href=$PHP_SELF?id=".$listcat["id"]."&catname=".urlencode($listcat["name"]).">".$listcat["name"]."</a>&nbsp;&nbsp;&nbsp;";
	}
	$outputhtml .= "</td>";
	$outputhtml .= "</tr>\n";
	$outputhtml .= "</table>\n";
	$outputhtml .= "<p align=center>[<a href=$PHP_SELF?id=new&catname=new>".picklang($cardlang["new_cards"])."</a>]&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;[<a href=$PHP_SELF?id=pop&catname=popular>".picklang($cardlang["pop_cards"])."</a>]</p>\n";

return $outputhtml;
}

/*
* showcard() - shows a card from the database, either with user supplied message
* or message form
*/
######## v.1.0.0
function showcard($mycard, $midi, $message, $font, $fontcolor, $in_form) {
global $cardlang, $reactorcolor, $spacer, $mididir, $boardname, $reactorcore;
$messagewidth = 184;
$totalwidth = $messagewidth + 3 + $mycard["width"];

	if($midi && !$in_form) {
		$outputhtml .= "<embed src=".$reactorcore."/".$boardname.$mididir.$midi." height=1 width=1 hidden=true loop=true autostart=true>\n";
	}
	$outputhtml .= mktable($totalwidth, $reactorcolor[1], 0);
	$outputhtml .= "<tr>";
	$outputhtml .= "<td width=$totalwidth bgcolor=$reactorcolor[0] colspan=5><img src=$spacer border=0 height=1 width=$totalwidth></td>";
	$outputhtml .= "</tr>\n";
	$outputhtml .= "<tr>";
	$outputhtml .= "<td width=1 bgcolor=$reactorcolor[0]><img src=$spacer border=0 height=".$mycard["height"]." width=1></td>";
	$outputhtml .= "<td width=".$mycard["width"].">";
	switch($mycard["type"]) {
		case "iframe":
			$outputhtml .= "<iframe align=absmiddle src=".$mycard["image"]." width=".$mycard["width"]." height=".$mycard["height"]." marginwidth=0 marginheight=0 hspace=0 vspace=0 frameborder=0 scrolling=no noresize>Sorry, this is an IFRAME card, and requires an IFRAME compatible browser.</iframe>\n";		
		break;
		case "script":
			$outputhtml .= "<script type=text/javascript src=".$mycard["image"]."></script><noscript>Sorry, this is a javascript card, and requires a javascript compatible browser.</noscript>\n";		
		break;
		case "img":
		default:
			$outputhtml .= "<img align=absmiddle src=".$mycard["image"]." width=".$mycard["width"]." height=".$mycard["height"]." border=0>";
	}
	$outputhtml .= "</td>";
	$outputhtml .= "<td width=1 bgcolor=$reactorcolor[0]><img src=$spacer border=0 height=".$mycard["height"]." width=1>";
	$outputhtml .= "</td>";
	$outputhtml .= "<td width=$messagewidth bgcolor=".(($in_form)? $reactorcolor[2]: $reactorcolor[1]).">";
	$outputhtml .= "<table height=".$mycard["height"]." width=$messagewidth border=0 cellspacing=0 cellpadding=5>";
	$outputhtml .= "<tr>";
	$outputhtml .= "<td valign=top>";
	if($in_form) {
		$outputhtml .= picklang($cardlang["enter_message"])."<br>\n";
		$outputhtml .= "<textarea name=message cols=17 rows=13 wrap=virtual>".textarea_prep(stripslashes($message))."</textarea>";
		$outputhtml .= "<br>(max 165 char)\n";
	}
	else {
		$outputhtml .= "<font size=4 face=\"$font\" color=#$fontcolor>".nl2br(stripslashes($message))."</font>";
	}
	$outputhtml .= "</td>";
	$outputhtml .= "</tr>\n";
	$outputhtml .= "</table>\n";
	$outputhtml .= "</td>";
	$outputhtml .= "<td width=1 bgcolor=$reactorcolor[0]><img src=$spacer border=0 height=".$mycard["height"]." width=1></td>";
	$outputhtml .= "</tr>\n";
	$outputhtml .= "<tr>";
	$outputhtml .= "<td width=$totalwidth bgcolor=$reactorcolor[0] colspan=5><img src=$spacer border=0 height=1 width=$totalwidth></td>";
	$outputhtml .= "</tr>\n";
	$outputhtml .= "</table>\n";

return $outputhtml;
}


?>
