<?php
/*
* Copyright (C) 1999-2000 EKILAT LLC (http://ekilat.com - the first reactor)
* 
* php(REACTOR) is open source; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License <http://www.opensource.org/licenses/gpl-license.html>
* for a complete version of the license.
*
**			./inc/chat.inc.php
* this file contains all the functions for the chat event system.  the chat event
* system is basically just a way for people to make appointments to meet in chat
* rooms.  you could also hold moderated discussions about current topics.  
*
* php(REACTOR); does not include a chat room, and we recommend that you DO NOT 
* put one on your server.  We suggest you use irc for simple text chat (a good
* irc applet can be found at http://www.jpilot.com).  Or, you could use a fancy 
* visual chat room - we recommend OnChat (http://www.onchat.com).
*/

// tell everyone we're already loaded
define("REACTOR_INC_CHAT", 1);

//ALWAYS INCLUDE THIS
if(!defined("REACTOR_INC_GLOBAL")) { include("inc/global.inc.php"); }
//INCLUDE BBS FUNCTIONS
if(!defined("REACTOR_INC_DB")) { include($pathtohomedir."/inc/db.inc.php"); }
//INCLUDE LANGUAGE FUNCTIONS
if(!defined("REACTOR_INC_LANG")) { include($pathtohomedir."/inc/lang.inc.php"); }

//INCLUDE 
if(!defined("REACTOR_CONF_CHAT")) { include($pathtohomedir."/conf/chat.conf.php"); }

//what table are the chat events stored in
$chattable = $boardname;//don't mess with this unless you know what you're doing

//specify the database that the chat table is located in
######## v.1.0.0
function chat_query($sql, $mode) {
	return db1_query($sql, $mode);
}

/*
* showchatevents() queries the chat db for the upcoming events.  if given 
* $boardname, it will query the chat events for that specific board.
*/
######## v.1.0.0
function showchatevents($fromboard, $boardid) {
global $datestringlong, $chattable, $showmax, $timeadj, $chatlang, $timezone;
$outputhtml = "";
$mytime = time() + $timeadj - 1800;//the 1800 is to show the events that are happening in this half-hour

	//query upcoming events
	if (!$fromboard) {
		//for all events in the chat db
		$sql = "SELECT subject, username, room, UNIX_TIMESTAMP(wen) AS start FROM $chattable WHERE UNIX_TIMESTAMP(wen)>".$mytime." AND status=1 ORDER BY wen ASC, created ASC LIMIT $showmax";
	}
	else if (!$boardid) {
		//for events specific to a board and not a forum
		$sql = "SELECT subject, username, room, UNIX_TIMESTAMP(wen) AS start FROM $chattable WHERE UNIX_TIMESTAMP(wen)>".$mytime." AND status=1 AND fromboard='".$fromboard."' ORDER BY wen ASC, created ASC LIMIT $showmax";
	}
	else {
		//for events related to a specific board and forum
		$sql = "SELECT subject, username, room, UNIX_TIMESTAMP(wen) AS start FROM $chattable WHERE UNIX_TIMESTAMP(wen)>".$mytime." AND status=1 AND fromboard='".$fromboard."' AND boardid=".$boardid." ORDER BY wen ASC, created ASC LIMIT $showmax";
	}
	if($request = chat_query($sql,"r")) {
		while ($myevent = request_fetch_array($request)) {
			$outputhtml .= "<li> <p><b>".$myevent["subject"]."</b></p> - ".date($datestringlong, $myevent["start"])." ".$timezone." ".picklang($chatlang["in"])." ".$myevent["room"]." ".picklang($chatlang["with"])." <b>".$myevent["username"]."</b>";
			if ($myevent["start"] < ($mytime + 1800)) $outputhtml .= " <b style=\"color:#ff0000;font-size:medium;\">-@<b style=\"color:#ff0000;font-size:xx-small;\">&gt;</b>@-</b>";
		}
	}
	return $outputhtml;
}


/*
* addchatevent() just inserts a chat events into the chat event table.  assumes
* that authorization and validation have already taken place
*/
######## v.1.0.0
function addchatevent($username, $subject, $room, $when, $fromboard, $boardid) {
global $chattable;
	if(!$fromboard) {
		$sql = "INSERT INTO $chattable (created, username, subject, room, wen, status, user_addr) VALUES (NULL,'".$username."','".$subject."','".$room."','".$when."',1,'".getenv("REMOTE_ADDR")."')";
	}
	else if (!$boardid) {
		$sql = "INSERT INTO $chattable (created, username, subject, room, wen, status, user_addr, fromboard) VALUES (NULL,'".$username."','".$subject."','".$room."','".$when."',1,'".getenv("REMOTE_ADDR")."','".$fromboard."')";
	}
	else {
		$sql = "INSERT INTO $chattable (created, username, subject, room, wen, status, user_addr, fromboard, boardid) VALUES (NULL,'".$username."','".$subject."','".$room."','".$when."',1,'".getenv("REMOTE_ADDR")."','".$fromboard."',".$boardid.")";
	}
	if($request = chat_query($sql, "w")) return true;
	else return false;
}


?>
