<?php
/*
* Copyright (C) 1999-2000 EKILAT LLC (http://ekilat.com - the first reactor)
* 
* php(REACTOR) is open source; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License <http://www.opensource.org/licenses/gpl-license.html>
* for a complete version of the license.
*
**        ./inc/db.inc.php
*
* This file stores all the database information for the eKilat databases.
* It is designed to ease the connection to multiple databses within one script.
* It attemps to provide a layer of database abstraction, but that is untested
* at this point as I have no Postgresql db.  If anyone does, :)
*
* IMPORTANT: THIS WILL BE STORED ABOVE THE DOCUMENT ROOT TO ENSURE SECURITY.  
* THIS FILE MUST BE SECURED AT ALL COSTS AS IT CONTAINS THE PASSWORDS TO YOUR 
* DATABASES. IF ON A SHARED SERVER USE A PHP WRAPPER TO RUN SCRIPTS UNDER YOUR 
* USERID AND SET PERMISSIONS TO 600.
*
* REMEMBER TO CHANGE mysql_pconnect() TO mysql_connect() IF running php as cgi.
*
* QUERY FUNCTIONS ARE MAPPED TO THE DATABASE IN WHICH THE TABLES ARE STORED.
* This is done to make the addition of additional databases easy.  The default
* setup is for two databases.  This is not necessary - you could use one or 
* twenty.  just create the function db3_query() and so on.
*
*/

// tell everyone we're already loaded
define("REACTOR_INC_DB", 1);

// the currently selected db
if(!isset($selected_db)) $selected_db = "";

// the most recent database link
if(!isset($db_link)) $db_link = "";

######## v.1.0.0
function db1_query($sql, $mode = "r") {
global $errormessage, $selected_db, $db_link;
static $mymode = "";

// UPDATE THE FOLLOWING VALUES
$mydb_host = "localhost";
$mydb_name = "test";
// READ PERMISSIONS - SELECT
$mydb_user_r = "root";
$mydb_pass_r = "";
// WRITE PERMISSIONS - INSERT, UPDATE, DELETE
$mydb_user_w = "root";
$mydb_pass_w = "";
// FULL PERMISSIONS - CREATE, DROP, ALTER, EVERYTHING ELSE. BE VERY VERY CAREFUL
$mydb_user_f = "root";
$mydb_pass_f = "";

	switch ($mode) {
		case "f":
			$user = $mydb_user_f;
			$pass = $mydb_pass_f;
		break;
		case "w":
			$user = $mydb_user_w;
			$pass = $mydb_pass_w;
		break;
		case "r":
			$user = $mydb_user_r;
			$pass = $mydb_pass_r;
		break;
	} 
	//change to mysql_connect if you are running php as cgi
	$mydb_db = @mysql_pconnect($mydb_host, $user, $pass);
	$db_link = $mydb_db;

	if (($selected_db != $mydb_name) || ($mymode!=$mode)) {
		@mysql_select_db($mydb_name, $mydb_db);
		$selected_db = $mydb_name;
	}
	$mymode = $mode;
	$request = @mysql_query($sql,$mydb_db);
	//check for errors on request
	if (mysql_errno()) {
		//uncomment the following line for debugging
		#$errormessage .= "mysql error # ".mysql_errno().": ".mysql_error()."<BR>\nsql: ".$sql."<br>\n";
		$errormessage .= "mysql error # ".mysql_errno().": (concealed)<BR>\n";
		return false;
	} 
	else {
		return $request;
	}
}

######## v.1.0.0
function db2_query($sql, $mode = "r") {
global $errormessage, $selected_db, $db_link;
static $mymode = "";

// UPDATE THE FOLLOWING VALUES
$mydb_host = "localhost";
$mydb_name = "test";
// READ PERMISSIONS - SELECT
$mydb_user_r = "root";
$mydb_pass_r = "";
// WRITE PERMISSIONS - INSERT, UPDATE, DELETE
$mydb_user_w = "root";
$mydb_pass_w = "";
// FULL PERMISSIONS - CREATE, DROP, ALTER, EVERYTHING ELSE. BE VERY VERY CAREFUL
$mydb_user_f = "root";
$mydb_pass_f = "";

	switch ($mode) {
		case "f":
			$user = $mydb_user_f;
			$pass = $mydb_pass_f;
		break;
		case "w":
			$user = $mydb_user_w;
			$pass = $mydb_pass_w;
		break;
		case "r":
			$user = $mydb_user_r;
			$pass = $mydb_pass_r;
		break;
	} 
	//change to mysql_connect if you are running php as cgi
	$mydb_db = @mysql_pconnect($mydb_host, $user, $pass);
	$db_link = $mydb_db;
	
	if (($selected_db != $mydb_name) || ($mymode!=$mode)) {
		@mysql_select_db($mydb_name, $mydb_db);
		$selected_db = $mydb_name;
	}
	$mymode = $mode;
	$request = @mysql_query($sql,$mydb_db);
	//check for errors on request
	if (mysql_errno()) {
		//uncomment the following line for debugging
		#$errormessage .= "mysql error # ".mysql_errno().": ".mysql_error()."<BR>\nsql: ".$sql."<br>\n";
		$errormessage .= "mysql error # ".mysql_errno().": (concealed)<BR>\n";
		return false;
	} 
	else {
		return $request;
	}
}


/* 
* THIS IS JUST AN ABSTRACTION LAYER (IT DOES THE SAME THING AS mysql_fetch_array())
* IT RETURNS AN ASSOCIATIVE ARRAY OF COLUMN NAMES AND VALUES.  Postgresql, anyone :)
*/
######## v.1.0.0
function request_fetch_array(&$request) {
	return @mysql_fetch_array($request);
}

/* for abstraction purposes */
######## v.1.0.0
function request_fetch_row(&$request) {
	return @mysql_fetch_row($request);
}

/* for abstraction purposes */
######## v.1.0.0
function get_insert_id() {
global $db_link;
	return @mysql_insert_id($db_link);
}

/* for abstraction purposes */
######## v.1.0.0
function get_num_rows($request) {
	return @mysql_num_rows($request);
}

/* for abstraction purposes */
######## v.1.0.0
function get_affected_rows() {
global $db_link;
	return @mysql_affected_rows($db_link);
}
/* for abstraction purpose */
######## v.1.0.0
function request_data_seek($request,$seek_point) {
       return @mysql_data_seek($request,$seek_point);
}       
?>
