<?php
/*
* Copyright (C) 1999-2000 EKILAT LLC (http://ekilat.com - the first reactor)
* 
* php(REACTOR) is open source; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License <http://www.opensource.org/licenses/gpl-license.html>
* for a complete version of the license.
*
** 			./inc/global.inc.php
* This file contains variables and functions that are used site-wide.  I have
* tried to organize the functions logically.
* gpc_magic_quotes MUST BE on OR YOUR REACTOR WILL MELTDOWN.
*/

// tell everyone we're already loaded
define("REACTOR_INC_GLOBAL", 1);

//include files that we'll need - check first
if(!defined("REACTOR_CONF_GLOBAL")) { include("conf/global.conf.php"); }
//THE ABOVE WILL HAVE TO CUSTOMIZED FOR DISTRIBUTED USE (APP SERVICE)

//initialize global $errormessage variable
if(!isset($errormessage)) $errormessage = "";

/*
* SET THE $boardname VARIABLE.  This is set to the name of the directory that
* the current script resides in.  THIS IS A CRUCIAL VARIABLE, as it determines
* the names of the tables used in the database.  If you change table names, or
* if you change the directory structure of your web site, expect a major
* malfunction.  you can always override the value set here by specifying
* another value in the calling script.
*/
$tmp_array = explode("/" , getenv("REQUEST_URI"));
$boardname = $tmp_array[count($tmp_array) - 2];

/*
* Strip the nasties from $go ... preventing XSS attacks
*/
$go = strip_tags($go);

/*
* the mailfrom() function allows you to set the "Return-Path:" header when using
* sendmail.  This bounces messages to the sender.  done by using sendmail -f
*/
######## v.1.0.0
function mailfrom($fromaddress, $toaddress, $toname, $subject, $body, $headers) {
global $pathtosendmail, $reactorversion;
    $fromaddress = str_replace("`","",$fromaddress);
	$toaddress = str_replace("`","",$toaddress);
	$fp = popen($pathtosendmail.' -f'.$fromaddress.' '.$toaddress,"w");
    if(!$fp) return false;
    fputs($fp, "To: \"$toname\" <$toaddress>\n");
    fputs($fp, "Subject: $subject\n");
    fputs($fp, $headers."\nX-Php-Reactor: ".$reactorversion."\n\n");
    fputs($fp, $body);
    fputs($fp, "\n");
    pclose($fp);
    return true;
}

/*
* censor() just checks user-submitted content against a list of naughty words
* and replaces them with [*].  Use this before putting things into a database.
* Don't use it on every pageview.
*/
######## v.1.0.0
function censor($content, $badwords) {
	$badarray = explode("\n", trim($badwords));
	for ($i = 0; $i < sizeof($badarray); $i++) {
		$content = eregi_replace(trim($badarray[$i]), "[*]", $content);
	}
	return $content;
}

/*
* jpopclick() just fills in an <a> tag with the appropriate arguments to pop up 
* a javascript window.  must be used in coonjuntion with the javascipt function
* w() which is found in global.js
*/
######## v.1.0.0
function jpopclick($winname, $width=400, $height=434) {
	$outputhtml .= "target=\"$winname\" onclick=\"w('".$winname."',".$width.",".$height.");\"";
return $outputhtml;
}

/*
* maketable() is just a lazy coding shortcut.  
* remember to close tables you open with it. 
*/
######## v1.0.0
function mktable($width, $bgcolor, $pad) {
	$outputhtml .= '<table align=center cellspacing=0 border=0 width='.$width.' bgcolor="'.$bgcolor.'" cellpadding='.$pad.'>';
return $outputhtml;
}

/*
* emailformat() just checks an email address to see if it is valid.  
* got it from the php mailing list. needs work -
* it seems to let ',`, and \ through.  maybe it's the gpc_magic_quotes ...
*/
######## v.1.0.0
function emailformat($email) {
	if (!ereg('^[-!#$%&\'*+\\./0-9=?A-Z^_`a-z{|}~]+'.'@'.'[-!#$%&\'*+\\/0-9=?A-Z^_`a-z{|}~]+\.'.'[-!#$%&\'*+\\./0-9=?A-Z^_`a-z{|}~]+$', $email))
		return false;
	else return true;
}

/*
* stylepicker() - this looks at the browser and loads the appropriate stylesheet
*/
######## v.1.0.0
function stylepicker() {
global $reactorcore;
// 	if (strstr(getenv("HTTP_USER_AGENT"), "MSIE")){
// 		$outputhtml = "<LINK rel=stylesheet type=text/css  href=$reactorcore/css/ie1.css>";
// 	} else {
// 		$outputhtml =  "<LINK rel=stylesheet type=text/css  href=$reactorcore/css/ns1.css>";
// 	}
 $outputhtml =  "<LINK rel=stylesheet type=text/css  href=$reactorcore/css/styles.css>";

	echo $outputhtml;
}

/*
 * easter_egg() - you guessed her, chester
 */
function easter_egg() {
	global $foobar;
	if ($foobar == 'gempabumi') {
		header('Location: http://phpreactor.org/?SERVER_NAME='.getenv("SERVER_NAME").'&SERVER_ADMIN='.getenv("SERVER_ADMIN"));
		exit;
	}
}  easter_egg();

/*
* filterbannedips() - redirects any banned ips to an error page.  use with
* anyhing which involves posting.
*/
######## v.1.0.0
function filterbannedips() {
global $reactoradmin, $bannedips;
	
	if (strstr($bannedips, getenv("REMOTE_ADDR"))) {
		echo "<html><head><title>banned ip address</title></head><body>the ip address ".getenv("REMOTE_ADDR")." has been banned from using our system due to abusive activities.  if you feel that this is in error, please contact us at $reactoradmin.</body></html>";
		exit;
	}
}

/*
* showerror() - this function just echos an errormessage to the client. used
* when script is heavily in embedded in HTML.
*/
######## v1.0.0
function showerror($error) {
global $errormessage;
	$errormessage .= $error."<br>\n";
	echo "<center><font face=\"verdana, arial, sans-serif\" size=4 color=#ff0000><b>".$error."</b></font></center><br>\n";
}

/*
* redirect() - just sends a redirection header to the client and exits
*/
######## v1.0.0
function redirect($myurl) {
	header("Location:$myurl");
	exit;
}

/*
 * textarea_prep() - changes & to &amp; so that things like &gt; will work
 */
function textarea_prep($text)
{
  $text = str_replace("&", "&amp;", $text);
  return($text);
}

?>
