<?php
/*
* Copyright (C) 1999-2000 EKILAT LLC (http://ekilat.com - the first reactor)
* 
* php(REACTOR) is open source; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License <http://www.opensource.org/licenses/gpl-license.html>
* for a complete version of the license.
*
**              ./inc/lang.inc.php
* The following code is the extra language capability
* it should be pasted into the top of every page that has a second language
* first, set the cookie for whatver language mode we're in
* if called with ?setlang=default the script will delete the cookie and return 
* to default.
* add extra languages by adding elements to the array given to picklang();
* Language selection currently works on cookies, but should be fairly easy
* to customize it to work on sessions or other content negotiation. if you want.
* because of the modularity of the php(REACTOR); system, we leave the distinct
* language specifications to their respective scripts.  we built it the way to
* be flexible. example:
* $bbstext = array(
* "postnewtopic" => array("default" => "post new topic", "english" => "post new topic"),
* "reply" => array("default" = "reply", "english" => "reply"),
* "" => array("default" => "", "english" => ""),
* );
*/

// tell everyone we're already loaded
define("REACTOR_INC_LANG", 1);

if($newlang == "default")
	setcookie("setlang", "", "" , "/", "", 0);
else if(isset($newlang))
	setcookie("setlang", $newlang, "" , "/", "", 0);

if(isset($newlang)) $setlang = $newlang;

/*
* picklang() just looks at the current language setting (cookie) and returns
* the appropriate value in the associative array that it is given.
* usage: <?php echo picklang(array("default" => "", "english" => "")); ?>
*/
######## v.1.0.0
function picklang($choices) {
global $setlang;
$mylang = $setlang;
    if(!$mylang) $mylang = "default";
    if ($choices[$mylang])
		return $choices[$mylang];
	else return $choices["default"];
}

/*
* langbox() displays a language selector.
* This is currently set for bilingual mode.  If you want a site in more than
* one language, you have to do some customization. no big deal.
* usage: <?php echo langbox(); ?>
*/
######## v.1.0.0
function langbox() {
global $setlang;
global $PHP_SELF;
	if (($setlang == "default") || ($setlang == ""))
		return "[<a href=$PHP_SELF?newlang=english>english</a>]";
	else return "[<a href=$PHP_SELF?newlang=default>other language</a>]";
}

?>