<?php
/*
* Copyright (C) 1999-2000 EKILAT LLC (http://ekilat.com - the first reactor)
* 
* php(REACTOR) is open source; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License <http://www.opensource.org/licenses/gpl-license.html>
* for a complete version of the license.
*
**			./inc/polls.inc.php
* this contains the functions used for the php(REACTOR); polls script
* polls can be shown one at a time, can be submitted by power users,
* and so on.  we like to put them everywhere.
*/

// tell everyone we're already loaded
define("REACTOR_INC_POLLS", 1);

//include files that we'll need - check first
if(!defined("REACTOR_INC_GLOBAL")) { include("inc/global.inc.php"); }
if(!defined("REACTOR_INC_DB")) { include($pathtohomedir."/inc/db.inc.php"); }
if(!defined("REACTOR_INC_LANG")) { include($pathtohomedir."/inc/lang.inc.php"); }
if(!defined("REACTOR_INC_USERS")) { include($pathtohomedir."/inc/users.inc.php"); }
if(!defined("REACTOR_INC_BBS")) { include($pathtohomedir."/inc/bbs.inc.php");}

//INCLUDE CONF
if(!defined("REACTOR_CONF_POLLS")) { include($pathtohomedir."/conf/polls.conf.php"); }

///the polls table name
$pollstable = $boardname;//be careful if you change this

//the table name for polls' comments
$commentstable = "comments";

//url to comments board
$commentsboard_url = $reactorcore."/comments";	//no trailing /	

//url to forums board
$forumsboard_url = $reactorcore."/forums";	//no trailing /

//WHAT DIRECTORY ARE YOUR POLLS LOCATED IN?
$pollsboard = $boardname;//no slashes /


//specify the database that the polls table is located in
######## v.1.0.0
function polls_query($sql, $mode) {
	return db1_query($sql, $mode);
}

/*
* showonepoll() - shows one poll in a simple fashion -used to show polls which
* which are attached to other boards.
*/
######## v.1.0.0
function showonepoll($fromboard, $boardid) {
global $reactorcore, $errormessage, $pollstable, $polllang, $pollsboard;

	$sql = "SELECT *, UNIX_TIMESTAMP(began) AS posted, UNIX_TIMESTAMP(expires) as expired FROM $pollstable WHERE status=1 AND UNIX_TIMESTAMP(expires)>".time()." AND fromboard='".$fromboard."' AND boardid=$boardid ORDER BY posted ASC LIMIT 1";
	if ($request = polls_query($sql, "r")) {
		if ($mypoll = request_fetch_array($request)) {
			$outputhtml .= "<form action=$reactorcore/$pollsboard/index.php method=post>\n";
			$outputhtml .= "<input type=hidden name=action value=pilih>\n";
			$outputhtml .= "<input type=hidden name=id value=".$mypoll["id"].">\n";
			$outputhtml .= "<p><b>".$mypoll["question"]."</b> - ".$mypoll["username"]."</p>\n";
if ($mypoll["choice0name"]) $outputhtml .= "<input class=c type=radio name=choice value=1>&nbsp;".str_replace(" ", "&nbsp;", $mypoll["choice0name"])." \n";
if ($mypoll["choice1name"]) $outputhtml .= "<input class=c type=radio name=choice value=2>&nbsp;".str_replace(" ", "&nbsp;", $mypoll["choice1name"])." \n";
if ($mypoll["choice2name"]) $outputhtml .= "<input class=c type=radio name=choice value=3>&nbsp;".str_replace(" ", "&nbsp;", $mypoll["choice2name"])." \n";
if ($mypoll["choice3name"]) $outputhtml .= "<input class=c type=radio name=choice value=4>&nbsp;".str_replace(" ", "&nbsp;", $mypoll["choice3name"])." \n";
if ($mypoll["choice4name"]) $outputhtml .= "<input class=c type=radio name=choice value=5>&nbsp;".str_replace(" ", "&nbsp;", $mypoll["choice4name"])." \n";
if ($mypoll["choice5name"]) $outputhtml .= "<input class=c type=radio name=choice value=6>&nbsp;".str_replace(" ", "&nbsp;", $mypoll["choice5name"])." \n";
if ($mypoll["choice6name"]) $outputhtml .= "<input class=c type=radio name=choice value=7>&nbsp;".str_replace(" ", "&nbsp;", $mypoll["choice6name"])." \n";
if ($mypoll["choice7name"]) $outputhtml .= "<input class=c type=radio name=choice value=8>&nbsp;".str_replace(" ", "&nbsp;", $mypoll["choice7name"])." \n";
if ($mypoll["choice8name"]) $outputhtml .= "<input class=c type=radio name=choice value=9>&nbsp;".str_replace(" ", "&nbsp;", $mypoll["choice8name"])." \n";
if ($mypoll["choice9name"]) $outputhtml .= "<input class=c type=radio name=choice value=10>&nbsp;".str_replace(" ", "&nbsp;", $mypoll["choice9name"])." \n";
			$outputhtml .= "<input type=submit value=".picklang($polllang["choose"])."> [<a href=$reactorcore/$pollsboard/index.php?id=".$mypoll["id"].">".picklang($polllang["results"])."</a>]";
			$outputhtml .= "</form>";
		}	
	}
	return $outputhtml;
}

/*
* addpoll() - inserta a poll into the polls table.  assumes that all the data
* been validated.
*/
######## v.1.0.0
function addpoll($username, $fromboard, $boardid, $question, $choice0name, $choice1name, $choice2name, $choice3name, $choice4name, $choice5name, $choice6name, $choice7name, $choice8name, $choice9name) {
global $reactorcore, $mytid, $ftable, $forumlist, $myuser, $errormessage, $days_to_expire, $pollstable, $boardname, $commentstable;
$expires = time() + $days_to_expire * 84600;
$expires = date("YmdHis",$expires);

	$sql = "INSERT INTO $pollstable (id,
	question,
	status,
	began,
	expires,
	lastip,
	choice0name, choice0hits,
	choice1name, choice1hits,
	choice2name, choice2hits,
	choice3name, choice3hits,
	choice4name, choice4hits,
	choice5name, choice5hits,
	choice6name, choice6hits,
	choice7name, choice7hits,
	choice8name, choice8hits,
	choice9name, choice9hits,
	username,
	fromboard, boardid)
	VALUES ( NULL,
	 '$question',
	 1,
	    NULL,
		 $expires,
		  '".getenv("REMOTE_ADDR")."',
		  '$choice0name',0,
		  '$choice1name',0,
		  '$choice2name',0,
		  '$choice3name',0,
		  '$choice4name',0,
		  '$choice5name',0,
		  '$choice6name',0,
		  '$choice7name',0,
		  '$choice8name',0,
		  '$choice9name',0,
		  '$username',
		  '$fromboard',$boardid)";

	//inserting poll
	if (!$request = polls_query($sql,"w")) {
		echo $errrormsg .= '(while inserting poll)'; return false;
		}	
	else {
		$pollid = get_insert_id($pollstable.'id_seq');
		$fid = get_commentboard_id($boardname);
		$forumlist = $commentstable;
		$ftable = $commentstable.'topics'.$fid;
		if(strlen($question)>=60){
			$subject = substr($question,0,56).'...';}
		else {
			$subject = $question;
		}

		// add a link to the body which points back to the poll
		$body = $question."\n\n".$reactorcore."/".$boardname."/index.php?id=".$pollid;

			
//      		//inserting comment
// 		$sql="INSERT $ftable VALUES('','','',0,'$subject','','','','',0,1,NULL,NULL,'','','')";
//   		if(!$request=polls_query($sql,"w")) { 
//  			echo $errormessage .= '(while inserting comment)'; return false;
//   			}
		if(!createtopic($fid,$myuser,$subject,$body,"'".getenv("REMOTE_ADDR")."'")) {
		  echo $errormessage; return false;
		} 
	        
  		else { 
		  $commenttid = $mytid;
   		//updating commenttid field in polls table
			$sql="UPDATE $pollstable SET commenttid=$commenttid WHERE id=$pollid";		  
 			if(!$request=polls_query($sql,"w")) { 
				echo $errormessage.='(while updating polls table)'; 
				return false;
			}
			//updating pid and rid in forumstopis  
//   			$sql="UPDATE $ftable  SET pid='$commenttid', rid='$commenttid'  WHERE tid='$commenttid'";
// 			if(!$request=polls_query($sql,"w")) { 
// 				echo $errormessage.='(while updating forum list)'; 
//			return false;
// 			}
		}
	}		
		return true;
}

/*
* showpoll() - shows one poll. used to show polls which have hyperlinks or 
* images
*/
######## v.1.0.0
function showpollchoices($id) {
global $errormessage, $pollstable, $thetimenow, $PHP_SELF, $reactorcolor, $reactorname, $datestringshort, $polllang;
	//if no id specified, query the last poll
	if(!$id) {
		$sql = "SELECT *, UNIX_TIMESTAMP(began) AS posted, UNIX_TIMESTAMP(expires) as expired FROM $pollstable WHERE status=1 AND UNIX_TIMESTAMP(expires)>$thetimenow ORDER BY expires DESC LIMIT 1";	
	} else {
		$sql = "SELECT *, UNIX_TIMESTAMP(began) AS posted, UNIX_TIMESTAMP(expires) as expired FROM $pollstable WHERE id=$id";		
	}

	if ($request = polls_query($sql, "r")) {
		$mypoll = request_fetch_array($request);
		if ($mypoll) {
			$id = $mypoll["id"];//in case it's not defined yet
			$outputhtml .= "<p class=n><b>".$mypoll["question"]."</b> - ".(($mypoll["username"])? $mypoll["username"]: $reactorname)."</p>";

			//put choices into an array
			for ($z = 0; $z < 10; $z++) {
				if ($mypoll["choice".$z."name"]) {
					$mychoicename[$z] = $mypoll["choice".$z."name"];	
				} else break;
			}
			//draw a form with the results
			$outputhtml .= "\n<form action=$PHP_SELF method=post>";
			$outputhtml .= "<input type=hidden name=id value=$id>";
			$outputhtml .= "<input type=hidden name=action value=pilih>";
			$outputhtml .= "\n<table width=98% align=center border=0 cellpadding=5 cellspacing=0 bgcolor=".$reactorcolor[2].">";

			$numrows = sizeof($mychoicename);
			for ($c = 0; $c < $numrows; $c++) {
				//show each choice
				$outputhtml .= "<tr>";
				$outputhtml .= "<td align=right width=50%><p><b>".$mychoicename[$c]."</b></p></td>";
				$outputhtml .= "<td width=50% align=left><input type=radio name=choice value=".($c+1)." class=r></td>";
				$outputhtml .= "</tr>\n";
			}
				
			$outputhtml .= "<tr>";
			$outputhtml .= "<td>&nbsp;</td>";
			$outputhtml .= "<td align=left><input class=b type=submit value=\"".picklang($polllang["choose"])."\"</td>";
			$outputhtml .= "</tr>\n";
			$outputhtml .= "</table>\n";
			$outputhtml .= "</form>\n";
			$outputhtml .= "<br>\n";
			$outputhtml .= "<p align=center>&lt;".date($datestringshort, $mypoll["posted"])."&gt; ".picklang($polllang["until"])." &lt;".date($datestringshort, $mypoll["expired"])."&gt;</p>";
		} 
		else {
			showerror(picklang($polllang["err_no_id"]));
		}			
	}
return $outputhtml;
}

/*
* makechoice() - record a users choice in the database ...
*/
######## v.1.0.0
function makechoice($choice, $id) {
global $errormessage, $polllang, $pollstable, $datestringshort, $thetimenow;
	
	if(!$choice) {
		showerror(picklang($polllang["err_no_choice"]));
	} else if(!$id) {
		showerror(picklang($polllang["err_no_id"]));
	} else {
		//decrement $choice (I incremented it in the form to avoid a if(!$choice) error.
		$choice = $choice - 1;
		//query the poll and check last ip.
		$sql = "SELECT lastip, began, choice".$choice."hits, choice".$choice."name, UNIX_TIMESTAMP(expires) as expired FROM $pollstable WHERE id=$id";
		if ($request = polls_query($sql, "r")) {
			$mypoll = request_fetch_array($request);
			if ($mypoll) {
				if(getenv("REMOTE_ADDR") == $mypoll["lastip"]) {
					showerror(picklang($polllang["err_temp_ip_block"]));
				} 
				else if($thetimenow > $mypoll["expired"]) {
					showerror(picklang($polllang["err_poll_expired"])." ".date($datestringshort, $mypoll["expired"]));
				} 
				else {
					$newtotal = $mypoll["choice".$choice."hits"] + 1;
					//update hits, began, lastip
					$sql = "UPDATE $pollstable SET choice".$choice."hits=$newtotal, lastip='".getenv("REMOTE_ADDR")."', began=".$mypoll["began"]." WHERE id=$id";
					if ($request = polls_query($sql, "w")) {
						//put in a thankyou message here.	
						$outputhtml .= "<p align=center><b>".picklang($polllang["thanks"])." (<i>".$mypoll["choice".$choice."name"]."</i>)</b></p>\n";			
					}
				}
			} else showerror(picklang($polllang["err_no_id"]));
		}
	}
return $outputhtml;
}

/*
* showpollresults() - choes the results for a particluar poll
*/
######## v.1.0.0
function showpollresults(&$id) {
global $barwidth, $errormessage, $pollstable, $polllang, $thetimenow, $PHP_SELF, $pollbar, $datestringshort, $reactorname, $reactorcolor;
	//query database and get results for id, if specified, otherwise, show most recent poll.
	if (!$id) {
		$sql = "SELECT *, UNIX_TIMESTAMP(began) AS posted, UNIX_TIMESTAMP(expires) as expired FROM $pollstable WHERE status=1 AND UNIX_TIMESTAMP(expires)>$thetimenow ORDER BY expires DESC LIMIT 1";
	} else {
		$sql = "SELECT *, UNIX_TIMESTAMP(began) AS posted, UNIX_TIMESTAMP(expires) as expired FROM $pollstable WHERE id=$id";	
	}
		if ($request = polls_query($sql, "r")) {
			$mypoll = request_fetch_array($request);
			if ($mypoll) {
				$id = $mypoll["id"];//in case it's not defined yet
				$outputhtml .= "<p class=n><b>".$mypoll["question"];
				if($thetimenow < $mypoll["expired"]) {
					$outputhtml .= " [<a href=$PHP_SELF?action=choose&id=".$mypoll["id"].">".picklang($polllang["choose"])."</a>]";
				}
				$outputhtml .= "</b> - ".(($mypoll["username"])? $mypoll["username"]: $reactorname)."</p>";

				$maxhits = 0;//to scale the most votes
				$mytotalhits = 0;
				for ($z = 0; $z < 10; $z++) {
					if ($mypoll["choice".$z."name"]) {
						$mychoicename = $mypoll["choice".$z."name"];	
						$mychoicehits = $mypoll["choice".$z."hits"];
						if ($mychoicehits > $maxhits) $maxhits = $mychoicehits;
						$mytotalhits += $mychoicehits;
						if (!$mychoice[$mychoicehits]){
							$mychoice[$mychoicehits] = $mychoicename;
						} else {
							$mychoice[$mychoicehits] .= " | ".$mychoicename;//for ties
						}
					} 
				}
				//draw a table with the results
				$outputhtml .= "<table width=98% align=center border=0 cellpadding=5 cellspacing=0 bgcolor=".$reactorcolor[2].">";

				//avoid dividing by zero
				if($maxhits == 0) $maxhits = 1;
				if($mytotalhits == 0) $mytotalhits = 1;

				//try and sort this array. this may be a very inefficient way to do it, cycling one by one.
				for ($c = $maxhits; $c > -1; $c--) {
					if ($mychoice[$c]) {
						if(strstr($mychoice[$c]," | ")) {
							$ties = explode(" | ",$mychoice[$c]);
							$numties = sizeof($ties);
							for ($b = 0; $b < $numties; $b++) {
								$outputhtml .= "<tr>";
								$outputhtml .= "<td align=right><p><b>".$ties[$b]."</b></p></td>";
								$outputhtml .= "<td align=left><p><img align=left src=$pollbar border=0 height=14 width=".floor($c*($barwidth/$maxhits))."><b>".floor($c*(100/$mytotalhits))."%</b> ($c)</p></td>";
								$outputhtml .= "</tr>\n";
							}
						} 
						else {
							$outputhtml .= "<tr>";
							$outputhtml .= "<td align=right><p><b>".$mychoice[$c]."</b></p></td>";
							$outputhtml .= "<td align=left><p><img align=left src=$pollbar border=0 height=14 width=".floor($c*($barwidth/$maxhits))."><b>".floor($c*(100/$mytotalhits))."%</b> ($c)</p></td>";
							$outputhtml .= "</tr>\n";
						}
					} 
				}
				$outputhtml .= "</table>\n";
				$outputhtml .= "<p align=center><b>$mytotalhits ".picklang($polllang["votes"])."</b>  &lt;".date($datestringshort, $mypoll["posted"])."&gt; ".picklang($polllang["until"])." &lt;".date($datestringshort, $mypoll["expired"])."&gt;</p>";
				$outputhtml .= display_comments($id);
			} else {
				showerror(picklang($polllang["err_no_id"]));
			}			
		}
return $outputhtml;
}

/*
* viewpolllist() - view a list of current/archived polls, number of votes, start
* and end dates.
*/
function viewpolllist($start, $showmax) {
global $thetimenow, $reactorcolor, $id, $errormessage, $pollstable, $PHP_SELF, $polllang, $reactorname, $datestringshort;

//set context
if (!$start) {$start = 0;}
$numrows = $showmax + 1;
$next = $start + $numrows;
$more = 1;
$prev = $start - $showmax;
	
	//query last $showmax polls (not sure about this * query)
	$sql = "SELECT *, UNIX_TIMESTAMP(began) AS posted, UNIX_TIMESTAMP(expires) as expired FROM $pollstable WHERE status = 1 ORDER BY expires DESC LIMIT $start, $numrows";
	if ($request = polls_query($sql, "r")) {
		$x = 1;
		$outputhtml .= "<table width=98% align=center border=0 cellpadding=5 cellspacing=0 >";
		for ($i = 0; $i < $showmax; $i++) {
			$mypoll = request_fetch_array($request);
			if ($mypoll["id"] == $id) continue;
			$x++;
			$mytotalhits = 0;
			if ($mypoll) {
				for ($z = 0; $z < 10; $z++) {
					$mytotalhits += $mypoll["choice".$z."hits"];
				}
				$outputhtml .= "<tr>";
				$outputhtml .= "<td ".((!($x % 2))? "bgcolor=".$reactorcolor[2] : "")."><p class=n><b><a href=$PHP_SELF?id=".$mypoll["id"].">".$mypoll["question"]."</a> ";
				if($thetimenow < $mypoll["expired"]) {
					$outputhtml .= "[<a href=$PHP_SELF?action=choose&id=".$mypoll["id"].">".picklang($polllang["choose"])."</a>]";
				}
				$outputhtml .= "</b> - ".(($mypoll["username"])? $mypoll["username"]: $reactorname)."</p>";
				$outputhtml .= "\n<ul>";
				$outputhtml .= "<p><b>".$mytotalhits." ".picklang($polllang["votes"])."</b>  &lt;".date($datestringshort, $mypoll["posted"])."&gt; ".picklang($polllang["until"])." &lt;".date($datestringshort, $mypoll["expired"])."&gt;</p>";
				$outputhtml .= "</ul>\n";
				$outputhtml .= "</td>";
				$outputhtml .= "</tr>\n";
			}
			else {
				$more = 0;
				break;
			}
		}
		//add prev and next links
		$outputhtml .= "<tr>";
		$outputhtml .= "<td><p align=center>";
		if ($prev > - 1) {
			$outputhtml .= "&lt;&lt; <a href=$PHP_SELF?action=viewold&start=$prev>".picklang($polllang["newer_polls"])."</a>&nbsp;&nbsp;&nbsp;";
		}
		else if ($start > 0) {
			$prev = 0;
			$outputhtml .= "&lt;&lt; <a href=$PHP_SELF?action=viewold&start=$prev>".picklang($polllang["newer_polls"])."</a>&nbsp;&nbsp;&nbsp;";
		}
		if ($more) {
			$mypoll = request_fetch_array($request);//check for next (11th) news.
			if ($mypoll) {
				$outputhtml .= "<a href=$PHP_SELF?action=viewold&start=".($next-1).">".picklang($polllang["older_polls"])."</a> &gt;&gt;";
			}
		}
		$outputhtml .= "</p></td>";
		$outputhtml .= "</tr>\n";
		$outputhtml .= "</table>\n";
	}
return $outputhtml;
}

function display_comments($pollid) {
        global $pollstable,$boardname,$polllang,$errormessage,$reactorcore, $commentsboard_url, $forumsboard_url;

	//get comment id of this board
        $fid=get_commentboard_id($boardname);
        $commenttable='commentstopics'.$fid;
        //now query all comments for this polls, indicated by id = $pollid
        $sql="SELECT A.subject,A.username,A.tid,UNIX_TIMESTAMP(A.created) as t_created  FROM $commenttable A, $pollstable B WHERE A.rid=B.commenttid AND B.id=$pollid";
	//echo $sql;
	if(!$request=polls_query($sql,"r")) {
                   echo $errormessage;
        }
        $first=request_fetch_array($request);
       	$outputhtml  = "<p class=n align=left>\n<b>".picklang($polllang["Comments"]).": </b><i>".$first["subject"]."</i> </p>\n";
        $outputhtml .= "<ul>\n";
        while($row=request_fetch_array($request)) {
        $outputhtml .= "<li><a href=$commentsboard_url/browse.php?fid=$fid&tid=".$row["tid"]."&mode=threaded >".$row["subject"]."</a>&nbsp;&nbsp;by : <a href=$commentsboard_url/browse.php?profile=".$row["username"].">".$row["username"]."</a>&nbsp;&nbsp;".date("M,d Y h:i",$row["t_created"])."</li>\n";
        }  
	$outputhtml .= "<br><br>\n[<a href=$commentsboard_url/post.php?fid=$fid&tid=".$first["tid"]." target=post onclick=w('post',400,435);><b>".picklang($polllang["post_comment"])."</b></a>]</p>\n";
        $outputhtml .= "</ul>\n";
	return $outputhtml;
	}

?>
