<?php
/*
* Copyright (C) 1999-2000 EKILAT LLC (http://ekilat.com - the first reactor)
* 
* php(REACTOR) is open source; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License <http://www.opensource.org/licenses/gpl-license.html>
* for a complete version of the license.
*
** lastposts.module.php
* this file queries the last posts from the database.
*
* ABOUT MODULES : modules are designed to be portable (useable anywhere,
* regardless of scope), and resuable (they can be called more than once in any
* script, thought this is not usually advantageous).  AS such, they follow
* a specific structure.  please follow it when building other modules.
*
* 1. set a CONSTANT which announces the loading of the module
* 2. put the majority of the module inside a function - this will help
*	 the scope of our variables to be portable - we don't know if this module 
*	 being called from within a function.
* 3. make sure you declare the globals necessary ...
* 
* REMEMBER, IF YOUR MODULES DEPEND ON /inc/ files or other includes, those
* files must be included in the calling script (the script called by the
* webserver).  Otherwise, the variables in the /inc/ files will not have
* global scope.
*/

//wrap the module function to prevent the redefinition  of functions
if(!defined("REACTOR_MODULE_LASTPOSTS")) {

// tell everyone we're already loaded
define("REACTOR_MODULE_LASTPOSTS", 1);

//check to make sure the appropriate /inc/ files are loaded
//note, we don't load them, we just check
if(!defined("REACTOR_INC_GLOBAL")) { $errormessage .= "module error: /inc/global.inc.php has not been loaded"; }
if(!defined("REACTOR_INC_LANG")) { $errormessage .= "module error: /inc/lang.inc.php has not been loaded"; }
if(!defined("REACTOR_INC_USERS")) { $errormessage .= "module error: /inc/users.inc.php has not been loaded"; }
if(!defined("REACTOR_INC_BBS")) { $errormessage .= "module error: /inc/bbs.inc.php has not been loaded"; }

 echo $errormessage;

function showlastposts($boardname="forums", $limitforums=3, $limitposts=1) {
global $timeadj, $reactorcore;
//DO GO-SIP FIRST!!
$lastposts = "";

$lastpostsintro = array("default" => "latest posts in $boardname", "english" => "latest posts in $boardname");

//nedded vars for go-sip and iklan
$forumlist = $boardname;
//select last 3 active forums
$sql = "SELECT fmname, fid FROM $forumlist WHERE status=1 ORDER BY modified DESC LIMIT ".$limitforums;
if ($request = forumquery($sql, "r")) {
  $lastposts .= "<b>".picklang($lastpostsintro).":</b><br>\n";
	while ($myforum = request_fetch_array($request)) {
		$ftable = $forumlist."topics".$myforum["fid"];
		$sql2 = "SELECT DISTINCT t.tid, t.subject FROM $ftable t, $ftable r WHERE t.tid=r.rid AND t.status=1 AND t.rank>0 ORDER BY t.modified DESC LIMIT ".$limitposts;
		if ($request2 = forumquery($sql2, "r")) {
			while ($mytopic = request_fetch_array($request2)) {
				$lastposts .= "<li> <a href=$reactorcore/$boardname/browse.php?fid=".$myforum["fid"].">".$myforum["fmname"]."</a> : <a href=$reactorcore/$boardname/browse.php?fid=".$myforum["fid"]."&tid=".$mytopic["tid"]."&go=".urlencode($mytopic["subject"]).">".$mytopic["subject"]."</a>\n";
			}
		}
	}
}

 return $lastposts;
}//end of module function definition

}//end of module function wrapper

$posts = showlastposts();
if ($posts) echo "<table border=0 cellspacing=0 cellpadding=0><tr><td>".$posts."</td></tr></table>";
?>
