<?php
/*
* Copyright (C) 1999-2000 EKILAT LLC (http://ekilat.com - the first reactor)
* 
* php(REACTOR) is open source; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License <http://www.opensource.org/licenses/gpl-license.html>
* for a complete version of the license.
*
** lastseen.module.php
* this file queries cards from the card database and
* prints it along with a link to the main cards page.
*
* ABOUT MODULES : modules are designed to be portable (useable anywhere,
* regardless of scope), and resuable (they can be called more than once in any
* script, thought this is not usually advantageous).  AS such, they follow
* a specific structure.  please follow it when building other modules.
*
* 1. set a CONSTANT which announces the loading of the module
* 2. put the majority of the module inside a function - this will help
*	 the scope of our variables to be portable - we don't know if this module 
*	 being called from within a function.
* 3. make sure you declare the globals necessary ...
* 
* REMEMBER, IF YOUR MODULES DEPEND ON /inc/ files or other includes, those
* files must be included in the calling script (the script called by the
* webserver).  Otherwise, the variables in the /inc/ files will not have
* global scope.
*/

//wrap the module function to prevent the redefinition  of functions
if(!defined("REACTOR_MODULE_LASTSEEN")) {

// tell everyone we're already loaded
define("REACTOR_MODULE_LASTSEEN", 1);

//check to make sure the appropriate /inc/ files are loaded
//note, we don't load them, we just check
if(!defined("REACTOR_INC_GLOBAL")) { $errormessage .= "module error: /inc/global.inc.php has not been loaded"; }
if(!defined("REACTOR_INC_LANG")) { $errormessage .= "module error: /inc/lang.inc.php has not been loaded"; }
if(!defined("REACTOR_INC_USERS")) { $errormessage .= "module error: /inc/users.inc.php has not been loaded"; }

function showlastseen($limit=10) {
global $timeadj, $reactorcore;
$userstable = "users";
$lastseen = array("default" => "last seen", "english" => "last seen");
	
	$sql = "SELECT username, UNIX_TIMESTAMP(modified) as lastseen FROM $userstable WHERE status=1 ORDER BY modified DESC LIMIT $limit";
	if ($request = users_query($sql, "r")) {
		$output = date("H:i", time() + $timeadj)." <b>".picklang($lastseen).":</b><br>\n";
		while($myuser = request_fetch_array($request)) {
			$output .= date("H:i", $myuser["lastseen"] + $timeadj)." <a class=k href=".$reactorcore."/forums/browse.php?profile=".$myuser["username"].">".$myuser["username"]."</a>";
			$output .= "<br>\n";
		}
		return $output;
	}
}//end of module function definition

}//end of module function wrapper

$who = showlastseen(10);
if ($who) echo "<table border=0 cellspacing=0 cellpadding=0><tr><td>".$who."</td></tr></table>";
?>
