<?php
/*
* Copyright (C) 1999-2000 EKILAT LLC (http://ekilat.com - the first reactor)
* 
* php(REACTOR) is open source; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License <http://www.opensource.org/licenses/gpl-license.html>
* for a complete version of the license.
*
** ./modules/poll_in_forum.module.php
* this module displays options to attach a poll to a forum
*
* ABOUT MODULES : modules are designed to be portable (useable anywhere,
* regardless of scope), and resuable (they can be called more than once in any
* script, thought this is not usually advantageous).  AS such, they follow
* a specific structure.  please follow it when building other modules.
*
* 1. set a CONSTANT which announces the loading of the module
* 2. put the majority of the module inside a function - this will help
*	 the scope of our variables to be portable - we don't know if this module 
*	 being called from within a function.
* 3. make sure you declare the globals necessary ...
* 
* REMEMBER, IF YOUR MODULES DEPEND ON /inc/ files or other includes, those
* files must be included in the calling script (the script called by the
* webserver).  Otherwise, the variables in the /inc/ files will not have
* global scope.
*/


//wrap the module function to prevent the redefinition  of functions
if(!defined("REACTOR_MODULE_POLL_IN_FORUM")) {

// tell everyone we're already loaded
define("REACTOR_MODULE_POLL_IN_FORUM", 1);

//check to make sure the appropriate /inc/ files are loaded
//note, we don't load them, we just check
if(!defined("REACTOR_INC_GLOBAL")) { $errormessage .= "module error: /inc/global.inc.php has not been loaded"; }
if(!defined("REACTOR_INC_LANG")) { $errormessage .= "module error: /inc/lang.inc.php has not been loaded"; }
if(!defined("REACTOR_INC_POLLS")) { $errormessage .= "module error: /inc/polls.inc.php has not been loaded"; }

function poll_in_forum() {
//declare global variables for anything you want to change or use
global $pollstable, $pollsboard, $boardname, $fid, $reactorcore;

//YOU MUST DEFINE THE FOLLOWING
//WHAT TABLE ARE YOUR POLLS LOCATED IN?
$pollstable = "polls";

//WHAT DIRECTORY ARE YOUR POLLS LOCATED IN?
$pollsboard = "polls";//no slashes /

//SET language values
$mylang = array(
"post_poll" => array("default" => "post a poll", "english" => "post a poll"),
"polls" => array("default" => "polls", "english" => "polls")
);
	
	$newpoll = showonepoll($boardname, $fid);
	if ($newpoll) {
		$outputhtml .= $newpoll;	
	}
	else {
		$outputhtml .= "<p align=left>&nbsp;<b>[<a href=$reactorcore/$pollsboard/post.php?fromboard=$boardname&boardid=$fid ".jpopclick("pollpost",400,434).">".picklang($mylang["post_poll"])."</a>]</b> [<a href=$reactorcore/$pollsboard/>".picklang($mylang["polls"])."</a>]</p>";
	}
	
return $outputhtml;
}//end of module function definition

}//end of module function wrapper

//send to the client
$poll_in_forum = poll_in_forum();
if($poll_in_forum) echo $poll_in_forum;
else echo $errormessage;
?>